<?php

/*======================================================================*\
// This code is provided free on the basis that you do not claim that
// it is your own, sell it or use it as the basis for other products that you
// sell. But by all means extend it, modify it, upgrade it, correct it,
// suggest improvements, call me an idiot, etc.
//
// (c) 2004/10
// Andrew Dearing
// European Industrial Research Management Association
// www.eirma.org
//
// v3.0.0, 01.01.2010
// For VB4.0.x
// see changes.txt for history
// v1.00, 1.3.2004
//
\*======================================================================*/

error_reporting(E_ALL & ~E_NOTICE & ~8192);

define('THIS_SCRIPT',  'local_links_spider');

// get special phrase groups
$phrasegroups = array(
	'local_links',
);

// pre-cache all templates used by this hack
$globaltemplates = array(
	'links_catjump',
	'links_catsortbit',
	'links_footer',
	'links_header',
	'links_navbar',
	'links_navbar_popups',
	'links_search_catselect',
	'links_spiderbit',
);

// get special data templates from the datastore
$specialtemplates = array(
	'attachmentcache',
	'ldm_admin',
	'ldm_cats',
);

// pre-cache templates used by specific actions
$actiontemplates = array(
);

// fire up VBulletin backend
require_once('./global.php');

require_once(DIR . '/includes/local_links_init.php');
require_once(DIR . '/includes/local_links_include.php');
require_once(DIR . '/includes/local_links_misc.php');

$SPIDER_SCRIPT = THIS_SCRIPT;

$vbulletin->input->clean_array_gpc('r', array(
	'action'	=> TYPE_STR,
	'pp'		=> TYPE_INT,
	'page'		=> TYPE_INT,
	));

$this_action = ($vbulletin->GPC_exists['action'] ? $vbulletin->GPC['action'] : "spider");

if ($vbulletin->GPC_exists['pp']) {
	$perpage = $vbulletin->GPC['pp'];
}
else {
	$perpage = $vbulletin->userinfo['maxposts'];
	$checkmax = explode(',', $vbulletin->options['usermaxposts'] . ',' . $vbulletin->options['maxposts']);
	if ($perpage < 1 OR $perpage > max($checkmax)) {
		$perpage = $vbulletin->options['maxposts'];
	}
	$perpage = ($links_defaults['links_per_page']!=0 ? $links_defaults['links_per_page'] : $perpage);
}

$pagenumber = ($vbulletin->GPC_exists['page'] ? $vbulletin->GPC['page'] : 1);
$master_title = htmlspecialchars_uni(($links_defaults['database_name'] ? $links_defaults['database_name'] : $vbphrase['ll_links_database']));

function ldm_spiderme($url) {

	$urlInfo = ldm_parse_url($url);
	$sites = array();
	$contents = ldm_fetch_page($url);
	preg_match_all("#<a.*? href=\"([^\"]+)\"[^>]*>([^<]*)</a>#", $contents, $matches);

	foreach ($matches[1] as $k=>$m) {
		if ($m{0}=="#") {
			continue;
		}
		elseif ($m{0}=="/") {
			$sites[] = array("url"=>$urlInfo['scheme'].'://'.$urlInfo['host'].$m, "link"=>$matches[2][$k]);
		}
		else {
			$sites[] = array("url"=>$m , "link"=>$matches[2][$k]);
		}
	}

	return $sites;
}

if ($this_action == "spider") {

	$this_navigation_title = $master_title;

	$vbulletin->input->clean_array_gpc('r', array(
		'linkid'	=> TYPE_INT,
		'catid'		=> TYPE_INT,
		));

	if ($links_defaults['category_jump_menu'] and count($linkscat)) {
		$catjumpbit = ldm_construct_category_list(array(0), "links_catjump", 0, "catid", "catid", 1);
	}

	$viewcatid = -2;
	$links_permissions["can_add_link"] = 0;
	$links_permissions["can_add_category"] = 0;
	$links_permissions["can_edit_category"] = 0;

	$linkid = $vbulletin->GPC['linkid'];
	$catid = $vbulletin->GPC['catid'];

	$sites = array();
	cache_LDMicons();

	if ($linkid) {
		$row = $vbulletin->db->query_first("
			SELECT link.linkname AS linkname, link.linkurl AS linkurl
			FROM ".THIS_TABLE."linkslink AS link
			WHERE link.linkid='".$linkid."'
			LIMIT 1
			");
		$linkurl = $row['linkurl'];
		$linkname = $row['linkname'];
		if ($linkurl) {
			$sites = ldm_spiderme($linkurl);
		}
	}

	$navbits = array();
	$navbits[$LINKS_SCRIPT.'.php'.$vbulletin->session->vars['sessionurl_q']] = $master_title;
	$this_navigation_title = ldm_kill_bbcodes($vbphrase['ll_search'].' '.$master_title);
	$navbits[$LINKS_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."catid=$catid"] = $linkscat["$catid"]["catname_clean"];
	$navbits[] = $vbphrase['ll_spidering'].' '.$linkname;

//	construct_forum_jump();
    $navpopup = array(
    	'id'    => 'ldmdisplay_navpopup',
        'title' => $LDM_catinfo['viewcatname'],
        'link'  => $LINKS_SCRIPT . '.php?' . $vbulletin->session->vars['sessionurl'] . 'catid=' . $viewcatid,
    );
    construct_quick_nav($navpopup);

    ldm_fetch_navbar_template($viewcatid);

	$show['notices'] = 0;
	$navbits = construct_navbits($navbits);
    $navbar = render_navbar_template($navbits);

    $templater = vB_Template::create('links_header');
    $templater->register_page_templates();
    $templater->quickRegister(array(
        'ldm_header_include'=>$ldm_header_include, 'ldm_headtag_include'=>$ldm_headtag_include,
        'LDM_scripts'=>$LDM_scripts, 'links_defaults'=>$links_defaults,
        'navbar'=>$navbar, 'this_navigation_title'=>$this_navigation_title
        ));
    $output = $templater->render();

	$istart = ($pagenumber-1)*$perpage;
	$ifin = $istart+$perpage;

	$pagenav = construct_page_nav($pagenumber, $perpage, count($sites), $SPIDER_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."catid=".$catid."&amp;linkid=".$linkid, "&amp;pp=$perpage");

    $templater = vB_Template::create('links_spiderbit');
    $templater->quickRegister(array(
        'linkid'=>$linkid,
        'linkname'=>$linkname,
        'pagenav'=>$pagenav,
        'stage'=>1,
        'LDM_scripts'=>$LDM_scripts,
        ));
    $output .= $templater->render();

	$k = -1;
	foreach ($sites as $thissite) {

		$k++;
		if ($k>=$ifin) {
			break;
		}
		elseif ($k<$istart) {
			continue;
		}

		$thisurl = $thissite['url'];
		if (strlen($thisurl)>32) {
			$thisurl_short = substr($thisurl, 0, 72).'...';
		}
		else {
			$thisurl_short = $thisurl;
		}

        $templater = vB_Template::create('links_spiderbit');
        $templater->quickRegister(array(
            'SPIDER_SCRIPT'=>$SPIDER_SCRIPT,
            'catid'=>$catid,
            'linkid'=>$linkid,
            'spidericon'=>$ldm_icon_cache['spider'],
            'thissite'=>$thissite,
            'thisurl_short'=>$thisurl_short,
            'stage'=>2,
            'LDM_scripts'=>$LDM_scripts,
                ));
        $output .= $templater->render();

	}

    $templater = vB_Template::create('links_spiderbit');
    $templater->quickRegister(array(
            'SPIDER_SCRIPT'=>$SPIDER_SCRIPT,
            'catid'=>$catid,
            'linkid'=>$linkid,
            'spidericon'=>$ldm_icon_cache['spider'],
            'thissite'=>$thissite,
            'thisurl_short'=>$thisurl_short,
            'stage'=>3,
            'LDM_scripts'=>$LDM_scripts,
                ));
    $output .= $templater->render();

    $templater = vB_Template::create('links_footer');
    $templater->register_page_templates();
    $templater->quickRegister(array(
        'catjumpbit'=>$catjumpbit, 'forumjump'=>$forumjump,
        'LDM_scripts'=>$LDM_scripts, 'ldm_footer_include'=>$ldm_footer_include
        ));
    $output .= $templater->render();

	print_output($output);
	exit;
}

?>