<?php

/* ===========================================================================*/
//
// This code is provided free on the basis that you do not claim that
// it is your own, sell it or use it as the basis for other products that you
// sell. But by all means extend it, modify it, upgrade it, correct it,
// suggest improvements, call me an idiot, etc.
//
// (c) 2004/10
// Andrew Dearing
// European Industrial Research Management Association
// www.eirma.org
//
// v3.0.0, 01.01.2010
// For VB4.0.x
// see changes.txt for history
// v1.00, 1.3.2004
//
/* ===========================================================================*/

if (!isset($links_permissions["can_admin_links"]) or !$links_permissions["can_admin_links"]) {
	print_no_permission();
	exit;
}

if (!$links_permissions['is_vbsuperadmin']) {
	print_no_permission();
	exit;
}

/* ===========================================================================*/
// XML Export
/* ===========================================================================*/

if ($this_action == "doadmin" and isset($_REQUEST['doexportxml'])) {

	$cpumax = ini_get('max_execution_time');
	if ($cpumax and $cpumax<$ADMIN_IMPEXP) {
		@ini_set('max_execution_time', min(ini_get('max_execution_time'), $ADMIN_IMPEXP));
	}
	@ini_set('memory_limit', -1);


	function ldm_impexp_patchme(&$arr) {
		global $vbulletin;

		$search = array ("\r", "\n");
		$replace = array ("\\r", "\\n");
		$arr = str_replace($search, $replace, $arr);
		foreach ($arr as $k=>$v) {
			$arr[$k] = htmlspecialchars_uni($v);
		}
	}

	$vbulletin->input->clean_array_gpc('r', array(
		'xmlexp' => TYPE_INT,
		'xmlgzip' => TYPE_INT,
	));

	if ($vbulletin->GPC['xmlexp']==1) {
// Standard LDM format

		require_once(DIR . '/includes/class_xml.php');

		$xml = new XMLexporter($vbulletin);

		$xml->add_group('LDM', array('name' => $master_title, 'version' => $links_defaults["this_version"],
			'date' => ldm_date($vbulletin->options['dateformat'], TIMENOW).' '.ldm_date($vbulletin->options['timeformat'], TIMENOW)));

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linksadmin
			");

		$xml->add_group('admin', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('admin', $myrow['adminid'], $myrow, true);
		}
		$xml->close_group();

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linkscat
			ORDER BY catid
			");

		$xml->add_group('categories', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('category', $myrow['catid'], $myrow, true);
		}
		$xml->close_group();

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linkslink
			ORDER BY linkid
			");

		$xml->add_group('links', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('link', $myrow['linkid'], $myrow, true);
		}
		$xml->close_group();

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linksltoc
			ORDER BY ltoc
			");

		$xml->add_group('linkcats', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('ltoc', $myrow['ltoc'], $myrow, true);
		}
		$xml->close_group();

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linkskeys
			ORDER BY keyid
			");

		$xml->add_group('keywords', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('keyword', $myrow['keyid'], $myrow, true);
		}
		$xml->close_group();

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linksltok
			ORDER BY lkey
			");

		$xml->add_group('linkkeys', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('ltok', $myrow['lkey'], $myrow, true);
		}
		$xml->close_group();

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linksentities
			ORDER BY entityid
			");

		$xml->add_group('entities', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('entity', $myrow['entityid'], $myrow, true);
		}
		$xml->close_group();

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linksfavs
			ORDER BY lfav
			");

		$xml->add_group('favourites', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('fav', $myrow['lfav'], $myrow, true);
		}
		$xml->close_group();

		$asb = $vbulletin->db->query_read("
			SELECT *
			FROM ".THIS_TABLE."linksrate
			ORDER BY lrate
			");

		$xml->add_group('ratings', array());
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			ldm_impexp_patchme($myrow);
			$xml->add_tag('rate', $myrow['lrate'], $myrow, true);
		}
		$xml->close_group();

		$xml->close_group();

		$doc = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n\n";

        if ($entities = @file_get_contents(DIR . '/includes/xml/entities_ldm.xml')) {
            $doc .= $entities;
            $doc .= "\n\n";
        }

		$doc .= $xml->output();
		$xml = null;

		require_once(DIR . '/includes/functions_file.php');
		if ($vbulletin->GPC['xmlgzip']) {
			file_download(gzencode($doc), 'export.xml.gz', 'application/x-gzip');
		}
		else {
			file_download($doc, 'export.xml', 'text/xml');
		}
		exit;

	}

	if ($vbulletin->GPC['xmlexp']==2) {
// Google Sitemap format

		$asb = $vbulletin->db->query_read("
			SELECT catid, catdate
			FROM ".THIS_TABLE."linkscat
			");

		$doc  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n\r\n";
		$doc .= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\r\n";
		while ($myrow = $vbulletin->db->fetch_array($asb)) {
			$doc .= "<url>\r\n";
			$doc .= "<loc>".$vbulletin->options['bburl']."/".$LINKS_SCRIPT.".php?catid=".$myrow['catid']."</loc>\r\n";
			$doc .= "<lastmod>".date("Y-m-d", $myrow['catdate'])."</lastmod>\r\n";
			$doc .= "</url>\r\n";
		}
		$doc .= "</urlset>";

		require_once(DIR . '/includes/functions_file.php');
		if ($vbulletin->GPC['xmlgzip']) {
			file_download(gzencode($doc), 'sitemap.xml.gz', 'application/x-gzip');
		}
		else {
			file_download($doc, 'sitemap.xml', 'text/xml');
		}
		exit;

	}


}

/* ===========================================================================*/
// XML Import
/* ===========================================================================*/

if ($this_action == "doadmin" and isset($_REQUEST['doimportxml'])) {

	$cpumax = ini_get('max_execution_time');
	if ($cpumax and $cpumax<$ADMIN_IMPEXP) {
		@ini_set('max_execution_time', min(ini_get('max_execution_time'), $ADMIN_IMPEXP));
	}
	@ini_set('memory_limit', -1);

	$vbulletin->url = $ADMIN_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."set=importexport";

	require_once(DIR . '/includes/adminfunctions.php');
	require_once(DIR . '/includes/class_xml.php');

if (function_exists('mb_convert_encoding')) {
	class LDM_XMLparser extends vB_XML_Parser {

	function handle_element_start(&$parser, $name, $attribs) {
		$this->cdata = '';

		foreach ($attribs AS $key => $val) {
			$attribs["$key"] = mb_convert_encoding($val, 'HTML-ENTITIES', 'UTF-8');
		}

		array_unshift($this->stack, array('name' => $name, 'attribs' => $attribs, 'tag_count' => ++$this->tag_count));
	}

	function &parse($encoding = 'ISO-8859-1', $emptydata = true) {
		if (empty($this->xmldata) OR $this->error_no > 0) {
			return false;
		}

		if (!($this->xml_parser = xml_parser_create($encoding))) {
			return false;
		}

		xml_parser_set_option($this->xml_parser, XML_OPTION_SKIP_WHITE, 0);
		xml_parser_set_option($this->xml_parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parser_set_option($this->xml_parser, XML_OPTION_TARGET_ENCODING, 'UTF-8');

		xml_set_character_data_handler($this->xml_parser, array(&$this, 'handle_cdata'));
		xml_set_element_handler($this->xml_parser, array(&$this, 'handle_element_start'), array(&$this, 'handle_element_end'));

		xml_parse($this->xml_parser, $this->xmldata);
		$err = xml_get_error_code($this->xml_parser);

		if ($emptydata) {
			$this->xmldata = '';
			$this->stack = array();
			$this->cdata = '';
		}

		if ($err) {
			$this->error_code = @xml_get_error_code($this->xml_parser);
			$this->error_line = @xml_get_current_line_number($this->xml_parser);
			xml_parser_free($this->xml_parser);
			return false;
		}

		xml_parser_free($this->xml_parser);

		return $this->parseddata;
	}

	}
}
else {
	class LDM_XMLparser extends vB_XML_Parser {
	}
}

	function ldm_impexp_import_row($table, &$row, $indexfield, $columns=0) {
		global $vbulletin;

		$search = array ("\r", "\n");
		$replace = array ("\\r", "\\n");

		$myrow = $row;
		$myrow = str_replace($replace, $search, $myrow);

		$tags = array();
		$values = array();
		foreach ($myrow as $tag=>$element) {
			if ($tag=='value') continue;
			if ($tag==$indexfield) continue;
			if (is_array($columns)) {
				if (!in_array($tag,$columns)) {
					continue;
				}
			}
			$tags[] = $tag;
			$values[] = $vbulletin->db->escape_string($element);
		}
		if (count($tags)) {
			$query = 'INSERT INTO '.THIS_TABLE.$table.
					' ('.implode(', ',$tags).') '.
					'VALUES ("'.implode('", "',$values).'")';
			$vbulletin->db->query_write($query);
			$row['value'] = $vbulletin->db->insert_id();
		}
	}

	function ldm_impexp_update_row($table, $rowid, $rowval, $fields) {
		global $vbulletin;

		$search = array ("\r", "\n");
       	$replace = array ("\\r", "\\n");
		$values = array();

		foreach ($fields as $tag=>$element) {
    		$element = str_replace($replace, $search, $element);
			$tags[] = $tag.'="'.$vbulletin->db->escape_string($element).'"';
		}
		if (count($tags)) {
			$query = 'UPDATE '.THIS_TABLE.$table.
					' SET '.implode(', ',$tags).
					' WHERE '.$rowid.'="'.$vbulletin->db->escape_string($rowval).'"';
			$vbulletin->db->query_write($query);
		}
	}

	function ldm_impexp_fix_table(&$arr) {
		if (array_key_exists('value', $arr)) { // one row only
			$temparray = array();
			foreach ($arr as $l=>$v) {
				$temparray[$l] = $v;
				unset($arr[$l]);
			}
			$arr[0] = $temparray;
		}
	}

	function ldm_impexp_import_table(&$arr, $table, $indexfield, $columns=0) {
		$nrec = 0;
		foreach ($arr as $l=>$t2) {
			ldm_impexp_import_row($table, $arr[$l], $indexfield, $columns);
			$nrec+=1;
		}
		return $nrec;
	}

	$vbulletin->input->clean_array_gpc('r', array(
		'xmlinit' => TYPE_INT,
		'xmlappend' => TYPE_INT,
	));

	$vbulletin->input->clean_array_gpc('f', array(
		'xmlimport' => TYPE_FILE,
	));

	require_once(DIR . '/includes/local_links_admininclude.php');

// Require valid import
	if (!$vbulletin->GPC['xmlimport']['name'] or !$vbulletin->GPC['xmlimport']['tmp_name']
		or !$vbulletin->GPC['xmlimport']['size']
		or !is_uploaded_file($vbulletin->GPC['xmlimport']['tmp_name'])) {
		$err = $vbphrase['ll_error_importxml_read'].' <a href="'.$vbulletin->url.'"><b>'.$vbphrase['ll_return'].'</b></a>';
		eval(standard_error($err));
		exit;
	}

	$fp = @gzopen($vbulletin->GPC['xmlimport']['tmp_name'], "rb");
	$xml = '';
	while (!@feof($fp)) {
		$xml .= @fread($fp, 8192);
	}
	@fclose($fp);

	if (!$xml) {
		$err = construct_phrase($vbphrase['ll_error_importxml_interpret'],$vbulletin->GPC['xmlimport']['name']).' <a href="'.$vbulletin->url.'"><b>'.$vbphrase['ll_return'].'</b></a>';
		eval(standard_error($err));
		exit;
	}


	$xmlobj = new LDM_XMLparser($xml);
	if ($xmlobj->error_no == 1 or $xmlobj->error_no == 2) {
		$err = construct_phrase($vbphrase['ll_error_importxml_createparser'],$vbulletin->GPC['xmlimport']['name']).' <a href="'.$vbulletin->url.'"><b>'.$vbphrase['ll_return'].'</b></a>';
		eval(standard_error($err));
		exit;
	}

	if (!$arr =& $xmlobj->parse()) {
        $errcode = $xmlobj->error_code;
		$err = construct_phrase($vbphrase['ll_error_importxml_doparser'], $xmlobj->error_line(), $vbulletin->GPC['xmlimport']['name'], $errcode, xml_error_string($errcode)).' <a href="'.$vbulletin->url.'"><b>'.$vbphrase['ll_return'].'</b></a>';
		eval(standard_error($err));
		exit;
	}

// Check that import file is compatible with current table structure
	$mismatches = array();

// This mapping should have been unnecessary, except that at some point we changed the naming convention...
	$tables = array(
		'admin' => THIS_TABLE."linksadmin",
		'categories' => THIS_TABLE."linkscat",
		'links' => THIS_TABLE."linkslink",
		'linkcats' => THIS_TABLE."linksltoc",
		'keywords' => THIS_TABLE."linkskeys",
		'linkkeys' => THIS_TABLE."linksltok",
		'entities' => THIS_TABLE."linksentities",
		'ratings' => THIS_TABLE."linksrate",
		'favourites' => THIS_TABLE."linksfavs",
		'downloads' => THIS_TABLE."linksdownloads",
		);


	$arecats = 0;
	if (array_key_exists('categories', $arr)) {
		if (is_array($arr['categories'])) {
			if (array_key_exists('category', $arr['categories'])) {
				if (count($arr['categories']['category'])) {
					$arecats = 1;
				}
			}
		}
	}

	if (!$arecats) {
		$kcat = $klink = 0;
		eval(print_standard_redirect(construct_phrase($vbphrase['ll_xmlimport_complete'],$kcat,$klink),0));
		exit;
	}

	foreach ($tables as $thisimport=>$thistable) {
		$tablecols[$thisimport] = array_keys(fetch_LDMtable_columns($thistable));
	}

	switch ($vbulletin->GPC['xmlappend']) {
	case 0:
		ldm_admin_clearfromtable('linksadmin', 'catid>0');
		ldm_admin_clearfromtable('linkscat');
		ldm_admin_clearfromtable('linkslink');
		ldm_admin_clearfromtable('linksltoc');
		ldm_admin_clearfromtable('linkskeys');
		ldm_admin_clearfromtable('linksltok');
		ldm_admin_clearfromtable('linksentities');
		ldm_admin_clearfromtable('linksfavs');
		ldm_admin_clearfromtable('linksrate');
		ldm_admin_clearfromtable('linksdownloads');
		break;
    default:
        break;
	}

	switch ($vbulletin->GPC['xmlappend']) {
	case 0:
	case 1:
    	$categories =& $arr['categories']['category'];
	    ldm_impexp_fix_table($categories);
	    $kcat = ldm_impexp_import_table($categories, 'linkscat', 'catid', $tablecols['categories']);

    	$catid_map = array();
	    foreach ($categories as $l=>$t1) {
		    $catid_map[$categories[$l]['catid']] = $categories[$l]['value'];
	    }
	    foreach ($categories as $l=>$t1) {
		    if ($categories[$l]['parentid']>0) {
			    $categories[$l]['parentid'] = $catid_map[$categories[$l]['parentid']];
			    $parents = explode(',', $categories[$l]['parentlist']);
			    foreach ($parents as $m=>$t2) {
		    		if ($parents[$m]>0) {
			    		$parents[$m] = $catid_map[$parents[$m]];
				    }
			    }
			    $categories[$l]['parentlist'] = implode(',', $parents);
			    ldm_impexp_update_row('linkscat', 'catid', $categories[$l]['value'], array('parentid'=>$categories[$l]['parentid'], 'parentlist'=>$categories[$l]['parentlist']));
		    }
	    }

	    $linkid_map = array();
	    $klink = 0;

	    if (array_key_exists('links', $arr)) {
		    if (is_array($arr['links'])) {
			    if (array_key_exists('link', $arr['links'])) {
				    $links =& $arr['links']['link'];
				    ldm_impexp_fix_table($links);
				    foreach ($links as $k=>$t1) {
					    $links[$k]['totrate'] = $links[$k]['numrate'] = $links[$k]['numcomment'] = 0;
				    }
				    $klink = ldm_impexp_import_table($links, 'linkslink', 'linkid', $tablecols['links']);

    				foreach ($links as $l=>$t1) {
	    				$linkid_map[$links[$l]['linkid']] = $links[$l]['value'];
		    		}
			    }
		    }
	    }

    	if (array_key_exists('linkcats', $arr)) {
	    	if (is_array($arr['linkcats'])) {
		    	if (array_key_exists('ltoc', $arr['linkcats'])) {
			    	$ltocs =& $arr['linkcats']['ltoc'];
				    ldm_impexp_fix_table($ltocs);
				    foreach ($ltocs as $l=>$t1) {
					    $ltocs[$l]['linkid'] = $linkid_map[$ltocs[$l]['linkid']];
					    $ltocs[$l]['catid']  = $catid_map[$ltocs[$l]['catid']];
				    }
				    $kltoc = ldm_impexp_import_table($ltocs, 'linksltoc', 'ltoc', $tablecols['linkcats']);
			    }
		    }
	    }

	    $keyids = array();
	    if (array_key_exists('keywords', $arr)) {
		    if (is_array($arr['keywords'])) {
			    if (array_key_exists('keyword', $arr['keywords'])) {
				    $keywords =& $arr['keywords']['keyword'];
				    ldm_impexp_fix_table($keywords);
				    $keyword_list = array();
				    foreach ($keywords as $v) {
					    $keyword_list[] = $v['keyword'];
				    }
				    $keyid_map = ldm_lookup_keywords($keyword_list);
			    }
		    }
	    }

	    if (array_key_exists('linkkeys', $arr)) {
		    if (is_array($arr['linkkeys'])) {
			    if (array_key_exists('ltok', $arr['linkkeys'])) {
				    $ltoks =& $arr['linkkeys']['ltok'];
				    ldm_impexp_fix_table($ltoks);
				    foreach ($ltoks as $l=>$t1) {
					    $ltoks[$l]['linkid'] = $linkid_map[$ltoks[$l]['linkid']];
					    $ltoks[$l]['keyid']  = $keyid_map[$ltoks[$l]['keyid']-1];
				    }
    				$kltok = ldm_impexp_import_table($ltoks, 'linksltok', 'lkey', $tablecols['linkkeys']);
	    		}
		    }
	    }

    	if (array_key_exists('entities', $arr)) {
	    	if (is_array($arr['entities'])) {
		    	if (array_key_exists('entity', $arr['entities'])) {
			    	$entities =& $arr['entities']['entity'];
				    ldm_impexp_fix_table($entities);
				    foreach ($entities as $l=>$t1) {
					    $entities[$l]['linkid'] = $linkid_map[$entities[$l]['linkid']];
				    }
				    $kents = ldm_impexp_import_table($entities, 'linksentities', 'entityid', $tablecols['entities']);
				    $entity_definitions = unserialize($ldm_master_settings['entity_definitions'][-1]['setting']);

    				require_once(DIR . '/includes/local_links_entities.php');
	    			ldm_check_entity_consistency($entities, $entity_definitions);

		    	}
		    }
	    }


    	if ($vbulletin->GPC['xmlinit']>=1 and array_key_exists('admin', $arr)) {
	    	if (is_array($arr['admin'])) {
		    	if (array_key_exists('admin', $arr['admin'])) {
			    	$admin =& $arr['admin']['admin'];
				    ldm_impexp_fix_table($admin);

    				switch ($vbulletin->GPC['xmlinit']) {
	    			case 1:
// Apply imported settings as overrides for imported data only
    					foreach ($admin as $l=>$t1) {
	    					if ($admin[$l]['catid']>0) {
		    					$admin[$l]['catid'] = $catid_map[$admin[$l]['catid']];
			    				ldm_impexp_import_row('linksadmin', $admin[$l], 'adminid', $tablecols['admin']);
				    		}
					    }
    					break;

	    			case 2:
// Apply imported settings everywhere
// First, reinitialise the table in case there are mismatches between imported data and current structure
		    			ldm_admin_clearfromtable('linksadmin');
			    		init_LDMadmintable();

				    	foreach ($admin as $l=>$t1) {
					    	if ($admin[$l]['catid']>0) {
						    	$admin[$l]['catid'] = $catid_map[$admin[$l]['catid']];
							    ldm_impexp_import_row('linksadmin', $admin[$l], 'adminid', $tablecols['admin']);
						    }
						    else {
							    $query = 'UPDATE '.THIS_TABLE.'linksadmin'.
								    	' SET setting="'.$vbulletin->db->escape_string($admin[$l]['setting']).'"'.
									    ' WHERE settingname="'.$admin[$l]['settingname'].'"'.
									    ' AND catid<0';
							    $vbulletin->db->query_write($query);
						    }
					    }
    					record_LDM_version(THIS_VERSION, 1);

	    			}
		    	}
		    }
	    }

// Ensure we have a clean category structure
		ldm_fix_cat_parentlist();
        ldm_fix_cat_count();

    	ldm_datastore_markdirty('ldm_admin');
	    ldm_datastore_markdirty('ldm_cats');

	    break;

	case 2: // Update names/descriptions of existing entries based on url

        $kcat = $klink = 0;
	    if (array_key_exists('links', $arr)) {
		    if (is_array($arr['links'])) {
			    if (array_key_exists('link', $arr['links'])) {
				    $links =& $arr['links']['link'];
				    ldm_impexp_fix_table($links);
				    foreach ($links as $k=>$t1) {
            		    ldm_impexp_update_row('linkslink', 'linkurl', $links[$k]['linkurl'],
            		        array('linkname'=>$links[$k]['linkname'], 'linkdesc'=>$links[$k]['linkdesc']));
                        $klink++;
				    }
			    }
		    }
	    }

	    break;

	default:
        $kcat = $klink = 0;
	    break;
	}

    require_once(DIR . '/includes/local_links_bitcache.php');
    ldm_clear_bitcache();

    eval(print_standard_redirect(construct_phrase($vbphrase['ll_xmlimport_complete'],$kcat,$klink),0));

	exit;

}

?>