<?php

/* ===========================================================================*/
//
// This code is provided free on the basis that you do not claim that
// it is your own, sell it or use it as the basis for other products that you
// sell. But by all means extend it, modify it, upgrade it, correct it,
// suggest improvements, call me an idiot, etc.
//
// (c) 2004/10
// Andrew Dearing
// European Industrial Research Management Association
// www.eirma.org
//
// v3.0.0, 01.01.2010
// For VB4.0.x
// see changes.txt for history
// v1.00, 1.3.2004
//
/* ===========================================================================*/

if ($this_action == "links") {

	($hook = vBulletinHook::fetch_hook('ldm_maindisplay_begin')) ? eval($hook) : false;

	$can_bypass = $links_permissions['can_see_protected_links_on_portal'] | $links_permissions['can_bypass_forumperms'];
	$limitfids = ldm_lookup_forum_protections($can_bypass);
	$vbulletin->input->clean_array_gpc('r', array(
		'catid'	=> TYPE_INT,
		'doi' => TYPE_STR,
		'filter' => TYPE_STR,
		'keyid' => TYPE_INT,
		'linkid' => TYPE_INT,
		'ratings' => TYPE_INT,
		'resync' => TYPE_INT,
		'sort'	=> TYPE_STR,
		));

    $LDM_scripts['THIS_SCRIPT'] =
        $LDM_scripts['LINKS_SCRIPT'] . '.php?' .
        ($vbulletin->GPC['catid']   ? 'catid=' . $vbulletin->GPC['catid'] : '') .
        ($vbulletin->GPC['doi']     ? 'doi=' . $vbulletin->GPC['doi'] : '') .
        ($vbulletin->GPC['filter']  ? 'filter=' . $vbulletin->GPC['filter'] : '') .
        ($vbulletin->GPC['keyid']   ? 'keyid=' . $vbulletin->GPC['keyid'] : '') .
        ($vbulletin->GPC['linkid']  ? 'linkid=' . $vbulletin->GPC['linkid'] : '') .
        ($vbulletin->GPC['ratings'] ? 'ratings=' . $vbulletin->GPC['ratings'] : '') .
        ($vbulletin->GPC['resync']  ? 'resync=' . $vbulletin->GPC['resync'] : '') .
        ($vbulletin->GPC['sort']    ? 'sort=' . $vbulletin->GPC['sort'] : '');

	$LDM_catinfo = array();

	if ($vbulletin->GPC['linkid']) {
		$viewlinkid = $vbulletin->GPC['linkid'];
		$asb = $vbulletin->db->query_read("
				SELECT link.linkname AS linkname, ltoc.catid AS linkcatid, link.linkurl AS linkurl
				FROM ".THIS_TABLE."linkslink AS link
				LEFT JOIN ".THIS_TABLE."linksltoc AS ltoc
				ON link.linkid=ltoc.linkid
				WHERE link.linkid='" . $viewlinkid . "'
				");
		$catids = array();
		unset($viewlinkname);
		while ($rec=$vbulletin->db->fetch_array($asb)) {
			$viewlinkname = $rec['linkname'];
			$viewlinkurl = $rec['linkurl'];
			$catids[] = $rec['linkcatid'];
		}
		$vbulletin->db->free_result($asb);
		if (!isset($viewlinkname)) {
			eval(standard_error(construct_phrase($vbphrase['ll_error_linkid'], $viewlinkid).
				$vbphrase['ll_goback']));
			exit;
		}
		elseif ($vbulletin->GPC['catid']) {
			if (!in_array($vbulletin->GPC['catid'], $catids)) {
				$newurl = ldm_get_url_atag(-2, $catids[0], $viewlinkid, $viewlinkname);
// implement as a 301 redirect
				@header( "HTTP/1.1 301 Moved Permanently" );
				@header( "Location: ".str_replace("&amp;", "&", $newurl) );
				exit;
			}
		}
		else {
			$viewlinkcatid = $catids[0];
		}
	}
	elseif ($vbulletin->GPC['doi']) {
		$viewdoi = $vbulletin->GPC['doi'];
		$rec = $vbulletin->db->query_first("
				SELECT link.linkid AS linkid, link.linkname AS linkname, ltoc.catid AS linkcatid
				FROM ".THIS_TABLE."linkslink AS link
				LEFT JOIN ".THIS_TABLE."linksltoc AS ltoc
				ON link.linkid=ltoc.linkid
				WHERE link.linkdoi LIKE ('".$vbulletin->db->escape_string($viewdoi)."')
				LIMIT 1
				");
		if (!isset($rec['linkname'])) {
			eval(standard_error(construct_phrase($vbphrase['ll_error_doi'], $viewdoi).
				$vbphrase['ll_goback']));
			exit;
		}
		$viewlinkid = $rec['linkid'];
		$viewlinkname = $rec['linkname'];
		$viewlinkcatid = $rec['linkcatid'];
	}
	else {
		$viewlinkid = 0;
	}

	if ($vbulletin->GPC['catid']) {
		$viewcatid = $vbulletin->GPC['catid'];
	}
	elseif ($viewlinkid) {
		$viewcatid = $viewlinkcatid;
	}
	else {
		$viewcatid = $BASE_CAT;
	}

	if ($vbulletin->GPC['keyid']) {
		$viewkeyid = $vbulletin->GPC['keyid'];
	}

	if (!$vbulletin->GPC['sort']) {
		$vbulletin->GPC['sort']=="";
		$sort = (isset($links_defaults['default_sort_order']) ? $links_defaults['default_sort_order'] : 'N');
	}
	else {
		$sort = $vbulletin->GPC['sort'];
	}

	$viewfilter = "";
	if ($vbulletin->GPC_exists['filter']) {
		$viewfilter = strtoupper(substr($vbulletin->GPC['filter'],0,1));
	}

// Owner can always see his categories.  Otherwise require both forum-based and LDM permission
	if (!$vbulletin->userinfo['userid'] or $vbulletin->userinfo['userid'] != $linkscat[$viewcatid]['catuserid']) {
		if (!$links_permissions['can_view_category']) {
			print_no_permission();
			exit;
		}

		if (isset($linkscat[$viewcatid]) and in_array($linkscat[$viewcatid]["catforum"], $limitfids)) {
			print_no_permission();
			exit;
		}
	}

	cache_LDMicons();

// Check if user has to accept site conditions...
	$ldm_accept = ldm_lookup_acceptme_form();
	if ($ldm_accept<=0) {

		$LDM_accept = array();
		$ldm_accept_vars = array();
		foreach (array('action','pp','page','catid','doi','filter','keyid','linkid','ratings','resync', 'sort') as $key) {
			if ($vbulletin->GPC_exists[$key]) {
				$ldm_accept_vars[$key] = $vbulletin->GPC[$key];
			}
		}
		$LDM_accept['hidden_vars'] = ldm_make_hidden_vars($ldm_accept_vars);
		$LDM_accept['script'] = LINKS_SCRIPT;
		$LDM_accept['userphrase'] = construct_phrase($vbphrase['ll_agreement'], $vbulletin->userinfo['username']);
		$LDM_accept['accept'] = $ldm_accept;

		$this_navigation_title = $master_title;

        ldm_fetch_navbar_template($viewcatid);

        $navpopup = array(
        	'id'    => 'ldmdisplay_navpopup',
        	'title' => $vbphrase['ll_menu_home'],
        	'link'  => $LINKS_SCRIPT . '.php' . $vbulletin->session->vars['sessionurl_q'],
        );
        construct_quick_nav($navpopup);

    	$navbits = array();
    	$navbits[$LINKS_SCRIPT . '.php' . $vbulletin->session->vars['sessionurl_q']] = $master_title;
		$navbits[""] = $vbphrase["ll_warning_message"];

    	$show['notices'] = 0;
    	$navbits = construct_navbits($navbits);
        $navbar = render_navbar_template($navbits);

        $header_options = array();

        $templater = vB_Template::create('links_header');
        $templater->register_page_templates();
        $templater->quickRegister(array(
            'ldm_header_include'=>$ldm_header_include, 'ldm_headtag_include'=>$ldm_headtag_include,
            'header_options'=>$header_options,
            'LDM_scripts'=>$LDM_scripts, 'links_defaults'=>$links_defaults,
            'navbar'=>$navbar, 'this_navigation_title'=>$this_navigation_title
            ));
        $output = $templater->render();

        $templater = vB_Template::create('links_agreement');
    	$templater->register_page_templates();
        $templater->quickRegister(array(
            'LDM_accept'=>$LDM_accept,
            'this_navigation_title'=>$this_navigation_title
            ));
        $output .= $templater->render();

        $templater = vB_Template::create('links_footer');
        $templater->register_page_templates();
        $templater->quickRegister(array(
            'catjumpbit'=>$catjumpbit, 'forumjump'=>$forumjump,
            'LDM_scripts'=>$LDM_scripts, 'ldm_footer_include'=>$ldm_footer_include
            ));
        $output .= $templater->render();

        print_output($output);
		exit;
	}

	$navbits = array();
	$navbits[$LINKS_SCRIPT . '.php' . $vbulletin->session->vars['sessionurl_q']] = $master_title;

	if ($viewcatid>0) {

		if (!ldm_catid_is_valid($viewcatid)) {
			eval(standard_error(construct_phrase($vbphrase['ll_error_category'], $viewcatid)));
			exit;
		}

		$LDM_catinfo['viewcatforum'] = $linkscat["$viewcatid"]["catforum"];
		if ($LDM_catinfo['viewcatforum']>0) {
			$foruminfo = fetch_foruminfo($LDM_catinfo['viewcatforum']);
			verify_forum_password($LDM_catinfo['viewcatforum'], $foruminfo["password"]);
		}

		if ($links_defaults['sync_enabled'] and $linkscat[$viewcatid]['catsyncdir']) {
			require_once(DIR . '/includes/local_links_misc.php');
			$resync = $vbulletin->GPC['resync'];
			ldm_synchronise_category($viewcatid, ($resync ? $links_defaults['sync_maxcpu_allowed_manual'] : $links_defaults['sync_maxcpu_allowed']), $resync);
		}

		($hook = vBulletinHook::fetch_hook('ldm_maindisplay_title')) ? eval($hook) : false;

		$LDM_catinfo['viewcatname'] = ldm_parse_features($linkscat["$viewcatid"]["catname"]);
		$LDM_catinfo['viewcatdesc'] = ldm_parse_features($linkscat["$viewcatid"]["catdesc"]);
		$LDM_catinfo['viewcattext'] = ldm_parse_features($linkscat["$viewcatid"]["cattext"]);

		$parentlist = $linkscat["$viewcatid"]["parentlist"];
		$parentlist = array_reverse(explode(',', $parentlist));
		foreach ($parentlist AS $pid) {
			if ($pid > 0) {
				$navbits[$LINKS_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."catid=$pid"] = $linkscat["$pid"]["catname_clean"];
			}
		}
		if (!$viewlinkid) {
			$navbits[""] = $linkscat["$viewcatid"]["catname_clean"];
		}
		else {
			$navbits[$LINKS_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."catid=$viewcatid"] = $linkscat["$viewcatid"]["catname_clean"];
			$navbits[""] = ldm_parse_features($viewlinkname);
		}
		if ($linkscat["$viewcatid"]["catforumlink"]>0 and $linkscat["$viewcatid"]["catforum"]>0) {
			$LDM_catinfo['viewcatforumname'] = $foruminfo['title_clean'];
			$LDM_catinfo['viewcatforumicon'] = (isset($ldm_icon_cache['forum_link']) ? ldm_get_imagebit($ldm_icon_cache['forum_link'], $vbphrase['ll_linkedforum']) : "");
		}
		else {
			$LDM_catinfo['viewcatforum'] = "";
		}

	}
	elseif ($viewcatid == $BASE_CAT) {
		$LDM_catinfo['viewcatdesc']  = $LDM_catinfo['viewcattext']  = $LDM_catinfo['viewcatforum'] = "";
		$LDM_catinfo['viewcatname']  = $master_title;
	}
	else {
		eval(standard_error(construct_phrase($vbphrase['ll_error_category'], $viewcatid).' '.$vbphrase['ll_goback']));
		exit;
	}

	if ($viewcatid>0 and $viewlinkid>0) {
		$this_navigation_title = $master_title . ' - ' . $linkscat["$viewcatid"]["catname_clean"] . ' - ' . htmlspecialchars_uni(ldm_kill_bbcodes($viewlinkname));
	}
	elseif ($viewcatid>0) {
		$this_navigation_title = $master_title . ' - ' . $linkscat["$viewcatid"]["catname_clean"];
	}
	else {
		$this_navigation_title = $master_title;
	}

// Statistics hit parades
	if ($viewcatid>0 and $links_defaults['show_hit_parade'] == 2) {
		require_once(DIR . '/includes/local_links_vbafunc.php');
		ldm_place_block(ldm_get_hitparades($viewcatid), $links_defaults['hit_parade_placement'], $links_defaults['hit_parade_placeorder']);
	}
	elseif ($viewcatid == $BASE_CAT and $links_defaults['show_hit_parade']) {
		require_once(DIR . '/includes/local_links_vbafunc.php');
		ldm_place_block(ldm_get_hitparades($BASE_CAT), $links_defaults['hit_parade_placement'], $links_defaults['hit_parade_placeorder']);
	}

// Treat viewing a single entry that has no url as a hit
	if ($vbulletin->GPC['linkid'] and !$viewlinkurl) {
		require_once(DIR . '/includes/local_links_misc.php');
		ldm_record_hit($vbulletin->GPC['linkid'], construct_phrase($vbphrase['ll_null_link'], $viewlinkname), $LINK_OK);
	}

	$linklistbit = "";
	$linklistarray = array();
	$moderatorlistbit = "";

	cache_LDMfavourites();
	cache_LDMnominations();

    $LDM_catinfo['mystarred'] = $links_mystarred;
    $LDM_catinfo['mynomination_icon'] = $ldm_icon_cache['mynomination'];

	if ($viewcatid>0) {

		$query = array();
		$query[] = "link.linkforum NOT IN (".implode(',', $limitfids).")";
		$query[] = "ltoc.catid = '".$viewcatid."'";

		if (!$links_permissions["can_moderate_links"] and !$links_permissions["can_moderate_forums"]) {
			if ($vbulletin->userinfo['userid'] == 0) {
				$query[] = "link.linkmoderate = $LINK_ACCEPTED";
			}
			else {
				$query[] = "(link.linkmoderate = $LINK_ACCEPTED OR
					(link.linkmoderate = $LINK_TO_MODERATE AND link.linkuserid = ".$vbulletin->userinfo['userid']."))";
			}
		}

		$showcatname = 0;
		if ($viewlinkid) {
			$query[] = "link.linkid = '".$viewlinkid."'";
			$showcatname = 1;
		}

		if (strlen($viewfilter)) {
			$query[] = "link.linkname REGEXP '^".$vbulletin->db->escape_string($viewfilter)."'";
		}

		$forcedisplayorder = 1;
		$sorder = ldm_get_sortsql($sort, 1);
		$forcedisplayorder = 0;

		$template = $links_defaults["template_linkbit"];
		$allowlinkexpand = 1;
		if ($viewlinkid or !$ldm_linkbitcache[$template]["collapse"]) {
			$allowlinkexpand = 0;
		}
		if ($viewlinkid) {
			$template = ($ldm_linkbitcache[$template]["altbit"] ? $ldm_linkbitcache[$template]["altbit"] : $links_defaults["template_altbit"]);
		}
		elseif ($allowlinkexpand and isset($vbcollapse['collapsecel_linkrefreshbit'])) {
			$template = $ldm_linkbitcache[$template]["collapse"];
		}

		if (is_numeric($sort)) {
			$sortsince = TIMENOW - $sort*24*60*60;
		}
		else {
			$sortsince = "";
		}

		$query = ldm_get_mainsql($query, $sortsince, 0, $sorder, "", $links_defaults['links_show_othercats'], 1);
		$ncols = ($viewlinkid ? 1 : ldm_entrybit_columns($template));
		$thispage = ($ncols<=1) ? $perpage : $ncols*floor(($perpage+$ncols-1)/$ncols);

		$entrybit_options = array(
			'showcatname'=>$showcatname, 'forcedisplayorder'=>$forcedisplayorder, 'forcereview'=>$links_defaults['links_jump_comment'],
			'viewlinkid'=>$viewlinkid, 'viewcatid'=>$viewcatid, 'sort'=>$sort,
			);
		if ($viewkeyid) {
			$entrybit_options['requirekeyid'] = $viewkeyid;
		}

		$nhits = ldm_get_entrybits($linklistarray, $hitids, $expiredids, $template, $query, $entrybit_options, $pagenumber, $thispage);

		$linklistbit = ldm_map_listbit_to_grid($linklistarray, $ncols, 1, 'links_linkseparator', $links_defaults['cat_entry_dseq_titles']);

		$linkratingspopupbit = "";
		if ($links_defaults["dropdown_comment_and_rate"]>0) {
			$linkratings = ldm_get_ratingsbits($hitids, $pagenumber, 0);
			$linkratingspopupbit = implode("", $linkratings);
		}

		ldm_process_expired($expiredids);

		$pagenav = construct_page_nav($pagenumber, $thispage, $nhits, $LINKS_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."catid=$viewcatid&amp;sort=$sort".(strlen($viewfilter) ? "&amp;filter=$viewfilter" : ""), "&amp;pp=$thispage");

		$LDM_catinfo['moderatorlistbit'] = '';
		if ($links_defaults['moderate_links'] and $links_defaults['show_moderators_catbit']) {
			require_once(DIR . '/includes/local_links_misc.php');
			$mod_users = ldm_lookup_userids(explode(';', $links_defaults['moderate_usernames']));
			$mods = ldm_fetch_moderators($viewcatid, $mod_users);
			$show['comma_leader'] = 0;
			foreach ($mods as $moderator) {
        		$templater = vB_Template::create('links_moderatorbit');
		    	$templater->register('moderator', $moderator);
		        $LDM_catinfo['moderatorlistbit'] .= $templater->render();
				$show['comma_leader'] = 1;
			}
		}

	}

	$pcatid   = $linkscat[$viewcatid]["parentid"];
	$catstyle = 1;

	unset ($thisorder);
	$catlistarray = array();
	if (!$viewlinkid and $links_defaults['cat_show_catbit']) {

	    $is_cached = 0;
	    if ($viewcatid==$BASE_CAT) {
	        require_once(DIR . '/includes/local_links_bitcache.php');
            $pageident = "categories";
            $cachebit = "LDM_".$pageident."_".$viewcatid;
            $is_cached = ldm_fetch_cachedbit($cachebit, $catlistbit, $thiscatid);
        }

        if (!$is_cached) {
    		$catsort = (isset($links_defaults['cat_default_sort_order']) ? $links_defaults['cat_default_sort_order'] : 'N');
	    	$cattree = ldm_cat_walk($viewcatid, $links_defaults['cat_depth_display'], $catsort);
		    $cat_template = $links_defaults['template_catbit'];
    		$cat_subtitles = cache_LDMsubtitles($links_defaults['cat_sub_dseq_titles']);
	    	foreach ($cattree AS $thisid=>$thischildren) {
		    	$displayorder = $linkscat[$thisid]['displayorder'];
			    $separator_title = $cat_subtitles[$displayorder];
    			if (isset($thisorder)) {
	    			if ($thisorder!=$displayorder) {
		    			$catlistarray[] = $displayorder;
			    	}
    			}
	    		elseif ($separator_title) {
		    		$catlistarray[] = $displayorder;
			    }
    			$thisorder = $displayorder;
	    		ldm_get_categorybits($catlistarray, $cat_template, $ldm_catbitcache[$cat_template]['subbit'], $thisid, $thischildren, 0);
    		}

    		$catlistbit = ldm_map_listbit_to_grid($catlistarray, ldm_catbit_columns($cat_template), 0, 'links_linkseparator', $links_defaults['cat_sub_dseq_titles']);

    	    if ($viewcatid==$BASE_CAT) {
	            ldm_store_cachedbit($cachebit, $catlistbit, $viewcatid);
	        }
    	}

		$catfulltextpopupbit = array();
		if ($links_defaults['cat_desc_popup']) {
			$catfulltextpopupbit = ldm_get_catextdesc_popupbit($viewcatid);
			foreach ($catfulltextpopupbit as $thisid=>$kpopup) {
			    $catlistbit =
					str_replace("<!--$thisid::ddcatname-->", $kpopup, $catlistbit);
		    }
		}

	}

	$linkfeatbit = "";
	$flinklistarray = array();
	if ($links_defaults['favandfeat_entries_enabled'] and $links_defaults['featured_sites'] and !$viewlinkid) {
		$feat_users = unserialize($links_defaults['featured_userid_favs']);

		if ($links_defaults['featured_usergroupid_favs']) {
			$uquery = "
				SELECT lfav.userid AS userid
				FROM ". THIS_TABLE . "linksfavs AS lfav
				LEFT JOIN ". TABLE_PREFIX . "user AS user
				ON user.userid=lfav.userid
				WHERE user.usergroupid IN (".$links_defaults['featured_usergroupid_favs'].")
				";
			$feat_usergroupids = explode(",", $links_defaults['featured_usergroupid_favs']);
			foreach ($feat_usergroupids AS $feat_usergroupid) {
				$uquery .= "
				OR FIND_IN_SET('".intval($feat_usergroupid)."', user.membergroupids)
				";
			}
			$asb = $vbulletin->db->query_read($uquery);
			while ($row=$vbulletin->db->fetch_array($asb)) {
				$feat_users[] = $row['userid'];
			}
			$vbulletin->db->free_result($asb);
		}

		if (count($feat_users)) {
			$flquery = array();
			$flquery[] = "lfav.userid IN (".implode(',', $feat_users).")";
            if ($viewcatid>0) {
			    switch ($links_defaults['featured_all_categories']) {
				case 0: // find in this category
				    $fquery[] = $flquery[] = "ltoc.catid = " . $viewcatid;
				    break;
				case 2: // find in this category or any child
				    $childcatlist = array($viewcatid);
				    foreach ($linkscat as $thiscatid=>$thiscat) {
				        if (in_array($viewcatid, explode(',', $thiscat['parentlist']))) {
				            $childcatlist[] = $thiscatid;
				        }
				    }
				    $fquery[] = $flquery[] = "ltoc.catid IN (" . implode(',', $childcatlist) . ")";
				    break;
				default:
				    break;
                }
			}
			$query = "
                SELECT lfav.linkid AS linkid, ltoc.catid AS catid
			    FROM local_linksfavs AS lfav
			    LEFT JOIN local_linksltoc AS ltoc
			    ON lfav.linkid = ltoc.linkid
			    WHERE " . implode(" AND ", $flquery) . "
                ORDER BY RAND()
                ";

    		$asb = $vbulletin->db->query_read($query);
    		$ids = array(-1);
	    	while ($myrow=$vbulletin->db->fetch_array($asb)) {
		    	$ids[] = $myrow['linkid'];
		    }
		    $ids = implode(',', $ids);

		    $fquery[] = "link.linkid IN (".$ids.")";
			$fquery[] = "link.linkforum NOT IN (".implode(',', $limitfids).")";

			$query = ldm_get_mainsql($fquery, 0, 0, "FIELD(link.linkid, ".$ids.")", 0, 0, 1);

			$entrybit_options = array('forcedisplayorder'=>1, 'viewlinkid'=>$viewlinkid, 'viewcatid'=>$viewcatid,);
			$nfhits = ldm_get_entrybits($flinklistarray, $hitids, $expiredids, $links_defaults['featured_linkbit'], $query, $entrybit_options, 1, $links_defaults['featured_sites']);
			$featlistbit = ldm_map_listbit_to_grid($flinklistarray, 1);
		}
	}

	$catuserid   = $linkscat[$viewcatid]["catuserid"];

	if ($vbulletin->userinfo['userid']==$catuserid) {
		$links_permissions["can_add_link"] = 1;
		$links_permissions["can_edit_category"] = 1;
	}

	$catchildren = $linkscat[$viewcatid]["childcats"];

	$catclosed = $linkscat[$viewcatid]["catclosed"];
	if ($catclosed) {
		if (!$links_permissions["can_admin_links"]) {
			$links_permissions["can_add_link"] = $links_permissions["can_edit_link"] = 0;
			$links_permissions["can_add_category"] = $links_permissions["can_edit_category"] = 0;
		}
	}

	$LDM_catinfo['catsync'] = $LDM_catinfo['catsync_next'] = $LDM_catinfo['catsync_last'] = "";
	$LDM_catinfo['synchronise_icon'] = $ldm_icon_cache['synchronise'];
	$LDM_catinfo['viewcatid'] = $viewcatid;
	$LDM_catinfo['viewdoi'] = $viewdoi;
	$LDM_catinfo['viewkeyid'] = $viewkeyid;
	$LDM_catinfo['viewlinkid'] = $viewlinkid;
	$LDM_catinfo['sort'] = $sort;

	if ($links_defaults['sync_enabled'] and $linkscat[$viewcatid]['catsyncdir']) {
		$links_permissions["can_add_link"] = 0;
		if ($linkscat[$viewcatid]['catsynctime']) {
			$LDM_catinfo['catsync_last'] =
			    ldm_date($vbulletin->options['dateformat'], $linkscat[$viewcatid]['catsynctime']) . ' ' .
			    ldm_date($vbulletin->options['timeformat'], $linkscat[$viewcatid]['catsynctime']);
		}
		else {
			$LDM_catinfo['catsync_last'] = $vbphrase['ll_never'];
		}
		$LDM_catinfo['catsync_last'] = construct_phrase($vbphrase['ll_synctime_last'], $LDM_catinfo['catsync_last']);
		if ($linkscat[$viewcatid]['catsyncdone']) {
			$LDM_catinfo['catsync_done'] = "";
			if ($links_defaults['sync_freq']>0) {
				$LDM_catinfo['catsync_next'] =
				    ldm_date($vbulletin->options['dateformat'], $links_defaults['sync_freq']+$linkscat[$viewcatid]['catsynctime']). ' ' .
				    ldm_date($vbulletin->options['timeformat'], $links_defaults['sync_freq']+$linkscat[$viewcatid]['catsynctime']);
				$LDM_catinfo['catsync_next'] = construct_phrase($vbphrase['ll_synctime_next'], $LDM_catinfo['catsync_next']);
			}
			else {
				$LDM_catinfo['catsync_next'] = $vbphrase['ll_synctime_manual'];
			}
		}
		else {
			$LDM_catinfo['catsync_done'] = $vbphrase['ll_sync_notcompleted'];
			if ($links_defaults['sync_freq']<=0) {
				$LDM_catinfo['catsync_next'] = $vbphrase['ll_synctime_manual'];
			}
		}
	}

	$sortnav = 1;
	if ($vbulletin->GPC['linkid'] or $viewcatid<0 or (!$linklistbit and !is_numeric($sort))) {
		$sortnav = 0;
	}

	if ($links_defaults['category_filter_menu'] and ($nhits or strlen($viewfilter))) {
        $filters = array(
            'A'=>'', 'B'=>'', 'C'=>'', 'D'=>'', 'E'=>'', 'F'=>'', 'G'=>'', 'H'=>'', 'I'=>'',
            'J'=>'', 'K'=>'', 'L'=>'', 'M'=>'', 'N'=>'', 'O'=>'', 'P'=>'', 'Q'=>'', 'R'=>'',
            'S'=>'', 'T'=>'', 'U'=>'', 'V'=>'', 'W'=>'', 'X'=>'', 'Y'=>'', 'Z'=>'', '0'=>'',
            '1'=>'', '2'=>'', '3'=>'', '4'=>'', '5'=>'', '6'=>'', '7'=>'', '8'=>'', '9'=>'',
            );
        if (strlen($viewfilter) and isset($filters[$viewfilter])) {
            $filters[$viewfilter] = 'class="highlight"';
        }
        $templater = vB_Template::create('links_filter');
        $templater->quickRegister(array(
                'filters'=>$filters,
                'sort'=>$sort,
                'viewcatid'=>$viewcatid,
                'viewfilter'=>$viewfilter,
                'LDM_scripts'=>$LDM_scripts,
                ));
        $linkfilterbit .= $templater->render();
	}

	if ($sortnav) {
		$sortvar = "sort";
		$sortreturnbit = ldm_make_hidden_vars(array("catid"=>$viewcatid, "keyid"=>$viewkeyid, "filter"=>$viewfilter, "page"=>1, "pp"=>$perpage));

        $templater = vB_Template::create('links_catsortbit');
        $templater->quickRegister(
            array('sortvar'=>'sort', 'sortsubmit'=>1, 'sortsize'=>1, 'sortwidth'=>200, 'sortdef'=>0,
                'sortset'=>$sort, 'sortcats'=>0)
            );
        $sortorderbit .= $templater->render();

		if ($links_defaults['category_keyword_menu']) {
			$keyfilterbit = ldm_construct_keyword_list("keyid", $viewcatid, $viewkeyid);
		}
		if ($keyfilterbit) {
			$keyreturnbit = ldm_make_hidden_vars(array("catid"=>$viewcatid, "filter"=>$viewfilter, "sort"=>$sort, "page"=>1, "pp"=>$perpage));
		}
	}

	$catjumpbit = "";
	if ($links_defaults['category_jump_menu'] and count($linkscat)) {
        $is_cached = 0;
	    if ($viewcatid==$BASE_CAT) {
	        require_once(DIR . '/includes/local_links_bitcache.php');
            $pageident = "catjump";
            $cachebit = "LDM_".$pageident."_".$viewcatid;
            $is_cached = ldm_fetch_cachedbit($cachebit, $catjumpbit, $thiscatid);
        }
        if (!$is_cached) {
            $catjumpbit = ldm_construct_category_list(array($viewcatid), "links_catjump", 0, "catid", "catid", 1);
    	    if ($viewcatid==$BASE_CAT) {
	            ldm_store_cachedbit($cachebit, $catjumpbit, $viewcatid);
	        }
        }
	}
	$allow = ldm_check_user_allowances(0);

	$LDM_catinfo['viewcatautocreate'] = "";
	if ($links_defaults['autocreate_active'] and ($links_defaults['autocreate_forum']>0 or $linkscat['catforum']>0)) {
		$autoforum = $links_defaults['autocreate_forum']>0 ? $links_defaults['autocreate_forum'] : $linkscat['catforum'];
		$autoforuminfo = fetch_foruminfo($autoforum);
		if (isset($autoforuminfo['title_clean'])) {
			$LDM_catinfo['viewcatautocreate'] = construct_phrase($vbphrase['ll_autocreate_forum'], $autoforuminfo['title_clean'], "forumdisplay.php?".$vbulletin->session->vars['sessionurl']."f=".$autoforum);
		}
	}

	$script = LINKS_SCRIPT;

//	construct_forum_jump();
    $navpopup = array(
    	'id'    => 'ldmdisplay_navpopup',
        'title' => $LDM_catinfo['viewcatname'],
        'link'  => $LINKS_SCRIPT . '.php?' . $vbulletin->session->vars['sessionurl'] . 'catid=' . $viewcatid,
    );
    construct_quick_nav($navpopup);

    ldm_fetch_navbar_template($viewcatid);

	$show['notices'] = 0;
	$navbits = construct_navbits($navbits);
    $navbar = render_navbar_template($navbits);

	($hook = vBulletinHook::fetch_hook('ldm_maindisplay_end')) ? eval($hook) : false;

//    $ldmnavbar['header_include'] = $ldm_header_include;

    $templater = vB_Template::create('links_catbit_extras');
    $templater->quickRegister(array(
        'LDM_catinfo'=>$LDM_catinfo, 'LDM_scripts'=>$LDM_scripts, 'consumption'=>$allow['consumption'],
        ));
    $LDM_catinfo['viewcatextra'] = $templater->render();

	$LDM_catinfo['viewcatextra'] = ldm_strip_template($LDM_catinfo['viewcatextra']);

	ldm_process_placed_blocks();

	$emptylistbit = "";
	$linkerrorbit = "";

	if (count($linklistarray)==0
	    and count($flinklistarray)==0
	    and ($viewcatid>0 and count($catlistarray)==0 and $links_defaults['cat_show_catbit'])) {
		$emptylistbit = ldm_emptypage_warning($viewcatid);
	}
// Seems this code can never be reached now...
//	elseif ($viewcatid>0 and !$nhits and $vbulletin->GPC['linkid']) {
//		eval("\$linkerrorbit = \"".fetch_template('links_access_error')."\";");
//	}
	elseif ($viewcatid>0 and !$nhits and is_numeric($sort)) {
		$emptylistbit = $vbphrase['ll_zerohits_sort'];
	}

    $header_options = array('ajaxkeysuggest'=>array(), );
    for ($key=1; $key<=$uniqueid; $key++) {
        $header_options['ajaxkeysuggest'][] = $key;
    }

    $templater = vB_Template::create('links_header');
    $templater->register_page_templates();
    $templater->quickRegister(array(
        'ldm_header_include'=>$ldm_header_include, 'ldm_headtag_include'=>$ldm_headtag_include,
        'LDM_scripts'=>$LDM_scripts, 'links_defaults'=>$links_defaults,
        'navbar'=>$navbar,
        'options'=>$header_options,
        'this_navigation_title'=>$this_navigation_title
        ));
    $output = $templater->render();

    $templater = vB_Template::create('links_main');
    $templater->quickRegister(array(
        'LDM_catinfo'=>$LDM_catinfo, 'LDM_scripts'=>$LDM_scripts, 'links_defaults'=>$links_defaults,
        'catlistbit'=>$catlistbit, 'emptylistbit'=>$emptylistbit,
        'featlistbit'=>$featlistbit, 'linkerrorbit'=>$linkerrorbit,
        'linklistbit'=>$linklistbit, 'catfulltextpopupbit'=>$catfulltextpopupbit,
        'pagenav'=>$pagenav, 'sortnav'=>$sortnav, 'linkfilterbit'=>$linkfilterbit,
        'sortreturnbit'=>$sortreturnbit, 'sortorderbit'=>$sortorderbit,
        'ldm_includeinmain'=>$ldm_includeinmain,
        'script'=>$LINKS_SCRIPT,
        ));
    $output .= $templater->render();

    $templater = vB_Template::create('links_footer');
    $templater->register_page_templates();
    $templater->quickRegister(array(
        'catjumpbit'=>$catjumpbit, 'forumjump'=>$forumjump,
        'LDM_scripts'=>$LDM_scripts, 'ldm_footer_include'=>$ldm_footer_include
        ));
    $output .= $templater->render();

	print_output($output);

	unset($linklistarray);
	unset($catlistarray);
	unset($flinklistarray);

	exit;
}

// Embedded linkbit only, for Jukebox

if ($this_action == "iframe") {

	($hook = vBulletinHook::fetch_hook('ldm_iframe_begin')) ? eval($hook) : false;

	$vbulletin->input->clean_array_gpc('r', array(
		'catid' => TYPE_INT,
		'linkid' => TYPE_INT,
		'sort'	=> TYPE_STR,
	));

	$linkid = $vbulletin->GPC['linkid'];
	$viewcatid = $vbulletin->GPC['catid'];

	$perpage = ($links_defaults['musicbox_files_seen'] ? $links_defaults['musicbox_files_seen'] : $perpage);

	if ($viewcatid>0) {

		$can_bypass = $links_permissions['can_see_protected_links_on_portal'] | $links_permissions['can_bypass_forumperms'];
		$limitfids = ldm_lookup_forum_protections($can_bypass);
		$LDM_catinfo['viewcatname'] = ldm_parse_features($linkscat["$viewcatid"]["catname"]);

		$query = array();
		$query[] = "link.linkforum NOT IN (".implode(',', $limitfids).")";
		$query[] = "ltoc.catid = '".$viewcatid."'";

		if ($vbulletin->userinfo['userid'] == 0) {
			$query[] = "link.linkmoderate = $LINK_ACCEPTED";
		}
		else {
			$query[] = "(link.linkmoderate = $LINK_ACCEPTED OR
				(link.linkmoderate = $LINK_TO_MODERATE AND link.linkuserid = ".$vbulletin->userinfo['userid']."))";
		}

		$sort = $vbulletin->GPC['sort'];
		if (!$sort) {
			$sort = (isset($links_defaults['musicbox_default_sort_order']) ? $links_defaults['musicbox_default_sort_order'] : 'h');
		}
		if (is_numeric($sort)) {
			$sortsince = TIMENOW - $sort*24*60*60;
		}
		else {
			$sortsince = "";
		}
		$sorder = ldm_get_sortsql($sort, 1);
		$query = ldm_get_mainsql($query, $sortsince, 0, $sorder, "", $links_defaults['links_show_othercats'], 1);

		$linklistarray = array();
		$template = $links_defaults["template_linkbit"];
		$entrybit_options = array('viewlinkid'=>$viewlinkid, 'viewcatid'=>$viewcatid, 'sort'=>$sort);
		$nhits = ldm_get_entrybits($linklistarray, $hitids, $expiredids, $template, $query, $entrybit_options, $pagenumber, $perpage);
		$ncols = 1;
		$linklistbit = ldm_map_listbit_to_grid($linklistarray, $ncols, 1);

		$linkratingspopupbit = "";
		if ($links_defaults["dropdown_comment_and_rate"]>0) {
			$linkratings = ldm_get_ratingsbits($hitids, $pagenumber, 0);
			$linkratingspopupbit = implode("", $linkratings);
		}

		$pagenav = construct_page_nav($pagenumber, $perpage, $nhits, $LINKS_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."action=iframe&amp;linkid=$linkid&amp;catid=$viewcatid&amp;sort=$sort", "&amp;pp=$perpage");

		$sortnav = 1;

		$sortreturnbit = ldm_make_hidden_vars(array("action"=>"iframe", "linkid"=>$linkid, "catid"=>$viewcatid, "page"=>1, "pp"=>$perpage));

        $templater = vB_Template::create('links_catsortbit');
        $templater->quickRegister(array(
            'sortvar'=>'sort', 'sortsubmit'=>1, 'sortsize'=>1,
            'sortwidth'=>200, 'sortdef'=>0,
            'sortset'=>$sort, 'sortcats'=>0,
            ));
        $sortorderbit .= $templater->render();

		$script = LINKS_SCRIPT;

		$catuserid   = $linkscat[$viewcatid]["catuserid"];
		if ($vbulletin->userinfo['userid']==$catuserid) {
			$links_permissions["can_add_link"] = 1;
		}

	}

    $templater = vB_Template::create('links_iframed');
    $templater->register_page_templates();
    $templater->quickRegister(array(
            'linkratingspopupbit'=>$linkratingspopupbit, 'viewcatname'=>$viewcatname,
            'linklistbit'=>$linklistbit, 'pagenav'=>$pagenav, 'sortnav'=>$sortnav,
            'sortreturnbit'=>$sortreturnbit, 'sortorderbit'=>$sortorderbit,
            ));
    $output .= $templater->render();

// we don't want the debug info to appear twice
	$vbulletin->debug = 0;
	define('DEBUG', 0);

	print_output($output);

	($hook = vBulletinHook::fetch_hook('ldm_iframe_complete')) ? eval($hook) : false;

	exit;
}

?>