<?php

/* ===========================================================================*/
//
// This code is provided free on the basis that you do not claim that
// it is your own, sell it or use it as the basis for other products that you
// sell. But by all means extend it, modify it, upgrade it, correct it,
// suggest improvements, call me an idiot, etc.
//
// (c) 2004/10
// Andrew Dearing
// European Industrial Research Management Association
// www.eirma.org
//
// v3.0.0, 01.01.2010
// For VB4.0.x
// see changes.txt for history
// v1.00, 1.3.2004
//
/* ===========================================================================*/

define(LDM_ENTRIES_TO_SHOW, 10);


function ldm_member_customfields_myentries($profilefieldid) {
	global $vbulletin, $vbphrase, $userinfo;

// Entries to show
	$entries_to_show = LDM_ENTRIES_TO_SHOW;
	$entries_to_scan = 3*LDM_ENTRIES_TO_SHOW;  // in case entries are in multiple categories

	$results = '';

	$rec = $vbulletin->db->query_read("
			SELECT links.linkid AS linkid, links.linkname AS linkname, links.linkdate AS linkdate,
			links.linkuserid AS userid, ltoc.catid AS catid, lcat.catname AS catname
			FROM ".THIS_TABLE."linkslink AS links
			LEFT JOIN ".THIS_TABLE."linksltoc AS ltoc
			ON links.linkid = ltoc.linkid
			LEFT JOIN ".THIS_TABLE."linkscat AS lcat
			ON lcat.catid = ltoc.catid
			WHERE links.linkuserid = ".intval($userinfo[userid])."
			ORDER BY linkdate DESC, linkid ASC
			LIMIT ".intval($entries_to_scan)."
			");
	$local_bbcode_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
	$nrec = 0;
	$thislinkid = -1;

	$build = 0;

	while ($myrow = $vbulletin->db->fetch_array($rec)) {

		$catname_clean = htmlspecialchars_uni($myrow['catname']);

		$this_link = '<a href="'.LINKS_SCRIPT.'.php?'.$vbulletin->session->vars['sessionurl'].'catid='.$myrow['catid'].'&amp;linkid='.$myrow['linkid'].'" title="'.$catname_clean.'">';

        if ($thislinkid!=$myrow['linkid']) {

    		($hook = vBulletinHook::fetch_hook('ldm_customfields_myentries')) ? eval($hook) : false;

            if ($build) {
                $templater = vB_Template::create('links_memberinfo_block_one');
                $templater->register_page_templates();
                $templater->quickRegister(array(
                    'this_date'=>$this_date,
                    'this_item'=>$this_item,
                    ));
                $ldmentriesbits .= $templater->render();
            }

    		$this_item = "";
            $build = 0;

        }

        $build = 1;

		if ($thislinkid==$myrow['linkid']) {
			$this_item .=
				' '.
				$this_link.
				'+'.
				'</a>';
		}
		else {
			$linkname = $local_bbcode_parser->do_parse($myrow['linkname']);
			$this_item .=
				$this_link.
				$linkname.
				'</a>';
		    $this_date = vbdate($vbulletin->options['dateformat'], $myrow['linkdate'], $vbulletin->options['yestoday']);
			$thislinkid = $myrow['linkid'];
			$nrec++;
		}

		if ($nrec>=$entries_to_show) {
			break;
		}

	}

// Complete last item
    if ($build) {
        $templater = vB_Template::create('links_memberinfo_block_one');
        $templater->register_page_templates();
        $templater->quickRegister(array(
            'this_date'=>$this_date,
            'this_item'=>$this_item,
            ));
        $ldmentriesbits .= $templater->render();
    }

    $build = 0;

	$this_item = "";
	if ($nrec>=$entries_to_show) {
		$this_item =
			'<a href="'.SEARCH_SCRIPT.'.php?'.$vbulletin->session->vars['sessionurl'].'action=show&amp;userid='.$userinfo['userid'].'&amp;sort=d">'.
			$vbphrase['ldm_all_entries'].
			'</a>';
		$build = 1;
	}
	elseif ($nrec==0) {
		$this_item = $vbphrase['none'];
		$build = 1;
	}

	($hook = vBulletinHook::fetch_hook('ldm_customfields_myentries')) ? eval($hook) : false;

    if ($build) {
        $templater = vB_Template::create('links_memberinfo_block_one');
        $templater->register_page_templates();
        $templater->quickRegister(array(
            'this_item'=>$this_item,
            ));
        $ldmentriesbits .= $templater->render();
    }

    $templater = vB_Template::create('links_memberinfo_block_entries');
    $templater->register_page_templates();
    $templater->quickRegister(array(
        'ldmentriesbits'=>$ldmentriesbits,
        ));
    $results = $templater->render();

	return $results;

}

function ldm_member_customfields_myhits($profilefieldid) {
	global $vbulletin, $vbphrase, $userinfo;

	$entries_to_show = LDM_ENTRIES_TO_SHOW;
	$results = '';

	$rec = $vbulletin->db->query_read("
			SELECT downloads.linkid AS linkid, downloads.userid AS userid, downloads.usertime AS usertime,
			links.linkname AS linkname, ltoc.catid AS catid, lcat.catname AS catname
			FROM ".THIS_TABLE."linksdownloads AS downloads
			LEFT JOIN ".THIS_TABLE."linkslink AS links
			ON downloads.linkid = links.linkid
			LEFT JOIN ".THIS_TABLE."linksltoc AS ltoc
			ON links.linkid = ltoc.linkid
			LEFT JOIN ".THIS_TABLE."linkscat AS lcat
			ON lcat.catid = ltoc.catid
			WHERE userid=".intval($userinfo[userid])."
			ORDER BY usertime DESC
			LIMIT ".intval($entries_to_show)."
			");

	$hits = array();
	$local_bbcode_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());

	while ($myrow = $vbulletin->db->fetch_array($rec)) {

        if (!$myrow['linkname']) { // entry no longer exists
            continue;
        }

		if (!$hits[$myrow['linkid']]) {

			$catname_clean = htmlspecialchars_uni($myrow['catname']);
			$linkname = $local_bbcode_parser->do_parse($myrow['linkname']);

			$this_link = '<a href="'.LINKS_SCRIPT.'.php?'.$vbulletin->session->vars['sessionurl'].'catid='.$myrow['catid'].'&amp;linkid='.$myrow['linkid'].'" title="'.$catname_clean.'">';

			$this_item =
				$this_link.
				$linkname.
				'</a>';
			$this_date =
				vbdate($vbulletin->options['dateformat'], $myrow['usertime'], $vbulletin->options['yestoday']);

			($hook = vBulletinHook::fetch_hook('ldm_customfields_myhits')) ? eval($hook) : false;

            $templater = vB_Template::create('links_memberinfo_block_one');
            $templater->register_page_templates();
            $templater->quickRegister(array(
                'this_date'=>$this_date,
                'this_item'=>$this_item,
                ));
            $ldmhitsbits .= $templater->render();

		}

		$hits[$myrow['linkid']] = 1;

	}

	if (!count($hits)) {
		$ldmhitsbits = $vbphrase['none'];
	}

    $templater = vB_Template::create('links_memberinfo_block_hits');
    $templater->register_page_templates();
    $templater->quickRegister(array(
        'ldmhitsbits'=>$ldmhitsbits,
        ));
    $results = $templater->render();

	return $results;

}

?>