<?php
/*======================================================================*\
|| #################################################################### ||
|| # Helpful Answers Rating Script version 2.1.0
|| # Addon Copyright Ted Sindzinski
|| # Developed exclusively for vBulletin 4.0
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2000-2006 Jelsoft Enterprises Ltd. All Rights Reserved. ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #################################################################### ||
\*======================================================================*/

// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('GET_EDIT_TEMPLATES', true);
define('THIS_SCRIPT', 'helpfulanswer');

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array('user', 'postbit');

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array();

// pre-cache templates used by specific actions
$actiontemplates = array(	
	'topanswers' => array(
		'helpful_answers',
		'helpful_answers_top',
		'helpful_answers_top_bit',
		'helpful_answers_topten_bit',
		'forumdisplay_sortarrow',
	)
);

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

// default action
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'topanswers';
}

// #############################################################################
// Show a list of the top rated threads
if ($_REQUEST['do'] == 'topanswers')
{

	// grab input	
	$sortfield = $vbulletin->input->clean_gpc('r', 'sortfield', TYPE_STR);
	$sortorder = $vbulletin->input->clean_gpc('r', 'sortorder', TYPE_STR);
	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);

	if(!$vbulletin->options['helpans_top']){
		eval(standard_error(fetch_error('helpfulanswer_notop')));
	}
	
	($hook = vBulletinHook::fetch_hook('helpfulanswers_top_start')) ? eval($hook) : false;
	
	$vbulletin->input->clean_array_gpc('r', array(
		'forumids' => TYPE_STR
	));
	
	// format search input
	$forumids = $vbulletin->GPC['forumids'];
	if($vbulletin->GPC['ctype']){ $conditions .= " AND thread.forumid IN IN(" . explode(',', $forumids) . ") "; }
			
	// sort criteria
	switch ($sortfield)
	{
		case 'rank':
			$sqlsort = 'avgrank';
			break;
		case 'post':
			$sqlsort = 'post.title';
			break;
		case 'forum':
			$sqlsort = 'forum.title';
			break;
		case 'total':
			$sqlsort = 'totalrank';
			break;
		case 'tdate':
			$sqlsort = 'lastvote';
			break;
		default:
			$sqlsort = 'avgrank';
	}

	if(!$vbulletin->options['helpans_stats_ten']){
		$helpful_selectby = ',goodrank as avgrank';		
		$helpful_bit_template = 'helpful_answers_top_bit';
	} else {
		$helpful_selectby = ',(goodrank/totalrank) as avgrank';
		$helpful_bit_template = 'helpful_answers_topten_bit';
	}

	// sort up or down
	$sortorder = strtolower($sortorder);
	if ($sortorder != 'asc')
	{
		$sortorder = 'desc';
		$oppositesort = 'asc';
	}
	else
	{
		$oppositesort = 'desc';
	}

	$helpfulanswerq = $db->query_first("
		SELECT count(postid) as cnt
		FROM " . TABLE_PREFIX . "helpfulpost as helpfulpost
		WHERE goodrank > 0
		$conditions
	");
	$totalanswers = $helpfulanswerq['cnt'];	

	// set defaults
	if(!$vbulletin->options['helpans_limit']){
		$perpage = 25;
	} else {
		$perpage = intval($vbulletin->options['helpans_limit']);
	}	
	
	sanitize_pageresults($totalanswers, $pagenumber, $perpage, 100, 50);
	
	$sortaddon .= ($vbulletin->GPC['forumids']) ? 'forumids=' . $vbulletin->GPC['forumids'] . '&amp;' : '';	
	$sortaddon = preg_replace('#&amp;$#s', '', $sortaddon);
	$sorturl = 'helpfulanswers.php?' . $vbulletin->session->vars['sessionurl'] . $sortaddon;
		
	$templater = vB_Template::create('forumdisplay_sortarrow');
		$templater->register('oppositesort', $oppositesort);
		$templater->register('pageinfo_sort', $pageinfo_sort);
		$templater->register('pagenumber', $pagenumber);
		$templater->register('perpage', $perpage);
		$templater->register('sortfield', $sortfield);
		$templater->register('sorturl', $sorturl);
	$sortarrow[$sortfield] = $templater->render();

	$limitlower = ($pagenumber - 1) * $perpage + 1;
	$limitupper = ($pagenumber) * $perpage;
	$counter = 0;
	$resultsbits = '';

	if ($limitupper > $totalanswers)
	{
		$limitupper = $totalanswers;
		if ($limitlower > $totalanswers)
		{
			$limitlower = $totalanswers - $perpage;
		}
	}
	if ($limitlower <= 0)
	{
		$limitlower = 1;
	}	

	($hook = vBulletinHook::fetch_hook('helpfulanswers_top_query')) ? eval($hook) : false;

	// pretty simple page, just grab the top X posts
	$helpfulanswers = $db->query_read_slave("
		SELECT post.postid,post.title as posttile,helpfulpost.goodrank,helpfulpost.totalrank,helpfulpost.lastvote,
			thread.threadid,thread.title as title,thread.postusername as postusername,forum.title as ftitle $helpful_selectby
			$hook_query_fields
		FROM " . TABLE_PREFIX . "helpfulpost as helpfulpost
		INNER JOIN " . TABLE_PREFIX . "post AS post ON(helpfulpost.postid = post.postid)
		INNER JOIN " . TABLE_PREFIX . "thread AS thread ON(post.threadid = thread.threadid)
		INNER JOIN " . TABLE_PREFIX . "forum AS forum ON(thread.forumid = forum.forumid)
		WHERE goodrank > 0
			$conditions
			$hook_query_joins
		ORDER BY $sqlsort $sortorder
		LIMIT " . ($limitlower - 1) . ", $perpage
	");
		
	// initialize counters
	$itemcount = ($pagenumber - 1) * $perpage;
	$first = $itemcount + 1;
	$resultsbits = '';
	
	while ($helpfulanswer = $db->fetch_array($helpfulanswers))
	{
		($hook = vBulletinHook::fetch_hook('helpfulanswers_top_loop')) ? eval($hook) : false;
		if($helpfulanswer['lastvote']){ $helpfulanswer['lastvote'] = vbdate($vbulletin->options['dateformat'] . ' ' .  $vbulletin->options['timeformat'], $helpfulanswer['lastvote']); } else { $helpfulanswer['lastvote'] = '-'; }
		$helpfulanswer['avgrank'] = number_format($helpfulanswer['avgrank'], 1, '.', ' ');
		$helpfulanswer['goodpercent'] = $helpfulanswer['goodrank'] / $helpfulanswer['totalrank'] * 100;
		$helpfulanswer['goodpercent'] = number_format($helpfulanswer['goodpercent'], 0);
		
		$templater = vB_Template::create($helpful_bit_template);
			$templater->register('lastvote', $helpfulanswer['lastvote']);
			$templater->register('postid', $helpfulanswer['postid']);
			$templater->register('ftitle', $helpfulanswer['ftitle']);
			$templater->register('title', $helpfulanswer['title']);
			$templater->register('totalrank', $helpfulanswer['totalrank']);
			$templater->register('goodpercent',$helpfulanswer['goodpercent']);
			$templater->register('avgrank', $helpfulanswer['avgrank']);
		$resultsbits .= $templater->render();

		$itemcount++;
	}
	$last = $itemcount;
	
	$pagenav = construct_page_nav($pagenumber, $perpage, $totalanswers, 'helpfulanswers.php?' . $vbulletin->session->vars['sessionurl'] . 'do=topanswers', ''
		. (!empty($vbulletin->GPC['perpage']) ? "&amp;pp=$perpage" : "")
		. (!empty($sortorder) ? "&amp;order=$sortorder" : "")
		. (!empty($sortfield) ? "&amp;sort=$sortfield" : "")
		. (!empty($sortaddon) ? "&amp;$sortaddon" : "")
	);
	
	($hook = vBulletinHook::fetch_hook('helpfulanswers_top_done')) ? eval($hook) : false;
	
	// build navbar
	$navbits = construct_navbits(array('' => $vbphrase['helpfulanswer_mosthelpful']));
	$navbar = render_navbar_template($navbits);
	
	$templater = vB_Template::create('helpful_answers_top');
	$templater->register_page_templates();
	$templater->register('navbar', $navbar);
	$templater->register('resultsbits', $resultsbits);
	$templater->register('pagenav', $pagenav);
	$templater->register('perpage', $perpage);
	$templater->register('sortarrow', $sortarrow);
	$templater->register('sorturl', $sorturl);
	$templater->register('oppositesort', $oppositesort);
	print_output($templater->render());

}

// #############################################################################
// Throw the guest to the register page
if ($_REQUEST['do'] == 'guestrate')
{

	// show them a message and ask them to register
	eval(standard_error(fetch_error('helpfulanswer_guestreg', $vbulletin->session->vars['sessionurl'], $vbulletin->options['bbtitle'])));

}

// #############################################################################
// Process rating request with AJAX or normally
if ($_REQUEST['do'] == 'helpfulanswer' OR $_REQUEST['do'] == 'rate')
{
	
	$vbulletin->input->clean_array_gpc('r', array(
		'postid' 				=> TYPE_UINT,
		'rank' 					=> TYPE_UINT,
		'using_ajax'    => TYPE_UINT,
		'securitytoken' => TYPE_STR
	));
	
	$using_ajax = $vbulletin->GPC['using_ajax'];
	$securitytoken = $vbulletin->GPC['securitytoken'];
	$safeuserid = $vbulletin->userinfo['userid'];
	$saferank = $vbulletin->GPC['rank'];
	
	$foruminfo = fetch_foruminfo($threadinfo['forumid'], false);	
	
	// check if they selected a post
	if(!$vbulletin->GPC['postid']){
		$using_ajax ? exit : eval(standard_error(fetch_error('helpfulanswer_nopost', $vbphrase['post'], $vbulletin->options['contactuslink'])));
	}
	
	// check about the post
	if (!$postinfo['postid'] OR $postinfo['isdeleted'] OR (!$postinfo['visible'] AND !can_moderate($threadinfo['forumid'], 'canmoderateposts')))
	{
		$using_ajax ? exit : eval(standard_error(fetch_error('invalidid', $vbphrase['post'], $vbulletin->options['contactuslink'])));
	}
	
	// check about the thread
	if (!$threadinfo['threadid'] OR $threadinfo['isdeleted'] OR (!$threadinfo['visible'] AND !can_moderate($threadinfo['forumid'], 'canmoderateposts')))
	{
		$using_ajax ? exit : eval(standard_error(fetch_error('invalidid', $vbphrase['thread'], $vbulletin->options['contactuslink'])));
	}
		
	// check if forum allows helpfulanswers
	if(!$foruminfo['helpfulanswerbits'])
	{
		$using_ajax ? exit : eval(standard_error(fetch_error('helpfulanswer_notenabled', $vbphrase['post'], $vbulletin->options['contactuslink'])));
	}
	
	// check that they aren't trying to give a rank over 10
	if ($vbulletin->GPC['rank'] > 10)
	{
		$using_ajax ? exit : eval(standard_error(fetch_error('invalidid', $vbphrase['post'], $vbulletin->options['contactuslink']))); // fake error, they know what's up
	}
	
	// check if they have enough posts
	if($vbulletin->options['helpans_min'] AND $vbulletin->userinfo['posts'] < $vbulletin->options['helpans_minnum']){
		if($using_ajax){ 
			$helpful_answers_error = construct_phrase($vbphrase['helpfulanswer_toofew'],$vbulletin->options['helpans_minnum'],$vbulletin->userinfo['posts']);

			$templater = vB_Template::create('helpful_answers_error');
			$templater->render();
			$templater->register('helpful_answers_error', $helpful_answers_error);
			print_output($templater->render());
			exit;
		} else { eval(standard_error(fetch_error('helpfulanswer_toofew',$vbulletin->options['helpans_minnum'],$vbulletin->userinfo['posts'])));}
	}
	
	// check that this isn't their post
	if (!$vbulletin->options['helpans_self'] AND $postinfo['userid'] == $vbulletin->userinfo['userid'])
	{
		if($using_ajax){ 
			$helpful_answers_error = $vbphrase['helpfulanswer_yourpost'];
			$templater = vB_Template::create('helpful_answers_error');
			$templater->render();
			$templater->register('helpful_answers_error', $helpful_answers_error);
			print_output($templater->render());
			exit;
		} else { eval(standard_error(fetch_error('helpfulanswer_yourpost'))); }
	}	
	
	// check if they can vote more than once per thread
	if($vbulletin->options['helpans_onevote']){

		$helpfulvote = $db->query_first_slave("
			SELECT COUNT(helpfulanswerid) as count FROM " . TABLE_PREFIX . "helpfulanswer
			WHERE userid = $safeuserid AND threadid = $postinfo[threadid]
		");
		
		$count = $helpfulvote['count'];
		
		if($count)
		{
			if($using_ajax){ 
				$helpful_answers_error = $vbphrase['helpfulanswer_alreadyvoted'];
				$templater = vB_Template::create('helpful_answers_error');
				$templater->render();
				$templater->register('helpful_answers_error', $helpful_answers_error);
				print_output($templater->render());
				exit;
			} else { eval(standard_error(fetch_error('helpfulanswer_alreadyvoted'))); }
		}	$count = '';	
	
	}	
	
	// check if the user has already rated the post
	$helpfulanswer = $db->query_first_slave("
		SELECT COUNT(helpfulanswerid) as count FROM " . TABLE_PREFIX . "helpfulanswer
		WHERE userid = $safeuserid AND postid = $postinfo[postid]
	");

	$count = $helpfulanswer['count'];
	
	if($count)
	{
		if($using_ajax){ 
			$helpful_answers_error = $vbphrase['helpfulanswer_alreadyset'];
			$templater = vB_Template::create('helpful_answers_error');
			$templater->render();
			$templater->register('helpful_answers_error', $helpful_answers_error);
			print_output($templater->render());
			exit;
		} else { eval(standard_error(fetch_error('helpfulanswer_alreadyset'))); }
	} $count = '';
	
	// check if they've voted too much today
	if(intval($vbulletin->options['helpans_limitvotes']) > 0){
	
		$datecut = TIMENOW - 86400;
		$helpfulanswer = $db->query_first_slave("
			SELECT COUNT(helpfulanswerid) as count FROM " . TABLE_PREFIX . "helpfulanswer
			WHERE userid = $safeuserid AND dateline > $datecut
		");
		$count = $helpfulanswer['count'];
	
		if($count >= $vbulletin->options['helpans_limitvotes'])
		{
			if($using_ajax){ 
				$helpful_answers_error = $vbphrase['helpfulanswer_limitposts'];
				$templater = vB_Template::create('helpful_answers_error');
				$templater->render();
				$templater->register('helpful_answers_error', $helpful_answers_error);
				print_output($templater->render());
				exit;
			} else { eval(standard_error(fetch_error('helpfulanswer_limitposts'))); }
		}
	
	}
	
	($hook = vBulletinHook::fetch_hook('helpfulanswers_prerate')) ? eval($hook) : false;
	
	// add the vote to the db log
	$db->query_write("
		INSERT INTO " . TABLE_PREFIX . "helpfulanswer
		SET postid = $postinfo[postid], threadid = $postinfo[threadid], userid = $safeuserid, yesno = '$saferank', dateline = ". TIMENOW ."
	");	
	
	$helpfuluser = '';
	if($vbulletin->options['helpans_noti']){
		$helpfuluser .= "helpfulcnt = helpfulcnt + 1,";
	}
	if($vbulletin->options['helpans_noti']){
		$helpfuluser .= "hagoodrank = hagoodrank + ". $saferank .", hatotalrank = hatotalrank + 1";
	}
	
	// add the vote to the users post record 
	if($postinfo['userid'] AND $helpfuluser){
		$db->query_write("
			UPDATE " . TABLE_PREFIX . "user	
			SET $helpfuluser
			WHERE userid = ". $postinfo['userid'] ."
		");
	}
	
	// figure out how to update the table
	
	// get the current rank
	$helpfulanswer = $db->query_first_slave("
		SELECT helpfulpost.goodrank, helpfulpost.totalrank
		FROM " . TABLE_PREFIX . "helpfulpost AS helpfulpost
    WHERE helpfulpost.postid = $postinfo[postid]
  ");
	$totalrank = $helpfulanswer['totalrank'];
	
	// start by looking for a rank AND the 10 point scale
	if($vbulletin->options['helpans_rank_ten']){		
		$update_query = ", goodrank = goodrank + ". intval($vbulletin->GPC['rank']);
		$helpfulanswer['goodrank'] = $helpfulanswer['goodrank'] + intval($vbulletin->GPC['rank']);		
		if($vbulletin->GPC['rank'] > 5){
			$helpful = 1;
		} else {
			$helpful = 0;
		}
	// no scale, now just look for a rank (good)
	} else if($vbulletin->GPC['rank']){
		$update_query = ", goodrank = goodrank + 1";
		$helpful = 1;
		$helpfulanswer['goodrank']++;
	// nada, it must be bad
	} else {
		$helpful = 0;
	}
	
	if($totalrank){
		// update existing record
		$db->query_write("
			UPDATE " . TABLE_PREFIX . "helpfulpost
			SET lastvote = ". TIMENOW .",
					totalrank = totalrank + 1
					$update_query
			WHERE postid = $postinfo[postid]
		");
	} else {
		// create new record
		$db->query_write("
			INSERT INTO " . TABLE_PREFIX . "helpfulpost
			SET postid = $postinfo[postid],
					threadid = $postinfo[threadid],
					lastvote = ". TIMENOW .",
					totalrank = 1
					$update_query			
		");
	}
	$helpfulanswer['totalrank']++;	
	
	($hook = vBulletinHook::fetch_hook('helpfulanswers_dorate')) ? eval($hook) : false;
	
	// annon. tracking option loaded only if enabled AND cURL is installed
	if(extension_loaded('curl') AND $vbulletin->options['helpans_report']){
	
		// yay, we're on. THANK YOU for keeping this feature enabled
	
		// build the url to call up for tracking
		$tracksitename = strip_tags($_SERVER['SERVER_NAME']);
		$trackurl = "http://www.moderninsider.com/helpfulratings.php?do=rate&site=". $tracksitename ."&helpful=". $helpful;
				
		$curlHandle = curl_init();
		curl_setopt($curlHandle, CURLOPT_URL, $trackurl); 
		curl_setopt($curlHandle, CURLOPT_HEADER, 0); // this is annon. no headers should be sent
		curl_setopt($curlHandle, CURLOPT_TIMEOUT, 5); // wait 5 seconds for response	
		curl_setopt($curlHandle, CURLOPT_RETURNTRANSFER, 1); // dont show the page
		curl_setopt($curlHandle, CURLOPT_FAILONERROR, 1); // dont show errors
		curl_setopt($curlHandle, CURLOPT_MUTE, 1); // dont show output		
		$content = curl_exec($curlHandle); // make the connection
		curl_close($curlHandle); // close it all down
		
	}
	
	// ratings are posted, time to return the user to the thread
	if ($using_ajax)
	{
		
		($hook = vBulletinHook::fetch_hook('helpfulanswers_show_ajax')) ? eval($hook) : false;		

		if($vbulletin->options['helpans_rank_ten']){
			
			$post['helpfulanswerid'] = 1; // they've rated it, duh
			$show['helpfulanswer'] = true; // yes they can see helpful answers on this post
			$show['rate_helpfulanswer'] = false; // no they can't rate this again
			$show['helpfulvoted'] = true;
			$post['avgrank'] = $helpfulanswer['goodrank'] / $helpfulanswer['totalrank']; // figure out the average vote on 10pts
			$post['avgrank'] = number_format($post['avgrank'], 1, '.', ' ');
			$post['totalvotes'] = $helpfulanswer['totalrank']; // figure out the number of votes
			$post['totalrank'] = $helpfulanswer['goodrank']; // figure out the total good points
								
			$templater = vB_Template::create('helpful_answers_ten');
			$templater->register('post', $post);	
			$templater->render();
			print_output($templater->render());
			exit;
			
		} else {
			
			$post['totalrank'] = intval($helpfulanswer['totalrank']); // total rankings count
			$post['goodrank'] = intval($helpfulanswer['goodrank']); // good rankings count
			$post['badrank'] = $helpfulanswer['totalrank'] - $helpfulanswer['goodrank']; // bad rankings count
			$post['yesno'] = $vbulletin->GPC['rank'];
			$post['helpfulanswerid'] = 1; // they've rated it, duh
			$show['helpfulanswer'] = true; // yes they can see helpful answers on this post
			$show['rate_helpfulanswer'] = false; // no they can't rate this again
			$show['helpfulvoted'] = true;

			if($vbulletin->options['helpans_txtimg'] == 4){
				$templater = vB_Template::create('helpful_answers_roll');
			} else {
				$templater = vB_Template::create('helpful_answers');
			}

			$templater->register('post', $post);
			$templater->render();
			print_output($templater->render());
			exit;
			
		}
		
	} else {
		
		// we're not using ajax (boo) so just redirect em
		$vbulletin->url = "showthread.php?t=".$postinfo['threadid'];
		eval(print_standard_redirect('redirect_helpfulanswer_done'));
		
	}
	
}


/*======================================================================*\
|| ####################################################################
|| # Downloaded: 15:36, Sat Dec 16th 2006
|| # CVS: $RCSfile$ - $Revision: 15732 $
|| ####################################################################
\*======================================================================*/
?>