<?php
// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'legende');

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array();

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array(
	'legende_home',
	'legende_bit'
);

// pre-cache templates used by specific actions
$actiontemplates = array();

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

// On check les permissions de l'utilisateur
if (!($permissions['vbh_legende_permissions'] & $vbulletin->bf_ugp_vbh_legende_permissions['canviewpage']))
{
	print_no_permission();
}

// On check si le membre peut voir les liens de contact
if (!($permissions['vbh_legende_permissions'] & $vbulletin->bf_ugp_vbh_legende_permissions['canviewlink']))
{
	$show['link'] = false;
} else {
	$show['link'] = true;
}

// On recupre les infos de la global $_REQUEST
$vbulletin->input->clean_array_gpc('r', array(
	'groupid'        => TYPE_INT,
	'perpage'        => TYPE_UINT,
	'pagenumber'     => TYPE_UINT
));
//$perpage =  $vbulletin->input->clean_gpc('r', 'perpage', TYPE_UINT);
$perpage =1;
$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
$groupid =  $vbulletin->input->clean_gpc('r', 'groupid', TYPE_INT);

// Requete sql pour la pagination
$usercount = $db->query_first("
    SELECT COUNT(userid) AS usercount
    FROM " . TABLE_PREFIX . "user AS u
    WHERE u.usergroupid=$groupid
");  


// On verifie qu'un usergroupid a t selectionn 
if (empty($groupid))
{
	print_no_permission();
}


$totalusers = $usercount['usercount'];

$perpage = '20';
// On verifie que les variables sont clean
sanitize_pageresults($totalusers, $pagenumber, $perpage, 200, 20);

// On definie les limites minimal et maximal des variables
$limitlower = ($pagenumber - 1) * $perpage;
$limitupper = ($pagenumber) * $perpage;

if ($limitupper > $totalusers)
{
	$limitupper = $totalusers;
	if ($limitlower > $totalusers)
	{
		$limitlower = ($totalusers - $perpage) - 1;
	}
}
if ($limitlower < 0)
{
	$limitlower = 0;
}	

// On selectionne les donnes dans la base
$users = $db->query_read("
	SELECT u.username, u.userid, u.posts, u.displaygroupid, ug.usergroupid, ug.description 
	FROM " . TABLE_PREFIX . "usergroup AS ug
	LEFT JOIN " . TABLE_PREFIX . "user AS u ON (ug.usergroupid = u.usergroupid)
	WHERE u.usergroupid=$groupid
	GROUP BY u.userid
	LIMIT $limitlower, $perpage
");
								

// On verifie que le groupe est bien prsent
if (!$users)
{
	print_no_permission();
}			
	
while ($user = $db->fetch_array($users))
{
	 // rcup de l'avatar
    require_once('./includes/functions_user.php');
    $userid = $user['userid'];
    $avatarurl = fetch_avatar_url($userid);
    if ($avatarurl == '') {
         $show['avatar'] = false;
    }
    else {
        $show['avatar'] = true;
    }  
	
    //On affiche le nom de l'utilisateur
	$user['musername'] =  fetch_musername($user);
	$usertitle = $user['description'];
	
	$templater_legbit = vB_Template::create('legende_bit');
    $templater_legbit->register('userid', $user['userid']);
	$templater_legbit->register('username', $user['musername']);
	$templater_legbit->register('posts', $user['posts']);
	$templater_legbit->register('avatarurl', $avatarurl[0]);	

    $list_member .= $templater_legbit->render();
}


/*

		
*/

// Construction de la navbar et la pagenav
$pagenav = construct_page_nav($pagenumber, $perpage, $usercount['usercount'], 'legende.php?groupid=' . $groupid); 
$navbits = construct_navbits(array('' => $vbphrase['legende_legende']));
$navbar = render_navbar_template($navbits);
$templater_legende_home = vB_Template::create('legende_home');
$templater_legende_home->register_page_templates();
$templater_legende_home->register('usertitle', $usertitle);
$templater_legende_home->register('list_member', $list_member);
$templater_legende_home->register('pagenav', $pagenav);
$templater_legende_home->register('pagenumber', $pagenumber);
$templater_legende_home->register('perpage', $perpage);
$templater_legende_home->register('navbar', $navbar);
print_output($templater_legende_home->render());





/*======================================================================*\
|| ####################################################################
|| # Downloaded: 18:58, Thu Feb 14th 2008
|| # CVS: $RCSfile$ - $Revision: 25118 $
|| ####################################################################
\*======================================================================*/
?>