<?php
/*
$Revision: 1.4 $  
$Date: 2010/01/13 23:54:00 $ 

Written By Paul Marsden. 
This CMS file is for Flashchat 6 integration with vBulletin 4.0
This version uses Usergroup Integration and is supplied as part of my Integration Modification at vbulletin.org.
*/

// Main Class //
class vBulletinCMS
{
	// Initialise CMS //
	function vBulletinCMS()
	{
		$prefix = $GLOBALS['vbulletin']['prefix'];
		$this->loginStmt = new Statement("SELECT *, userid AS id FROM {$prefix}user WHERE username=?");
		$this->getUserStmt = new Statement("SELECT *, userid AS id, username AS login FROM {$prefix}user WHERE userid=?");
		$this->getUsersStmt = new Statement("SELECT *, userid AS id, username AS login FROM {$prefix}user");
		$this->getUserForSession = new Statement("SELECT * FROM {$prefix}session WHERE sessionhash=? ORDER BY lastactivity DESC");
		$this->getAvatar = new Statement("SELECT * FROM {$prefix}customavatar WHERE userid = ? AND visible = 1");
		$this->getUserGroup = new Statement("SELECT * FROM {$prefix}usergroup WHERE usergroupid=?");
		$this->updateLastactivityForUser = new Statement("UPDATE {$prefix}user SET lastactivity=? WHERE userid=?");
		$this->updateSessionForUser = new Statement("UPDATE {$prefix}session SET lastactivity=?, location='$_SERVER[SCRIPT_FILENAME]' WHERE userid=?");

		$this->session = $_COOKIE[$GLOBALS['vbulletin']['cookie'] . '_sessionhash']; // 4.0.1 +

		if (empty($this->session))
		{	// 4.0.0
			$this->session = $_COOKIE[$GLOBALS['vbulletin']['cookie'] . 'sessionhash'];
		}

		if($_SESSION['fc_users_cache']['sessionhashid'] != $this->session)
		{
			$rs = $this->getUserForSession->process($this->session);
			if($rs->hasNext())
			{
				$rec = $rs->next();
				$this->userid = intval($rec['userid']);
				$_SESSION['fc_users_cache']['sessionuserid'] = $this->userid;
				$_SESSION['fc_users_cache']['sessionhashid'] = $this->session;
			}
			else
			{
				$this->userid = 0;
			}
		}
		else
		{
			$this->userid = $_SESSION['fc_users_cache']['sessionuserid'];
		}
	}

	// Auto Login //
	function isLoggedIn()
	{
		if($this->userid > 0)
		{
			$ru = $this->updateSessionForUser->process(time(),$this->userid);
			$ru = $this->updateLastactivityForUser->process(time(),$this->userid);
		}
		unset ($_SESSION['fc_users_cache'][$this->userid]);
		unset ($_SESSION['fc_roles_cache'][$this->userid]); 
		return $this->userid;
	}

	// Manual Login //
	function login($login, $password)
	{
		if ($login == '_int_') 
		{
			return $this->userid;
		}
		else
		{
			$userid = 0;
		}
		if($GLOBALS['fc_config']['loginUTF8decode'])
		{
			$login = utf8_to_entities($login);
			$rs = $this->loginStmt->process(utf8_decode($login));
		}
		else
		{
			$rs = $this->loginStmt->process($login);
		}
		if($rs->hasNext())
		{
			$rec = $rs->next();
			if($GLOBALS['fc_config']['loginUTF8decode'])
			{
				$password = utf8_to_entities($password);
				if(($rec['password'] == md5(md5(utf8_decode($password)).$rec['salt']))) 
				{
					$userid = $rec['id'];
				}
			}
			else
			{
				if(($rec['password'] == md5(md5($password).$rec['salt'])))
				{
					$userid = $rec['id'];
				}
			}
			if($userid > 0)
			{
				$ru = $this->updateSessionForUser->process(time(),$userid);
				$ru = $this->updateLastactivityForUser->process(time(),$userid);
			}
		}
		unset ($_SESSION['fc_users_cache'][$userid]);
		unset ($_SESSION['fc_roles_cache'][$userid]); 
		return $userid;
	}

	// Logout //
	function logout()
	{
		$_SESSION['fc_users_cache']['sessionhashid'] = '#';
		if($this->userid > 0)
		{
			$ru = $this->updateSessionForUser->process(time(),$this->userid);
			$ru = $this->updateLastactivityForUser->process(time(),$this->userid);
		}
		return NULL;
	}

	// Usergroup role lookup //
	function getRole($role,$usergroups,$type,$newrole)
	{
		foreach ($GLOBALS['vbulletin'][$type] as $group) 
		{
			if (in_array($group,$usergroups)) 
			{
				$role = $newrole;
			}
		}
		return $role;
	}

	// Assign chat role //
	function getUserRole($usergroups)
	{
		$groups = explode(',',$usergroups);
		$userrole = $this->getRole(Null,$groups,'noaccess',ROLE_ANY);
		$userrole = $this->getRole($userrole,$groups,'users',ROLE_USER);
		if ($GLOBALS['fc_config']['liveSupportMode']) 
		{
			$userrole = $this->getRole($userrole,$groups,'customer',ROLE_CUSTOMER);
		}
		$userrole = $this->getRole($userrole,$groups,'mods',ROLE_MODERATOR);
		$userrole = $this->getRole($userrole,$groups,'admin',ROLE_ADMIN);
		$userrole = $this->getRole($userrole,$groups,'spy',ROLE_SPY);
		$userrole = $this->getRole($userrole,$groups,'banned',ROLE_NOBODY);
		return $userrole;
	}

	// Get user details //
	function getUser($userid)
	{
		$rs = $this->getUserStmt->process($userid);
		if($rs->hasNext())
		{
			$rec = $rs->next();
			$rec['usergroups'] = $rec['usergroupid'] ;
			if(intval($rec['membergroupids'])) 
			{
				$rec['usergroups'] .= ",".$rec['membergroupids'] ;
			}
			if(intval($rec['infractiongroupids'])) 
			{
				$rec['usergroups'] .= ",".$rec['infractiongroupids'] ;
			}
			$permlist = array('users','customer','mods','admin','banned','noaccess','spy');
			foreach($permlist as $permission) $GLOBALS['vbulletin'][$permission] = array();
			$groups = explode(',',$rec['usergroups']);
			foreach($groups as $group)
			{
				if(($rx = $this->getUserGroup->process($group)) && ($rex = $rx->next()))
				{
					if(intval($rex['fcpermissions']))
					{
						$bit = 1;
						foreach($permlist as $permission)
						{
							if ($rex['fcpermissions'] & $bit) $GLOBALS['vbulletin'][$permission][] = $group;
							$bit *= 2;
						}
					}
					else
					{
						exit('Error 4.0.3 : No permissions set for usergroup '.$group.'.');
					}
				}
				else
				{
					exit('Error 4.0.4 : No permissions found for usergroup '.$group.'.');
				}
			}
			$rec['roles'] = $this->getUserRole($rec['usergroups']);
			if($GLOBALS['fc_config']['loginUTF8decode'])
			{
				$tagencoded = entities_to_utf8($rec['login']);
				if(strlen($rec['login']) > strlen($tagencoded))
				{
					$rec['login'] = $tagencoded;
				}
				else
				{
					$rec['login'] = utf8_encode($rec['login']);
				}
			}
			$_SESSION['fc_users_cache'][$userid] = $rec;
			$_SESSION['fc_roles_cache'][$userid] = $rec['roles'];
			return $rec;
		}
		else
		{
			return null;
		}
	}

	// Return all existing users //
	function getUsers()
	{
		$rs = $this->getUsersStmt->process();
		if($rs->hasNext())
		{
			return $rs;
		}
		else
		{
			return null;
		}
	}

	// Returns URL of user profile page //
	function getUserProfile($userid)
	{
		$rs = $this->getUserStmt->process($this->userid);
		if($rs->hasNext())
		{
			// CSRF check //
			$rec = $rs->next();
			$fcid = $rec['userid'];
			$fcus = sha1($rec['salt']);
		}
		else
		{
			exit('Error 4.0.5 : Unable to load user information.');
		}
		return ($this->userid == $userid) ? "../profile.php?do=editprofile&fcid=$fcid&fcus=$fcus" : "../member.php?u=$userid&fcid=$fcid&fcus=$fcus";
	}

	// Check if user is in role //
	function userInRole($userid, $role)
	{
		if(!intval($userid))
		{
			return false;
		}
		$user = $this->getUser($userid) ;
		if($role == $user['roles'])
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	// Get Male or Female //
	function getGender($user)
	{
		return null;
	}

	// Get current avatar //
	// This function only works if you use the database storage method in vbulletin //
	function getPhoto($userid)
	{
		if($_SESSION['fc_users_cache'][$userid]['pid'] == $userid)
		{
			return $_SESSION['fc_users_cache'][$userid]['fpath'];
		}
		$rs = $this->getAvatar->process($userid);
		if($rs->hasNext())
		{
			$rec = $rs->next();
			if($rec['filedata'] == '') 
			{
				return null;
			}
			$fparts = explode('.', $rec['filename']);
			$fextn  = $fparts[count($fparts)-1];
			$fname  = '$'.substr('000000'.$userid,-6).'$'.$rec['dateline'];
			$fpath  = './images/cust_img/'.$fname.'.'.$fextn;
			if(!file_exists($fpath))
			{
				$fp = fopen($fpath, 'wb');
				fwrite($fp, $rec['filedata']);
				fflush($fp);
				fclose($fp);
			}
			$_SESSION['fc_users_cache'][$userid]['pid'] = $userid;
			$_SESSION['fc_users_cache'][$userid]['fpath'] = $fpath;
			return $fpath;
		}
		else
		{
			return null;
		}
	}
}

// Security check //
if (!defined('INC_DIR'))
{
	exit('Error 4.0.1 : Please consult you system administrator.');
}

// Find vbroot //
$vbroot = realpath(dirname(__FILE__)).'/../../../';

// Get vb config //
if (!include_once($vbroot.'includes/config.php'))
{
	exit('Error 4.0.2 : Unable to load the vBulletin config file.');
}

// Clear the moderator login message //
foreach($GLOBALS['fc_config']['languages'] as $k => $v)
{
	$GLOBALS['fc_config']['languages'][$k]['dialog']['login']['moderator'] = '';
}

// Get vbulletin config settings //
$GLOBALS['fc_config']['db'] = array(
	'base' => $config['Database']['dbname'],
	'user' => $config['MasterServer']['username'],
	'pass' => $config['MasterServer']['password'],
	'pref' => $GLOBALS['fc_config']['db']['pref'],
	'host' => $config['MasterServer']['servername'],
);

// Add tcp port if specified //
if($config['MasterServer']['port'])
{
	$GLOBALS['fc_config']['db']['host'] .= ':'.$config['MasterServer']['port'];
}

// vBulletin settings //
$GLOBALS['vbulletin'] = array(
	'cookie' => $config['Misc']['cookieprefix'], 
	'prefix' => $config['Database']['tableprefix']
);

// Initiate CMS Class //
$GLOBALS['fc_config']['cms'] = new vBulletinCMS();

?>
