<?php
// Setup PHP Enviropment
error_reporting(E_ALL & ~E_NOTICE);
// Define Contants
define('THIS_SCRIPT', 'classifieds');
define('GET_EDIT_TEMPLATES', 'add,edit');

// Cache Templates & Variables
// get special phrase groups
$phrasegroups = array(
	'microclassifieds',
	'postbit',
	'posting'
);
$specialtemplates = array(
    'smiliecache',
	'bbcodecache',
	'attachmentcache',
);
$globaltemplates = array(
    'microclassifieds_main',
    'microclassifieds_addedit_item',
    'microclassifieds_item_gallery',
    'microclassifieds_item_attachments',
    'microclassifieds_shipping_options',
    'microclassifieds_payment_options',
    'microclassifieds_view_item',
    'microclassifieds_view_item_gallery',
    'microclassifieds_view_item_attachments',
    'microclassifieds_view_shipping_options',
    'microclassifieds_view_payment_options',
    'microclassifieds_delete_item',
    'microclassifieds_sell_item',
    'microclassifieds_category_items',
    'microclassifieds_category_empty',
    'microclassifieds_search_results',
    'microclassifieds_search_results_items',
    'microclassifieds_search_empty',
    'microclassifieds_my_items',
    'microclassifieds_my_items_bit',
    'microclassifieds_approve_items',
    'microclassifieds_approve_items_bit',
    'microclassifieds_premium_items',
    'microclassifieds_premium_items_bit',
    'microclassifieds_random_items',
    'microclassifieds_random_items_bit',
    'microclassifieds_upcoming_items',
    'microclassifieds_upcoming_items_bit',
    'microclassifieds_newest_items',
    'microclassifieds_newest_items_bit',
    'microclassifieds_search_block',
    'microclassifieds_buynow_block',
    'microclassifieds_contact_block',
    'microclassifieds_horizontal_categories',
    'microclassifieds_horizontal_categories_bit',
	'bbcode_code',
	'bbcode_html',
	'bbcode_php',
	'bbcode_quote',
    'editor_toolbar_on'
);
$actiontemplates = array();

// Include Globals
require_once('./global.php');
require_once('./includes/functions_editor.php');
require_once('./includes/functions_wysiwyg.php');
require_once('./includes/functions_newpost.php');
require_once('./includes/functions_user.php');
require_once('./includes/class_bbcode.php');
require_once('./includes/class_image.php');
require_once('./includes/functions_bigthree.php');
require_once('./microclassifieds/includes/functions.php');
require_once('./includes/class_bootstrap_framework.php');
vB_Bootstrap_Framework::init();

// Don't remove it, unless if you know what you're doing.
$copyright = "<div class='smallfont' align='center'><a target='_blank' href='http://www.microhellas.com/'><b>microCLASSIFIEDS<b></a> &copy;2010 by <a target='_blank' href='http://www.microhellas.com/'><b>Mary<b></a></div>";
// Check Moderation Permissions
if($permissions['microclassifieds'] & $vbulletin->bf_ugp['microclassifieds']['moderate'])
{
     $isadmin = 1;
} else {
     $isadmin = 0;
}
// Main Script
if(!($permissions['microclassifieds'] & $vbulletin->bf_ugp['microclassifieds']['access'])){
    print_no_permission();
}
// Select Action
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'main';
}

//  #######################################################################
//  ###############################  Index Page  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'main'){
    $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    if(!isset($_REQUEST['catid']))
    {
       $catid = 0;
    } else {
       $catid = $_REQUEST["catid"];
    }
    $blocks = $vbulletin->options["microclassifieds_blocks"];
    $hcategories = getHorizontalCategories($catid,$blocks);
    // Custom Navbar
    $mynavbar = '';
    $mynavbar = getClassifiedsNavBar($mynavbar, $catid);
    // Category's Classifieds
    $records = 0;
    if($catid != 0)
    {
       $records = 0;
       $totalclassifieds = $db->query_first("
                             SELECT COUNT(`id`) AS `totalclassifieds`
                             FROM `" . TABLE_PREFIX . "microclassifieds_items`
                             WHERE categoryid=$catid AND active=1 AND sold=0
                             ");
 	   $records = $totalclassifieds['totalclassifieds'];
       $perpage= $vbulletin->options['microclassifieds_perpage'];
       $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
       if (empty($pagenumber))
       {
           $pagenumber = 1;
       }
       $limitlower = ($pagenumber - 1) * $perpage+1;
       $limitupper = ($pagenumber) * $perpage;
       $counter = 0;
       if ($limitupper > $records)
	   {
	       $limitupper = $records;
           if ($limitlower > $records)
		   {
		       $limitlower = $records-$perpage;
		   }
	   }
	   if ($limitlower <= 0)
	   {
	       $limitlower = 1;
	   }
       $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'classifieds.php?' . $vbulletin->session->vars['sessionurl'] . 'do=main&catid='.$catid);
       $classifieds = $vbulletin->db->query_read("
	                               SELECT *
	                               FROM " . TABLE_PREFIX . "microclassifieds_items
                                   WHERE categoryid=$catid AND active=1 AND sold=0
	                               ORDER BY premium DESC, ends DESC
                                   LIMIT " . ($limitlower-1) . ", $perpage");
       // Build Classifieds Bits
       while ($classified = $vbulletin->db->fetch_array($classifieds)){
              // Get Classified Photo
              $current_classified = $classified["id"];
              $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE itemid=$current_classified AND istitlephoto=1");
              if(!$photo)
              {
                  $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE itemid=$current_classified");
              }
		      if($photo)
              {
		         $classified_photo = $photo["photoname"];
              } else {
                 $classified_photo = '';
              }
              // Get Seller data
              $classified_sellerid = getRecordById("user",$classified["userid"],"userid");
              $classified_seller = $classified_sellerid["username"];
              // Format Numeric Values
              $classified_minimumprice = getFormatPrice($classified[minimumprice]);
              $classified_price = getFormatPrice($classified[price]);
              $classified_ends = date($vbulletin->options['microclassifieds_dateformat'], $classified[ends]);
              // Other Data
              $classified_currency = $classified["currency"];
              $classified_title = $classified["title"];
              $classified_location = $classified["location"];
              // Prepare Templates
			  $templater = vB_Template::create('microclassifieds_category_items');
			  $templater->register('classified_id', $current_classified);
			  $templater->register('classified_title', $classified_title);
              $templater->register('classified_seller', $classified_seller);
			  $templater->register('classified_seller_type', $classified[sellertype]);
              $templater->register('classified_price', $classified_price);
              $templater->register('classified_ends', $classified_ends);
              $templater->register('classified_currency', $classified_currency);
			  $templater->register('classified_location', $classified_location);
              $templater->register('classified_newused', $classified[newused]);
              $templater->register('classified_photo', $classified_photo);
			  $category_items .= $templater->render();
       }
    }
    // Template for Empty List
    $templater = vB_Template::create('microclassifieds_category_empty');
    $category_empty .= $templater->render();
    // Premium Classifieds
    $premium_classifieds = getPremium($catid);
    // Newest Classifieds
    $newests_classifieds = getNewest($catid);
    // Soon to Expire Classifieds
    $upcoming_classifieds = getUpcoming($catid);
    // Random Classifieds
    $random_classifieds = getRandom($catid);
    // Search Form
    // Get Categories for Search
    $tablename = "".TABLE_PREFIX."microclassifieds_categories";
    $selectCat = new SelectCategory('categoryid', $tablename);
    $selectCat->SetMultiple(false, 30);
    $selectCat->SetFirstOption($vbphrase["microclassifieds_all"], 0);
    $selectCat->SetSelected($catid);
    $selectCat->SetStyle('width:175px;');
    $selectcategory = $selectCat->Output();
    $templater = vB_Template::create('microclassifieds_search_block');
    $templater->register('selectcategory', $selectcategory);
	$search_block .= $templater->render();
    // Page Templates
	$templater = vB_Template::create('microclassifieds_main');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("classifieds.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['microclassifieds_navbar'], '', $mynavbar));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('horizontalcategories', $horizontalcategories);
    $templater->register('premium_items', $premium_items);
    $templater->register('random_items', $random_items);
    $templater->register('upcoming_items', $upcoming_items);
    $templater->register('newest_items', $newest_items);
    $templater->register('search_block', $search_block);
    $templater->register('category_items', $category_items);
    $templater->register('category_empty', $category_empty);
    $templater->register('pagenav', $pagenav);
    $templater->register('catid', $catid);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ##########################  Add / Edit Item  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'addedititem')
{
    // Check for access permission
    if(!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $activeuser = $vbulletin->userinfo['userid'];
    $urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
    if(!$urlid)
    {
        $urlid = 1;
    }
    // Then, check if Item id exists or not
    if(!$itemid)
    {
       // Item id dosen't exists, let's populate default values as per vB4 requirements
       $item["id"] = 0;
       $item["categoryid"] = 0;
       $item["userid"] = $vbulletin->userinfo['userid'];
       $item["title"] = '';
       $item["bodytext"] = '';
       $item["location"] = '';
       $item["starts"] = 0;
       $item["ends"] = 0;
       $item["days"] = 0;
       $item["price"] = 0;
       $item["currency"] = '';
       $item["sellertype"] = 1;
       $item["newused"] = 2;
       $item["dimesnsions"] = '';
       $item["weight"] = '';
       $item["active"] = 0;
       $item["premium"] = 0;
       $item["keywords"] = '';
       $item["sold"] = 0;
       // Setup Editor
	   $editorid = construct_edit_toolbar('', false, 'nonforum', $vbulletin->options['allowsmilies']);
       // Get Categories for Drop Down
       $tablename = "".TABLE_PREFIX."microclassifieds_categories";
       $selectCat = new SelectCategory('categoryid', $tablename);
       $selectCat->SetMultiple(false, 15);
       $selectCat->SetStyle('width:330px;');
       $selectcategory = $selectCat->Output();
    } else {
       // Find Item
       $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_items WHERE id=$itemid LIMIT 1");
       $item = $db->fetch_array($qry);
       // Who is the owner?
       $owner = $item["userid"];
       // Check if active user is the owner or if he has moderator permissions
       if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["moderate"])))
       {
           // Check failed. Send him back
           print_no_permission();
       }
       // Setup Editor
       $editorid = construct_edit_toolbar($item['bodytext'], false, 'nonforum', $vbulletin->options['allowsmilies']);
       // Get Categories for Drop Down
       $tablename = "".TABLE_PREFIX."microclassifieds_categories";
       $selectCat = new SelectCategory('categoryid', $tablename);
       $selectCat->SetMultiple(false, 15);
       $selectCat->SetStyle('width:330px;');
       $selectCat->SetSelected($item["categoryid"]);
       $selectcategory = $selectCat->Output();
       // Get Item Photos
       $item_photos = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE itemid=$itemid");
       $totalphotos = $db->num_rows($item_photos);
       $idx = 0;
       while($item_photo = $db->fetch_array($item_photos)) {
             $templater = vB_Template::create('microclassifieds_item_gallery');
			 $templater->register('photo_id', $item_photo[id]);
			 $templater->register('photo_itemid', $item_photo[itemid]);
			 $templater->register('photo_photoname', $item_photo[photoname]);
             $templater->register('photo_title', $item_photo[title]);
			 $templater->register('photo_istitlephoto', $item_photo[istitlephoto]);
			 $item_gallery .= $templater->render();
             $idx++;
             if($idx == 3) {
             	$changeline = 1;
             	$idx = 0;
             } else {
                $changeline = 0;
             }
	   }
       // Get Item Files
       $item_files = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_files WHERE itemid=$itemid");
       $totalfiles = $db->num_rows($item_files);
       while($item_file = $db->fetch_array($item_files)) {
             $templater = vB_Template::create('microclassifieds_item_attachments');
			 $templater->register('file_id', $item_file[id]);
			 $templater->register('file_itemid', $item_file[itemid]);
			 $templater->register('file_filename', $item_file[filename]);
             $templater->register('file_title', $item_file[title]);
			 $item_attachments .= $templater->render();
	   }
       // Get Item's Shipping Options
       $item_shippings = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_shipping WHERE itemid=$itemid");
       while($shipping = $db->fetch_array($item_shippings)) {
			 $shipping['rate'] = getFormatPrice($shipping['rate']);
             $templater = vB_Template::create('microclassifieds_shipping_options');
			 $templater->register('shipping_id', $shipping[id]);
			 $templater->register('shipping_itemid', $shipping[itemid]);
			 $templater->register('shipping_carrier', $shipping[carrier]);
             $templater->register('shipping_destination', $shipping[destination]);
             $templater->register('shipping_duration', $shipping[duration]);
             $templater->register('shipping_rate', $shipping[rate]);
             $templater->register('shipping_shipfeesby', $shipping[shipfeesby]);
			 $shipping_options .= $templater->render();
	   }
       // Get Item's Payment Options
       $item_payments = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_payments WHERE itemid=$itemid");
       while($payment = $db->fetch_array($item_payments)) {
             $templater = vB_Template::create('microclassifieds_payment_options');
			 $templater->register('payment_id', $payment[id]);
			 $templater->register('payment_itemid', $payment[itemid]);
			 $templater->register('payment_merchant', $payment[merchant]);
             $templater->register('payment_details', $payment[details]);
             $templater->register('payment_payfeesby', $payment[payfeesby]);
			 $payment_options .= $templater->render();
	   }
    }
    // Prepare Template
	$templater = vB_Template::create('microclassifieds_addedit_item');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("classifieds.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microclassifieds_navbar'], '' => $vbphrase['microclassifieds_addedit_item']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('editorid', $editorid);
	$templater->register('messagearea', $messagearea);
	$templater->register('id', $item[id]);
    $templater->register('categoryid', $item[categoryid]);
    $templater->register('userid', $item[userid]);
    $templater->register('title', $item[title]);
    $templater->register('location', $item[location]);
    $templater->register('starts', $item[starts]);
    $templater->register('ends', $item[ends]);
    $templater->register('days', $item[days]);
    $templater->register('price', $item[price]);
    $templater->register('currency', $item[currency]);
    $templater->register('sellertype', $item[sellertype]);
    $templater->register('newused', $item[newused]);
    $templater->register('dimensions', $item[dimensions]);
    $templater->register('weight', $item[weight]);
    $templater->register('active', $item[active]);
    $templater->register('premium', $item[premium]);
    $templater->register('keywords', $item[keywords]);
    $templater->register('sold', $item[sold]);
	$templater->register('selectcategory', $selectcategory);
    $templater->register('item_gallery', $item_gallery);
    $templater->register('totalphotos', $totalphotos);
    $templater->register('item_attachments', $item_attachments);
    $templater->register('totalfiles', $totalfiles);
    $templater->register('shipping_options', $shipping_options);
    $templater->register('payment_options', $payment_options);
    $templater->register('isadmin', $isadmin);
    $templater->register('urlid', $urlid);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}


//  #######################################################################
//  #########################  Insert / Update Item  ######################
//  #######################################################################
if ($_REQUEST['do'] == 'saveupdateitem')
{
    if(!($permissions['microclassifieds'] & $vbulletin->bf_ugp['microclassifieds']['post']))
    {
         print_no_permission();
    }
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
    $activeuser = $vbulletin->userinfo['userid'];
    if(!$urlid)
    {
        $urlid = 1;
    }
    if($itemid != 0)
    {
       // Find Item
       $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_items WHERE id=$itemid LIMIT 1");
       $item = $db->fetch_array($qry);
       // Who is the owner?
       $owner = $item["userid"];
       // Check if active user is the owner or if he has moderator permissions
       if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["moderate"])))
       {
           // Check failed. Send him back
           print_no_permission();
       }
    }
    $vbulletin->input->clean_array_gpc('p', array(
   		'wysiwyg'       => TYPE_BOOL,
		'title'			=> TYPE_NOHTML,
        'location'    	=> TYPE_NOHTML,
        'days'         	=> TYPE_INT,
        'message'		=> TYPE_STR,
        'keywords'      => TYPE_NOHTML,
        'userid'	    => TYPE_UINT,
        'premium'	    => TYPE_UINT,
        'sellertype'    => TYPE_UINT,
        'newused'       => TYPE_UINT,
        'price'    	    => TYPE_INT,
        'starts'	    => TYPE_INT,
        'currency'      => TYPE_NOHTML,
        'dimensions'    => TYPE_NOHTML,
        'weight'        => TYPE_NOHTML,
        'categoryid'    => TYPE_UINT,
        'urlid'    => TYPE_UINT,
        'mainphoto'	    => TYPE_UINT
	));
    // Get Values
    $userid = $vbulletin->GPC['userid'];
    $urlid = $vbulletin->GPC['urlid'];
    $categoryid = $vbulletin->GPC['categoryid'];
	$title = $db->escape_string($vbulletin->GPC['title']);
    $location = $db->escape_string($vbulletin->GPC['location']);
    $days = $vbulletin->GPC['days'];
	if ($vbulletin->GPC['wysiwyg'])
	{
		require_once(DIR . '/includes/functions_wysiwyg.php');
		$vbulletin->GPC['message'] = convert_wysiwyg_html_to_bbcode($vbulletin->GPC['message'], 0);
	}
    require_once(DIR . '/includes/functions_newpost.php');
	$vbulletin->GPC['message'] = convert_url_to_bbcode($vbulletin->GPC['message']);
    $bodytext = $db->escape_string($vbulletin->GPC['message']);
    $keywords = $db->escape_string($vbulletin->GPC['keywords']);
    $price = $vbulletin->GPC['price'];
    $starts = $vbulletin->GPC['starts'];
    $currency = $db->escape_string($vbulletin->GPC['currency']);
    $dimensions = $db->escape_string($vbulletin->GPC['dimensions']);
    $weight = $db->escape_string($vbulletin->GPC['weight']);
    $newused = $vbulletin->GPC['newused'];
    $sellertype = $vbulletin->GPC['sellertype'];
    $premium = $vbulletin->GPC['premium'];
    $useapproval=$vbulletin->options[microclassifieds_approve];
    if ($useapproval=='1') {
        if(!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["moderate"])) {
             $active='0';
        } else {
             $active='1';
        }
    } else {
        $active='1';
    }
    if($itemid != 0)
    {
       $newitem = false;
       // Update Item
       $ends = $starts + ($days * (24 * 60 * 60));
       $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microclassifieds_items
                                    SET categoryid='$categoryid',
                                        title = '$title',
                                        location = '$location',
                                        days = '$days',
                                        ends = '$ends',
                                        bodytext='$bodytext',
                                        keywords = '$keywords',
                                        price = '$price',
                                        currency = '$currency',
                                        dimensions = '$dimensions',
                                        weight = '$weight',
                                        newused = '$newused',
                                        sellertype = '$sellertype',
                                        premium = '$premium',
                                        active = '$active' WHERE id=$itemid");
    } else {
	   $newitem = true;
       // Save New Item
       $starts = time();
       $ends = $starts + ($days * (24 * 60 * 60));
       $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "microclassifieds_items
                                    SET categoryid = '$categoryid',
                    			        userid = '$userid',
                                        title = '$title',
                                        location = '$location',
                                        starts = '$starts',
                                        days = '$days',
                                        ends = '$ends',
                                        bodytext='$bodytext',
                                        keywords = '$keywords',
                                        price = '$price',
                                        currency = '$currency',
                                        dimensions = '$dimensions',
                                        weight = '$weight',
                                        newused = '$newused',
                                        sellertype = '$sellertype',
                                        premium = '$premium',
                                        active = '$active'");
       $itemid=$vbulletin->GPC['itemid'] = $db->insert_id();
    }
    // Manage Shipping Options
    for($i=0; $i <= 9; $i++) {
	    $carrier = addslashes(strip_tags($_POST["carrier"][$i]));
        $duration = addslashes(strip_tags($_POST["duration"][$i]));
        $destination = addslashes(strip_tags($_POST["destination"][$i]));
        $rate = intval($_POST["rate"][$i]);
        $shipfeesby = intval($_POST["shipfeesby"][$i]);
        if(!empty($carrier))
        {
            $db->query_write("INSERT INTO ".TABLE_PREFIX."microclassifieds_item_shipping
                              SET itemid = '$itemid',
                                  carrier = '$carrier',
                                  duration = '$duration',
                                  destination = '$destination',
                                  rate = '$rate',
                                  shipfeesby = '$shipfeesby'");
            $db->insert_id();
        }
    }
    // Remove Shipping Option(s)
	$removeshippings = $_POST["removeshippings"];
	if(!empty($removeshippings)) {
		foreach(array_keys($removeshippings) as $key)
        {
		  $db->query_write("DELETE FROM ".TABLE_PREFIX."microclassifieds_item_shipping WHERE id=".intval($key));
		}
	}
    // Manage Payment Options
    for($i=0; $i <= 9; $i++) {
	    $merchant = addslashes(strip_tags($_POST["merchant"][$i]));
        $details = addslashes(strip_tags($_POST["details"][$i]));
        $payfeesby = intval($_POST["payfeesby"][$i]);
        if(!empty($merchant))
        {
            $db->query_write("INSERT INTO ".TABLE_PREFIX."microclassifieds_item_payments
                              SET itemid = '$itemid',
                                  merchant = '$merchant',
                                  details = '$details',
                                  payfeesby = '$payfeesby'");
            $db->insert_id();
        }
    }
    // Remove Payment Option(s)
	$removepayments = $_POST["removepayments"];
	if(!empty($removepayments)) {
		foreach(array_keys($removepayments) as $key)
        {
		  $db->query_write("DELETE FROM ".TABLE_PREFIX."microclassifieds_item_payments WHERE id=".intval($key));
		}
	}
    // Manage Photos
	$maxphotos = $vbulletin->options["microclassifieds_max_photos"];
	$cnt = $db->query_first("
		   SELECT COUNT(".TABLE_PREFIX."microclassifieds_item_photos.id) AS cnt
		   FROM ".TABLE_PREFIX."microclassifieds_item_photos
		   JOIN ".TABLE_PREFIX."microclassifieds_items
			    ON ".TABLE_PREFIX."microclassifieds_items.id=".TABLE_PREFIX."microclassifieds_item_photos.itemid
		   WHERE itemid=$itemid");
    $filename = "";
	$notuploaded = 0;
	$photos = $_FILES['photo'];
	if(!empty($photos))
    {
		foreach($photos['name'] as $key => $photoname)
        {
			$upload = 0;
			if($cnt["cnt"] < $maxphotos && $maxphotos > 0)
            {
			   $upload = 1;
			   $filename = '';
            }
		    if(!empty($photoname) && $_FILES["name"][$key]["error"] == UPLOAD_ERR_OK)
            {
				if($upload)
                {
		    	   $filename = processUploadedPhoto($photos["tmp_name"][$key], $photoname, '',
		           $vbulletin->options["microclassifieds_photo_width"], $vbulletin->options["microclassifieds_photo_height"],
		           $vbulletin->options["microclassifieds_thumb_width"], $vbulletin->options["microclassifieds_thumb_height"]);
				} else {
					$notuploaded = 1;
					break;
				}
		    }
			if(!empty($filename)) {
	            $phototitle = addslashes(strip_tags($_POST["phototitle"][$key]));
                if($phototitle == '')
                {
       			   $phototitle = $db->escape_string($vbulletin->input->clean_gpc('r', "phototitle$key", TYPE_NOHTML));
                }
                if($phototitle == '')
                {
                   $phototitle = $vbphrase["microbusiness_untitled"];
                }
				$db->query_write("INSERT INTO ".TABLE_PREFIX."microclassifieds_item_photos
                                  SET itemid = '$itemid',
                                      photoname = '$filename',
                                      title = '$phototitle'");
                $db->insert_id();
			}
			$cnt["cnt"] = $cnt["cnt"] + 1;
		}
	}
    $mainphoto = $vbulletin->GPC['mainphoto'];
	if($mainphoto != 0)
    {
		$db->query_write("UPDATE ".TABLE_PREFIX."microclassifieds_item_photos SET istitlephoto=0 WHERE itemid=$itemid");
		$db->query_write("UPDATE ".TABLE_PREFIX."microclassifieds_item_photos SET istitlephoto=1 WHERE itemid=$itemid AND id=$mainphoto");
	}
	$delete = $_POST["delete"];
	if(!empty($delete)) {
		foreach(array_keys($delete) as $key)
        {
		  $db->query_write("DELETE FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE id=".intval($key));
		}
	}
    // Manage Files
	$maxfiles = $vbulletin->options["microclassifieds_max_files"];
	$cnt = $db->query_first("
		   SELECT COUNT(".TABLE_PREFIX."microclassifieds_item_files.id) AS cnt
		   FROM ".TABLE_PREFIX."microclassifieds_item_files
		   JOIN ".TABLE_PREFIX."microclassifieds_items
			    ON ".TABLE_PREFIX."microclassifieds_items.id=".TABLE_PREFIX."microclassifieds_item_files.itemid
		   WHERE itemid=$itemid");
    $filename = "";
	$notuploaded = 0;
	$files = $_FILES['file'];
    $allowedfiletypes = explode(',',$vbulletin->options["microclassifieds_upload_type"]);
	if(!empty($files))
    {
		foreach($files['name'] as $key => $attachment)
        {
			$upload = 0;
			if($cnt["cnt"] < $maxfiles && $maxfiles > 0)
            {
			   $upload = 1;
			   $filename = '';
            }
		    if(!empty($attachment) && $_FILES["name"][$key]["error"] == UPLOAD_ERR_OK)
            {
                $filetype = get_ext($attachment);
                if(in_array($filetype, $allowedfiletypes))
                {
				   if($upload)
                   {
		    	      $filename = processUploadedFile($files["tmp_name"][$key], $attachment, '');
				   } else {
				      $notuploaded = 1;
				      break;
				   }
                }
		    }
			if(!empty($filename)) {
	            $filetitle = addslashes(strip_tags($_POST["filetitle"][$key]));
                if($filetitle == '')
                {
       			   $filetitle = $db->escape_string($vbulletin->input->clean_gpc('r', "filetitle$key", TYPE_NOHTML));
                }
                if($filetitle == '')
                {
                   $filetitle = $vbphrase["microbusiness_untitled"];
                }
				$db->query_write("INSERT INTO ".TABLE_PREFIX."microclassifieds_item_files
                                  SET itemid = '$itemid',
                                      filename = '$filename',
                                      title = '$filetitle'");
                $db->insert_id();
			}
			$cnt["cnt"] = $cnt["cnt"] + 1;
		}
	}
	$deletefile = $_POST["deletefile"];
	if(!empty($deletefile)) {
		foreach(array_keys($deletefile) as $key)
        {
		  $db->query_write("DELETE FROM ".TABLE_PREFIX."microclassifieds_item_files WHERE id=".intval($key));
		}
	}
    // Redirect back
    if($urlid==1)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=myitems";
    } else {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=approveitems";
    }
    eval(print_standard_redirect('microclassifieds_action_ok', true, true));
}

//  #######################################################################
//  ######################  Confirm Item's Deletion  ######################
//  #######################################################################
if ($_REQUEST['do'] == 'deleteitem')
{
    // Check for access permission
    if(!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microclassifieds_invalid_data', true, true));
    }
    if(!$urlid)
    {
        $urlid = 1;
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    // Who is the owner?
    $owner = $item["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["moderate"])))
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Everything is ok, lets prepare the confirmation form
    // Prepare Template
	$templater = vB_Template::create('microclassifieds_delete_item');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("classifieds.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microclassifieds_navbar'], '' => $vbphrase['microclassifieds_deletion_navbar']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('itemid', $item[id]);
    $templater->register('title', $item[title]);
    $templater->register('urlid', $urlid);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ##############################  Delete Item  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'yesdelete')
{
    // Check for access permission
    if(!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microclassifieds_invalid_data', true, true));
    }
    if(!$urlid)
    {
        $urlid = 1;
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    // Who is the owner?
    $owner = $item["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["moderate"])))
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Everything is ok, lets start deletion
    // Remove Photos
    $item_photos = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_item_photos WHERE itemid=$itemid");
    while ($photo = $vbulletin->db->fetch_array($item_photos)){
	       $photoname = $photo["photoname"];
           $photoid = $photo["id"];
           unlink("microclassifieds/photos/$photoname");
           unlink("microclassifieds/photos/thumbs/$photoname");
           $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "microclassifieds_item_photos
	    			                    WHERE id = $photoid");
    }
    // Remove Attachments
    $item_attachments = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_item_files WHERE itemid=$itemid");
    while ($attachment = $vbulletin->db->fetch_array($item_attachments)){
	       $attachment_name = $attachment["filename"];
           $attachment_id = $attachment["id"];
           unlink("microclassifieds/files/$attachment_name");
           $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "microclassifieds_item_files
	    			                    WHERE id = $attachment_id");
    }
    // Remove Hits
    $item_hits = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_item_hits WHERE itemid=$itemid");
    while ($hit = $vbulletin->db->fetch_array($item_hits)){
           $hit_id = $hit["id"];
           $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "microclassifieds_item_hits
	    			                    WHERE id = $hit_id");
    }
    // and finally let's remove the Classified
    $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "microclassifieds_items WHERE id = $itemid");
    // Redirect back
    if($urlid==1)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=myitems";
    } else {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=approveitems";
    }
    eval(print_standard_redirect('microclassifieds_action_ok', true, true));
}


//  #######################################################################
//  ##########################  Confirm Item as Sold  #####################
//  #######################################################################
if ($_REQUEST['do'] == 'sellitem')
{
    // Check for access permission
    if(!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microclassifieds_invalid_data', true, true));
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    // Who is the owner?
    $owner = $item["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if($owner != $vbulletin->userinfo['userid'])
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Prepare Template
	$templater = vB_Template::create('microclassifieds_sell_item');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("classifieds.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microclassifieds_navbar'], '' => $vbphrase['microclassifieds_sold_navbar']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('itemid', $item[id]);
    $templater->register('title', $item[title]);
    $templater->register('price', $maxbid[bid]);
    $templater->register('currency', $item[currency]);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ###########################  Mark Item as Sold ########################
//  #######################################################################
if ($_REQUEST['do'] == 'yessell')
{
    // Check for access permission
    if(!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microclassifieds_invalid_data', true, true));
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    // Who is the owner?
    $owner = $item["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if($owner != $vbulletin->userinfo['userid'])
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Everything is ok, lets mark it as sold
    $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microclassifieds_items SET sold=1 WHERE id = $itemid");
    // Redirect Back
    $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=myitems";
    eval(print_standard_redirect('microclassifieds_action_ok', true, true));
}


//  #######################################################################
//  ###############################  View Item  ###########################
//  #######################################################################
if ($_REQUEST['do'] == 'viewitem')
{
    // Check for access permission
    if(!($permissions["microclassifieds"] & $vbulletin->bf_ugp["microclassifieds"]["access"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    if(!$itemid)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microclassifieds_invalid_data', true, true));
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microclassifieds_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    if(!$item)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microclassifieds_invalid_data', true, true));
    }
    // Format values that must be formated
    // Get Category name
    $categoryid = getRecordById("microclassifieds_categories",$item["categoryid"]);
    $category = $categoryid["name"];
    // Get Seller data
    $sellerid = getRecordById("user",$item["userid"],"userid");
    $seller = $sellerid["username"];
    // Format Bodytext
	require_once(DIR . '/includes/class_bbcode.php');
	$bbcode_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());

	$bodytext = $bbcode_parser->do_parse($item['bodytext'], false, true, true, true, true, $cachable);

    // Count remaining time
    $now_time = time();
    $exp_time = $item["ends"];
    $dif_time = $exp_time - $now_time;
    $expiration = time_duration($dif_time,$vbulletin->options["microclassifieds_expirationformat"]);
    // Count Hits
    $hits = getCountItemHits($item["id"]);
    // Record Hit
    $visitorid = $vbulletin->userinfo['userid'];
    $ownerid = $item["userid"];
    $itemid = $item["id"];
    if ((!empty($visitorid)) AND ($visitorid != $ownerid))
    {
	     $db->query_write("INSERT INTO ".TABLE_PREFIX."microclassifieds_item_hits
                                  SET itemid = '$itemid',
                                      ownerid = '$ownerid',
                                      userid = '$userid'");
         $db->insert_id();
    }
    //  keywords clickable
    $tagIds = $item["keywords"];
    $tagArray = explode(',', $tagIds);
    $tagNames = array();
    foreach($tagArray as $tid){
            $tagNames[] = "<a class='smallfont' href='classifieds.php?do=searchresults&keyword=". $tid ."'><b>".$tid."</b></a>";
    }
    $keywords = implode(', ', $tagNames);
    // Format Numeric Values
    $price = getFormatPrice($item[price]);
    $ends = date($vbulletin->options['microclassifieds_dateformat'], $item[ends]);
       // Get Item Photos
       $item_photos = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE itemid=$itemid");
       $totalphotos = $db->num_rows($item_photos);
       $idx = 0;
       while($item_photo = $db->fetch_array($item_photos)) {
             $templater = vB_Template::create('microclassifieds_view_item_gallery');
			 $templater->register('photo_id', $item_photo[id]);
			 $templater->register('photo_itemid', $item_photo[itemid]);
			 $templater->register('photo_photoname', $item_photo[photoname]);
             $templater->register('photo_title', $item_photo[title]);
			 $templater->register('photo_istitlephoto', $item_photo[istitlephoto]);
			 $view_item_gallery .= $templater->render();
             $idx++;
             if($idx == 3) {
             	$changeline = 1;
             	$idx = 0;
             } else {
                $changeline = 0;
             }
	   }
       // Get Item Files
       $item_files = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_files WHERE itemid=$itemid");
       $totalfiles = $db->num_rows($item_files);
       while($item_file = $db->fetch_array($item_files)) {
             $templater = vB_Template::create('microclassifieds_view_item_attachments');
			 $templater->register('file_id', $item_file[id]);
			 $templater->register('file_itemid', $item_file[itemid]);
			 $templater->register('file_filename', $item_file[filename]);
             $templater->register('file_title', $item_file[title]);
			 $view_item_attachments .= $templater->render();
	   }
       // Get Item's Shipping Options
       $item_shippings = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_shipping WHERE itemid=$itemid");
       $shippings = $db->num_rows($item_shippings);
       while($shipping = $db->fetch_array($item_shippings)) {
			 $shipping['rate'] = getFormatPrice($shipping['rate']);
             $templater = vB_Template::create('microclassifieds_view_shipping_options');
			 $templater->register('shipping_id', $shipping[id]);
			 $templater->register('shipping_itemid', $shipping[itemid]);
			 $templater->register('shipping_carrier', $shipping[carrier]);
             $templater->register('shipping_destination', $shipping[destination]);
             $templater->register('shipping_duration', $shipping[duration]);
             $templater->register('shipping_rate', $shipping[rate]);
             $templater->register('currency', $item[currency]);
             $templater->register('shipping_shipfeesby', $shipping[shipfeesby]);
			 $view_shipping_options .= $templater->render();
	   }
       // Get Item's Payment Options
       $item_payments = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_payments WHERE itemid=$itemid");
       $payments = $db->num_rows($item_payments);
       while($payment = $db->fetch_array($item_payments)) {
             $templater = vB_Template::create('microclassifieds_view_payment_options');
			 $templater->register('payment_id', $payment[id]);
			 $templater->register('payment_itemid', $payment[itemid]);
			 $templater->register('payment_merchant', $payment[merchant]);
             $templater->register('payment_details', $payment[details]);
             $templater->register('payment_payfeesby', $payment[payfeesby]);
			 $view_payment_options .= $templater->render();
	   }
    $catid = $item["categoryid"];
        // Premium Classifieds
    $premium_classifieds = getPremium($catid);
    // Newest Classifieds
    $newests_classifieds = getNewest($catid);
    // Soon to Expire Classifieds
    $upcoming_classifieds = getUpcoming($catid);
    // Search Form
    // Get Categories for Search
    $tablename = "".TABLE_PREFIX."microclassifieds_categories";
    $selectCat = new SelectCategory('categoryid', $tablename);
    $selectCat->SetMultiple(false, 30);
    $selectCat->SetFirstOption($vbphrase["microclassifieds_all"], 0);
    $selectCat->SetSelected($catid);
    $selectCat->SetStyle('width:175px;');
    $selectcategory = $selectCat->Output();
    $templater = vB_Template::create('microclassifieds_search_block');
    $templater->register('selectcategory', $selectcategory);
	$search_block .= $templater->render();
    // Buy Now Form
    $buyerid = $vbulletin->userinfo['userid'];
    $templater = vB_Template::create('microclassifieds_buynow_block');
    $templater->register('buyerid', $buyerid);
    $templater->register('itemid', $item[id]);
    $templater->register('price', $item[price]);
    $templater->register('itemtitle', $item[title]);
    $templater->register('currency', $item[currency]);
	$buynow_block .= $templater->render();
    // Contact Seller Form
    $visitorid = $vbulletin->userinfo['userid'];
	$editorid = construct_edit_toolbar('', false, 'nonforum', $vbulletin->options['allowsmilies']);
    $templater = vB_Template::create('microclassifieds_contact_block');
    $templater->register('editorid', $editorid);
	$templater->register('messagearea', $messagearea);
    $templater->register('itemid', $item[id]);
    $templater->register('visitorid', $visitorid);
    $contact_block .= $templater->render();
    // Prepare Template
	$templater = vB_Template::create('microclassifieds_view_item');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("classifieds.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microclassifieds_navbar'], '' => $item['title']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('id', $item[id]);
    $templater->register('category', $category);
    $templater->register('userid', $item[userid]);
    $templater->register('title', $item[title]);
    $templater->register('bodytext', $bodytext);
    $templater->register('location', $item[location]);
    $templater->register('expiration', $expiration);
    $templater->register('ends', $ends);
    $templater->register('days', $item[days]);
    $templater->register('price', $price);
    $templater->register('currency', $item[currency]);
    $templater->register('sellertype', $item[sellertype]);
    $templater->register('newused', $item[newused]);
    $templater->register('dimensions', $item[dimensions]);
    $templater->register('weight', $item[weight]);
    $templater->register('premium', $item[premium]);
    $templater->register('keywords', $keywords);
    $templater->register('seller', $seller);
    $templater->register('hits', $hits);
    $templater->register('item_gallery', $view_item_gallery);
    $templater->register('totalphotos', $totalphotos);
    $templater->register('main_photo', $main_photo);
    $templater->register('item_attachments', $view_item_attachments);
    $templater->register('totalfiles', $totalfiles);
    $templater->register('shipping_options', $view_shipping_options);
    $templater->register('shippings', $shippings);
    $templater->register('payment_options', $view_payment_options);
    $templater->register('payments', $payments);
    $templater->register('premium_items', $premium_items);
    $templater->register('upcoming_items', $upcoming_items);
    $templater->register('newest_items', $newest_items);
    $templater->register('search_block', $search_block);
    $templater->register('buynow_block', $buynow_block);
    $templater->register('contact_block', $contact_block);
    $templater->register('isadmin', $isadmin);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ###########################  Search Results  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'searchresults'){
    global $sql;
    // Clean Post Values
    $vbulletin->input->clean_array_gpc('r', array(
        'categoryid'   => TYPE_INT,
        'location'	   => TYPE_NOHTML,
        'expiration'   => TYPE_INT,
		'newused'	   => TYPE_INT,
        'sellertype'   => TYPE_INT,
        'keyword'	   => TYPE_NOHTML
	));
    // Get Values
    $categoryid = $vbulletin->GPC['categoryid'];
    $location = $vbulletin->GPC['location'];
    $expiration = $vbulletin->GPC['expiration'];
    $newused = $vbulletin->GPC['newused'];
    $sellertype = $vbulletin->GPC['sellertype'];
    $keyword = $vbulletin->GPC['keyword'];
    // Lets start query with some standards
    $sql = "SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE active=1 AND sold=0";
    // And now lets add custom requests
    // Get Categories andSubcategories
    $SubIds = array();
    $getSub = _getChildId($SubIds, $categoryid);
    $categories = implode($SubIds, ', ');
    $sql .= " AND categoryid IN ($categories)";
    if (!empty($location))
    {
        $sql .= " AND (location LIKE '$location%' OR location LIKE '%$location%' OR location LIKE '%$location')";
    }
    if ($expiration>0)
    {
        $timeframe = $expiration * 60 * 60;
        $timelimit = time()-$timeframe;
        $sql .= " AND ends>$timelimit";
    }
    if ($newused>0)
    {
        $sql .= " AND newused=$newused";
    }
    if ($sellertype>0)
    {
        $sql .= " AND sellertype='$sellertype'";
    }
    if (!empty($keyword))
    {
        $sql .= " AND (keywords LIKE '$keyword%' OR keywords LIKE '%$keyword%' OR keywords LIKE '%$keyword')";
    }
    // Store post values for multipages
    $postvalues .= "&categoryid=".$categoryid;
    $postvalues .= "&location=".$location;
    $postvalues .= "&expiration=".$expiration;
    $postvalues .= "&newused=".$newused;
    $postvalues .= "&sellertype=".$sellertype;
    $postvalues .= "&keyword=".$keyword;
    $sql .= " ORDER BY ends ASC";
    // Count records for pagination
    $totalclassifieds = $db->query_read($sql);
    $records = $db->num_rows($totalclassifieds);
    $perpage= $vbulletin->options['microclassifieds_perpage'];
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    if (empty($pagenumber))
    {
        $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
    $limitupper = ($pagenumber) * $perpage;
    $counter = 0;
    if ($limitupper > $records)
	{
	    $limitupper = $records;
        if ($limitlower > $records)
	    {
	        $limitlower = $records-$perpage;
	    }
	}
	if ($limitlower <= 0)
	{
	    $limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'classifieds.php?' . $vbulletin->session->vars['sessionurl'] . 'do=searchresults'.$postvalues.'');
    // We must add limit to sql
    $sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
    // Execute Query
    $classifieds = $db->query_read($sql);
    // Build Classifieds Bits
    while ($classified = $vbulletin->db->fetch_array($classifieds)){
           // Get Classified Photo
           $current_classified = $classified["id"];
           $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE itemid=$current_classified AND istitlephoto=1");
           if(!$photo)
           {
              $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE itemid=$current_classified");
           }
           if($photo)
           {
	          $classified_photo = $photo["photoname"];
           } else {
              $classified_photo = '';
           }
           // Get Seller data
           $classified_sellerid = getRecordById("user",$classified["userid"],"userid");
           $classified_seller = $classified_sellerid["username"];
           // Format Numeric Values
           $classified_price = getFormatPrice($classified[price]);
           $classified_ends = date($vbulletin->options['microclassifieds_dateformat'], $classified[ends]);
           // Other Data
           $classified_currency = $classified["currency"];
           $classified_title = $classified["title"];
           $classified_location = $classified["location"];
           // Prepare Templates
	       $templater = vB_Template::create('microclassifieds_search_results_items');
		   $templater->register('classified_id', $current_classified);
		   $templater->register('classified_title', $classified_title);
           $templater->register('classified_seller', $classified_seller);
		   $templater->register('classified_seller_type', $classified[sellertype]);
           $templater->register('classified_price', $classified_price);
           $templater->register('classified_ends', $classified_ends);
           $templater->register('classified_currency', $classified_currency);
		   $templater->register('classified_location', $classified_location);
           $templater->register('classified_newused', $classified[newused]);
           $templater->register('classified_photo', $classified_photo);
		   $search_results_items .= $templater->render();
    }
    // Template for Empty Search Results
    $templater = vB_Template::create('microclassifieds_search_empty');
    $search_empty .= $templater->render();
    // Premium Classifieds
    $premium_classifieds = getPremium($catid);
    // Newest Classifieds
    $newests_classifieds = getNewest($catid);
    // Soon to Expire Classifieds
    $upcoming_classifieds = getUpcoming($catid);
    // Search Form
    // Get Categories for Search
    $tablename = "".TABLE_PREFIX."microclassifieds_categories";
    $selectCat = new SelectCategory('id', $tablename);
    $selectCat->SetMultiple(false, 30);
    $selectCat->SetFirstOption($vbphrase["microclassifieds_all"], 0);
    $selectCat->SetSelected($categoryid);
    $selectCat->SetStyle('width:175px;');
    $selectcategory = $selectCat->Output();
    $templater = vB_Template::create('microclassifieds_search_block');
    $templater->register('selectcategory', $selectcategory);
	$search_block .= $templater->render();
    // Page Templates
	$templater = vB_Template::create('microclassifieds_search_results');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("classifieds.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['microclassifieds_navbar'], '' => $vbphrase['microclassifieds_search_results']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('premium_items', $premium_items);
    $templater->register('upcoming_items', $upcoming_items);
    $templater->register('newest_items', $newest_items);
    $templater->register('search_block', $search_block);
    $templater->register('search_results_items', $search_results_items);
    $templater->register('search_empty', $search_empty);
    $templater->register('pagenav', $pagenav);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ################################# BuyNow  #############################
//  #######################################################################
if ($_REQUEST['do'] == 'buynow'){
    // Clean Post Values
    $vbulletin->input->clean_array_gpc('r', array(
        'buyerid'   => TYPE_UINT,
        'itemid'    => TYPE_UINT
	));
    // Get Values
    $buyerid = $vbulletin->GPC['buyerid'];
    $itemid = $vbulletin->GPC['itemid'];
    // Check Permissions to Buy
    if(!($permissions['microclassifieds'] & $vbulletin->bf_ugp['microclassifieds']['post'])){
        print_no_permission();
    }
    // Find Item to get some data
    $qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    $sellerid = $item["userid"];
    // Check if Buyer is the same as Seller
    if ($item["userid"] == $buyerid)
    {
        $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewitem&itemid=".$itemid."";
        eval(print_standard_redirect('microclassifieds_nobuy_owner', true, true));
    }
    // Check if Classified has already expired
    $timenow = time();
    if ($item["ends"] < $timenow)
    {
        $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewitem&itemid=".$itemid."";
        eval(print_standard_redirect('microclassifieds_classified_expired', true, true));
    }
    $buyprice = $item["price"];
    $buynow = getFormatPrice($buyprice);
    // Get Buyer's data for message to Seller
    $buyer_get = getRecordById("user",$buyerid,"userid");
    $buyer_username = $buyer_get["username"];
    $msg_title = $vbphrase["microclassifieds_have_sale"];
    $msg_body = $vbphrase["microclassifieds_sale_msg_1"];
    $msg_body .= ' ';
    $msg_body .= $buyer_username;
    $msg_body .= ' ';
    $msg_body .= $vbphrase["microclassifieds_sale_msg_2"];
    $msg_body .= ' ';
    $msg_body .= $buynow;
    $msg_body .= ' ';
    $msg_body .= $item["curency"];
    $msg_body .= ' ';
    $msg_body .= $vbphrase["microclassifieds_sale_msg_3"];
    $msg_body .= ' ';
    $msg_body .= $item["title"];
    $msg_body .= '. ';
    $msg_body .= $vbphrase["microclassifieds_sale_msg_4"];
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "pmtext
                                        SET fromuserid = '$buyerid',
                    			            fromusername = '$buyer_username',
                                            title = '$msg_title',
                                            message = '$msg_body',
                                            touserarray = '',
                                            iconid = '0',
                                            dateline = '$timenow',
                                            showsignature = '0',
                                            allowsmilie = '1',
                                            reportthreadid = '0'");
    $messageid=$vbulletin->GPC['pmtextid'] = $db->insert_id();
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "pm
                                        SET pmtextid = '$messageid',
                    			            userid = '$sellerid',
                                            folderid = '0',
                                            messageread = '0',
                                            parentpmid = '0'");
    $msguserid=$vbulletin->GPC['pmid'] = $db->insert_id();
    $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "user SET pmunread=pmunread+1 WHERE userid=$sellerid");
    $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewitem&itemid=".$itemid."";
    eval(print_standard_redirect('microclassifieds_action_ok', true, true));
}

//  #######################################################################
//  ############################ Contact Seller  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'contactseller'){
    // Clean Post Values
    $vbulletin->input->clean_array_gpc('r', array(
        'visitorid'   => TYPE_UINT,
        'itemid'      => TYPE_UINT,
   		'wysiwyg'       => TYPE_BOOL,
		'title'			=> TYPE_NOHTML,
        'message'		=> TYPE_STR
	));
    // Get Values
    $visitorid = $vbulletin->GPC['visitorid'];
    $itemid = $vbulletin->GPC['itemid'];
    $title = $db->escape_string($vbulletin->GPC['title']);
    if($vbulletin->GPC['wysiwyg'])
    {
		$bodytext = convert_wysiwyg_html_to_bbcode($vbulletin->GPC['message']);
    } else {
  	    $bodytext = $vbulletin->GPC['message'];
    }
	$bodytext = $db->escape_string($bodytext);
    // Check Permissions to Contact
    if(!($permissions['microclassifieds'] & $vbulletin->bf_ugp['microclassifieds']['post'])){
        print_no_permission();
    }
    // Find Item to get some data
    $qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    $sellerid = $item["userid"];
    // Check if visitor is the same as Seller
    if ($item["userid"] == $visitorid)
    {
        $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewitem&itemid=".$itemid."";
        eval(print_standard_redirect('microclassifieds_nocontact_owner', true, true));
    }
    // Check if Classified has already expired
    $timenow = time();
    if ($item["ends"] < $timenow)
    {
        $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewitem&itemid=".$itemid."";
        eval(print_standard_redirect('microclassifieds_classified_expired', true, true));
    }
    // Get visitor's data for message to Seller
    $visitor_get = getRecordById("user",$visitorid,"userid");
    $visitor_username = $visitor_get["username"];
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "pmtext
                                        SET fromuserid = '$visitorid',
                    			            fromusername = '$visitor_username',
                                            title = '$title',
                                            message = '$bodytext',
                                            touserarray = '',
                                            iconid = '0',
                                            dateline = '$timenow',
                                            showsignature = '0',
                                            allowsmilie = '1',
                                            reportthreadid = '0'");
    $messageid=$vbulletin->GPC['pmtextid'] = $db->insert_id();
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "pm
                                        SET pmtextid = '$messageid',
                    			            userid = '$sellerid',
                                            folderid = '0',
                                            messageread = '0',
                                            parentpmid = '0'");
    $msguserid=$vbulletin->GPC['pmid'] = $db->insert_id();
    $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "user SET pmunread=pmunread+1 WHERE userid=$sellerid");
    $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewitem&itemid=".$itemid."";
    eval(print_standard_redirect('microclassifieds_action_ok', true, true));
}

//  #######################################################################
//  ##############################  My Items  #############################
//  #######################################################################
if ($_REQUEST['do'] == 'myitems'){
    global $sql;
    // Clean Post Values
    $vbulletin->input->clean_array_gpc('r', array(
        'userid'   => TYPE_INT,
	));
    // Get Values
    $userid = $vbulletin->userinfo['userid'];
    // Lets start query with some standards
    $sql = "SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE userid=$userid ORDER BY sold ASC, ends ASC";
    // Count records for pagination
    $totalclassifieds = $db->query_read($sql);
    $records = $db->num_rows($totalclassifieds);
    $perpage= $vbulletin->options['microclassifieds_perpage'];
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    if (empty($pagenumber))
    {
        $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
    $limitupper = ($pagenumber) * $perpage;
    $counter = 0;
    if ($limitupper > $records)
	{
	    $limitupper = $records;
        if ($limitlower > $records)
	    {
	        $limitlower = $records-$perpage;
	    }
	}
	if ($limitlower <= 0)
	{
	    $limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'classifieds.php?' . $vbulletin->session->vars['sessionurl'] . 'do=myitems');
    // We must add limit to sql
    $sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
    // Execute Query
    $classifieds = $db->query_read($sql);
    // Build Classifieds Bits
    while ($classified = $vbulletin->db->fetch_array($classifieds)){
           // Check if Classified has expired
           $timenow = time();
           $classifiedends = $classified["ends"];
           if($classifiedends<$timenow)
           {
              $expired = 1;
           } else {
              $expired = 0;
           }
           $classified_ends = date($vbulletin->options['microclassifieds_dateformat'], $classified[ends]);
           // Prepare Templates
	       $templater = vB_Template::create('microclassifieds_my_items_bit');
		   $templater->register('classified_id', $classified[id]);
		   $templater->register('classified_title', $classified[title]);
           $templater->register('classified_price', $classified[price]);
           $templater->register('classified_ends', $classified_ends);
           $templater->register('classified_currency', $classified[currency]);
           $templater->register('classified_active', $classified[active]);
           $templater->register('classified_sold', $classified[sold]);
           $templater->register('classified_expired', $expired);
		   $my_items_bit .= $templater->render();
    }
    // Premium Classifieds
    $premium_classifieds = getPremium($catid);
    // Newest Classifieds
    $newests_classifieds = getNewest($catid);
    // Soon to Expire Classifieds
    $upcoming_classifieds = getUpcoming($catid);
    // Search Form
    // Get Categories for Search
    $tablename = "".TABLE_PREFIX."microclassifieds_categories";
    $selectCat = new SelectCategory('id', $tablename);
    $selectCat->SetMultiple(false, 30);
    $selectCat->SetFirstOption($vbphrase["microclassifieds_all"], 0);
    $selectCat->SetSelected($categoryid);
    $selectCat->SetStyle('width:175px;');
    $selectcategory = $selectCat->Output();
    $templater = vB_Template::create('microclassifieds_search_block');
    $templater->register('selectcategory', $selectcategory);
	$search_block .= $templater->render();
    // Page Templates
	$templater = vB_Template::create('microclassifieds_my_items');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("classifieds.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['microclassifieds_navbar'], '' => $vbphrase['microclassifieds_my_items']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('premium_items', $premium_items);
    $templater->register('upcoming_items', $upcoming_items);
    $templater->register('newest_items', $newest_items);
    $templater->register('search_block', $search_block);
    $templater->register('my_items_bit', $my_items_bit);
    $templater->register('pagenav', $pagenav);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ############################  Approve Listing  ########################
//  #######################################################################
if ($_REQUEST['do'] == 'approveitems'){
    global $sql;
    // Check for permissions
    if(!($permissions['microclassifieds'] & $vbulletin->bf_ugp['microclassifieds']['moderate'])){
         print_no_permission();
    }
    // Lets start query with some standards
    $sql = "SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE active=0 ORDER BY starts ASC";
    // Count records for pagination
    $totalclassifieds = $db->query_read($sql);
    $records = $db->num_rows($totalclassifieds);
    $perpage= $vbulletin->options['microclassifieds_perpage'];
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    if (empty($pagenumber))
    {
        $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
    $limitupper = ($pagenumber) * $perpage;
    $counter = 0;
    if ($limitupper > $records)
	{
	    $limitupper = $records;
        if ($limitlower > $records)
	    {
	        $limitlower = $records-$perpage;
	    }
	}
	if ($limitlower <= 0)
	{
	    $limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'classifieds.php?' . $vbulletin->session->vars['sessionurl'] . 'do=approveitems');
    // We must add limit to sql
    $sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
    // Execute Query
    $classifieds = $db->query_read($sql);
    // Build Classifieds Bits
    while ($classified = $vbulletin->db->fetch_array($classifieds)){
           $classified_ends = date($vbulletin->options['microclassifieds_dateformat'], $classified[ends]);
           $seller_id = $classified["userid"];
           $seller_name = getRecordById("user",$seller_id,"userid");
           $seller = $seller_name["username"];
           // Prepare Templates
	       $templater = vB_Template::create('microclassifieds_approve_items_bit');
		   $templater->register('classified_id', $classified[id]);
		   $templater->register('classified_title', $classified[title]);
           $templater->register('classified_seller', $seller);
           $templater->register('classified_ends', $classified_ends);
		   $approve_items_bit .= $templater->render();
    }
    // Page Templates
	$templater = vB_Template::create('microclassifieds_approve_items');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("classifieds.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['microclassifieds_navbar'], '' => $vbphrase['microclassifieds_approve_items']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('approve_items_bit', $approve_items_bit);
    $templater->register('pagenav', $pagenav);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ###############################  Approve Item  ########################
//  #######################################################################
if ($_REQUEST['do'] == 'yesapprove'){

    // Check for permissions
    if(!($permissions['microclassifieds'] & $vbulletin->bf_ugp['microclassifieds']['moderate'])){
         print_no_permission();
    }
    // Clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microclassifieds_invalid_data', true, true));
    }
    // Approve Item
    $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microclassifieds_items SET active=1 WHERE id=$itemid");
    $vbulletin->url="classifieds.php?" . $vbulletin->session->vars['sessionurl'] . "do=approveitems";
    eval(print_standard_redirect('microclassifieds_action_ok', true, true));
}
?>
