<?php
// Setup PHP Enviropment
error_reporting(E_ALL & ~E_NOTICE);
// Define Contants
define('THIS_SCRIPT', 'microcms');
define('GET_EDIT_TEMPLATES', 'add,edit');

// Cache Templates & Variables
// get special phrase groups
$phrasegroups = array(
	'microcms',
	'postbit',
	'posting'
);
$specialtemplates = array(
    'smiliecache',
	'bbcodecache',
	'attachmentcache',
);
$globaltemplates = array(
    'microcms_main',
    'microcms_addedit_item',
    'microcms_item_gallery',
    'microcms_item_attachments',
    'microcms_view_item',
    'microcms_view_item_gallery',
    'microcms_view_item_attachments',
    'microcms_delete_item',
    'microcms_category_items',
    'microcms_category_empty',
    'microcms_my_items',
    'microcms_my_items_bit',
    'microcms_approve_items',
    'microcms_approve_items_bit',
    'microcms_premium_items',
    'microcms_premium_items_bit',
    'microcms_highlight_items',
    'microcms_highlight_items_bit',
    'microcms_newest_items',
    'microcms_newest_items_bit',
    'microcms_newest_items_bit_bit',
    'microcms_forum_items',
    'microcms_forum_items_bit',
    'microcms_forum_items_bit_bit',
    'microcms_sticky',
    'microcms_sticky_bit',
    'microcms_latest',
    'microcms_latest_bit',
    'microcms_popular',
    'microcms_popular_bit',
    'microcms_top_this_week',
    'microcms_top_this_week_bit',
    'microcms_top_last_week',
    'microcms_top_last_week_bit',
    'microcms_just_join',
    'microcms_just_join_bit',
    'microcms_categories',
    'microcms_categories_bit',
	'bbcode_code',
	'bbcode_html',
	'bbcode_php',
	'bbcode_quote',
    'editor_toolbar_on'
);
$actiontemplates = array();

// Include Globals
require_once('./global.php');
require_once('./includes/functions_editor.php');
require_once('./includes/functions_wysiwyg.php');
require_once('./includes/functions_newpost.php');
require_once('./includes/functions_user.php');
require_once('./includes/class_bbcode.php');
require_once('./includes/class_image.php');
require_once('./includes/functions_bigthree.php');
require_once('./microcms/includes/functions.php');
require_once('./includes/class_bootstrap_framework.php');
vB_Bootstrap_Framework::init();

// Don't remove it, unless if you know what you're doing.
$copyright = "<div class='smallfont' align='center'><a target='_blank' href='http://www.microhellas.com/'><b>microCMS<b></a> &copy;2010 by <a target='_blank' href='http://www.microhellas.com/'><b>Mary<b></a></div>";
// Check Moderation Permissions
if($permissions['microcms'] & $vbulletin->bf_ugp['microcms']['moderate'])
{
     $isadmin = 1;
} else {
     $isadmin = 0;
}
// Main Script
if(!($permissions['microcms'] & $vbulletin->bf_ugp['microcms']['access'])){
    print_no_permission();
}
// Select Action
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'main';
}

//  #######################################################################
//  ###############################  Index Page  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'main'){
    $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    if(!isset($_REQUEST['catid']))
    {
       $catid = 0;
    } else {
       $catid = $_REQUEST["catid"];
    }
    $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    $listcategories = getCategories($catid);
    // Custom Navbar
    $mynavbar = '';
    $mynavbar = getMyNavBar($mynavbar, $catid);

    // Category's Articles
    $records = 0;
    if($catid != 0)
    {
       $records = 0;
       $totalarticles = $db->query_first("
                             SELECT COUNT(`id`) AS `totalarticles`
                             FROM `" . TABLE_PREFIX . "microcms_items`
                             WHERE categoryid=$catid AND active=1 AND hidden=0
                             ");
 	   $records = $totalarticles['totalarticles'];
       $perpage= $vbulletin->options['microcms_perpage'];
       $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
       if (empty($pagenumber))
       {
           $pagenumber = 1;
       }
       $limitlower = ($pagenumber - 1) * $perpage+1;
       $limitupper = ($pagenumber) * $perpage;
       $counter = 0;
       if ($limitupper > $records)
	   {
	       $limitupper = $records;
           if ($limitlower > $records)
		   {
		       $limitlower = $records-$perpage;
		   }
	   }
	   if ($limitlower <= 0)
	   {
	       $limitlower = 1;
	   }
       $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'index.php?' . $vbulletin->session->vars['sessionurl'] . 'do=main&catid='.$catid);
       $articles = $vbulletin->db->query_read("
	                               SELECT *
	                               FROM " . TABLE_PREFIX . "microcms_items
                                   WHERE categoryid=$catid AND active=1 AND hidden=0
	                               ORDER BY premium DESC, created DESC
                                   LIMIT " . ($limitlower-1) . ", $perpage");
       // Build Articles Bits
       while ($article = $vbulletin->db->fetch_array($articles)){
              // Get Article Photo
              $current_article = $article["id"];
              $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microcms_item_photos WHERE itemid=$current_article AND istitlephoto=1");
              if(!$photo)
              {
                  $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microcms_item_photos WHERE itemid=$current_article");
              }
		      if($photo)
              {
		         $article_photo = $photo["photoname"];
              } else {
                 $article_photo = '';
              }
              // Get Seller data
              $article_authorid = getRecordById("user",$article["userid"],"userid");
              $article_author = $article_authorid["username"];
              // Format Values
              $article_created = date($vbulletin->options['microcms_dateformat'], $article[created]);
              $article_updated = date($vbulletin->options['microcms_dateformat'], $article[updated]);
              // Prepare Templates
			  $templater = vB_Template::create('microcms_category_items');
			  $templater->register('article_id', $current_article);
			  $templater->register('article_title', $article[title]);
              $templater->register('article_description', $article[description]);
              $templater->register('article_authorid', $article_authorid);
              $templater->register('article_author', $article_author);
              $templater->register('article_created', $article_created);
              $templater->register('article_updated', $article_updated);
              $templater->register('article_photo', $article_photo);
			  $category_items .= $templater->render();
       }
    }
    // Template for Empty List
    $templater = vB_Template::create('microcms_category_empty');
    $category_empty .= $templater->render();
    // Top Posters this week
    $stat_topthisweek = getTopThisWeek();
    // Top Posters Last week
    $stat_toplastweek = getTopLastWeek();
    // Just Join
    $stat_justjoin = getJustJoin();
    // Premium Articles
    $premium_articles = getPremium($catid);
    // Highlight Articles
    $highlight_articles = getHighlight($catid);
    // Newest Articles
    $newests_articles = getNewest($catid);
    // Forums
    $forum_block = getForums();
    // Sticky Threads
    $sticky_threads = getSticky();
    // Latest Threads
    $latest_threads = getLatest();
    // Popular Threads
    $popular_threads = getPopular();
    // Page Templates
	$templater = vB_Template::create('microcms_main');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("index.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['microcms_navbar'], '', $mynavbar));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('categories', $categories);
    $templater->register('top_this_week', $top_this_week);
    $templater->register('top_last_week', $top_last_week);
    $templater->register('just_join', $just_join);
    $templater->register('premium_items', $premium_items);
    $templater->register('highlight_items', $highlight_items);
    $templater->register('categories', $categories);
    $templater->register('newest_items', $newest_items);
    $templater->register('forum_items', $forum_items);
    $templater->register('sticky', $sticky);
    $templater->register('latest', $latest);
    $templater->register('popular', $popular);
    $templater->register('category_items', $category_items);
    $templater->register('category_empty', $category_empty);
    $templater->register('pagenav', $pagenav);
    $templater->register('catid', $catid);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ##########################  Add / Edit Item  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'addedititem')
{
    // Check for access permission
    if(!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $activeuser = $vbulletin->userinfo['userid'];
    $urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
    if(!$urlid)
    {
        $urlid = 1;
    }
    // Then, check if Item id exists or not
    if(!$itemid)
    {
       // Item id dosen't exists, let's populate default values as per vB4 requirements
       $item["id"] = 0;
       $item["categoryid"] = 0;
       $item["userid"] = $vbulletin->userinfo['userid'];
       $item["title"] = '';
       $item["bodytext"] = '';
       $item["description"] = '';
       $item["active"] = 0;
       $item["premium"] = 0;
       $item["highlight"] = 0;
       $item["hidden"] = 0;
       // Setup Editor
	   $editorid = construct_edit_toolbar('', false, 'nonforum', $vbulletin->options['allowsmilies']);
       // Get Categories for Drop Down
       $tablename = "".TABLE_PREFIX."microcms_categories";
       $selectCat = new SelectCategory('categoryid', $tablename);
       $selectCat->SetMultiple(false, 15);
       $selectCat->SetStyle('width:330px;');
       $selectcategory = $selectCat->Output();
    } else {
       // Find Item
       $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microcms_items WHERE id=$itemid LIMIT 1");
       $item = $db->fetch_array($qry);
       // Who is the owner?
       $owner = $item["userid"];
       // Check if active user is the owner or if he has moderator permissions
       if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["moderate"])))
       {
           // Check failed. Send him back
           print_no_permission();
       }
       // Setup Editor
       $editorid = construct_edit_toolbar($item['bodytext'], false, 'nonforum', $vbulletin->options['allowsmilies']);
       // Get Categories for Drop Down
       $tablename = "".TABLE_PREFIX."microcms_categories";
       $selectCat = new SelectCategory('categoryid', $tablename);
       $selectCat->SetMultiple(false, 15);
       $selectCat->SetStyle('width:330px;');
       $selectCat->SetSelected($item["categoryid"]);
       $selectcategory = $selectCat->Output();
       // Get Item Photos
       $item_photos = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_item_photos WHERE itemid=$itemid");
       $totalphotos = $db->num_rows($item_photos);
       $idx = 0;
       while($item_photo = $db->fetch_array($item_photos)) {
             $templater = vB_Template::create('microcms_item_gallery');
			 $templater->register('photo_id', $item_photo[id]);
			 $templater->register('photo_itemid', $item_photo[itemid]);
			 $templater->register('photo_photoname', $item_photo[photoname]);
             $templater->register('photo_title', $item_photo[title]);
			 $templater->register('photo_istitlephoto', $item_photo[istitlephoto]);
			 $item_gallery .= $templater->render();
             $idx++;
             if($idx == 3) {
             	$changeline = 1;
             	$idx = 0;
             } else {
                $changeline = 0;
             }
	   }
       // Get Item Files
       $item_files = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_item_files WHERE itemid=$itemid");
       $totalfiles = $db->num_rows($item_files);
       while($item_file = $db->fetch_array($item_files)) {
             $templater = vB_Template::create('microcms_item_attachments');
			 $templater->register('file_id', $item_file[id]);
			 $templater->register('file_itemid', $item_file[itemid]);
			 $templater->register('file_filename', $item_file[filename]);
             $templater->register('file_title', $item_file[title]);
			 $item_attachments .= $templater->render();
	   }
    }
    // Prepare Template
	$templater = vB_Template::create('microcms_addedit_item');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("index.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microcms_navbar'], '' => $vbphrase['microcms_addedit_item']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('editorid', $editorid);
	$templater->register('messagearea', $messagearea);
	$templater->register('id', $item[id]);
    $templater->register('categoryid', $item[categoryid]);
    $templater->register('userid', $item[userid]);
    $templater->register('title', $item[title]);
    $templater->register('description', $item[description]);
    $templater->register('active', $item[active]);
    $templater->register('premium', $item[premium]);
    $templater->register('highlight', $item[highlight]);
    $templater->register('hidden', $item[hidden]);
	$templater->register('selectcategory', $selectcategory);
    $templater->register('item_gallery', $item_gallery);
    $templater->register('totalphotos', $totalphotos);
    $templater->register('item_attachments', $item_attachments);
    $templater->register('totalfiles', $totalfiles);
    $templater->register('isadmin', $isadmin);
    $templater->register('urlid', $urlid);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}


//  #######################################################################
//  #########################  Insert / Update Item  ######################
//  #######################################################################
if ($_REQUEST['do'] == 'saveupdateitem')
{
    if(!($permissions['microcms'] & $vbulletin->bf_ugp['microcms']['post']))
    {
         print_no_permission();
    }
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
    $activeuser = $vbulletin->userinfo['userid'];
    if(!$urlid)
    {
        $urlid = 1;
    }
    if($itemid != 0)
    {
       // Find Item
       $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microcms_items WHERE id=$itemid LIMIT 1");
       $item = $db->fetch_array($qry);
       // Who is the owner?
       $owner = $item["userid"];
       // Check if active user is the owner or if he has moderator permissions
       if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["moderate"])))
       {
           // Check failed. Send him back
           print_no_permission();
       }
    }
    $vbulletin->input->clean_array_gpc('p', array(
   		'wysiwyg'       => TYPE_BOOL,
		'title'			=> TYPE_NOHTML,
        'description'  	=> TYPE_STR,
        'message'		=> TYPE_STR,
        'userid'	    => TYPE_UINT,
        'premium'	    => TYPE_UINT,
        'highlight'	    => TYPE_UINT,
        'categoryid'    => TYPE_UINT,
        'urlid'         => TYPE_UINT,
        'mainphoto'	    => TYPE_UINT
	));
    // Get Values
    $userid = $vbulletin->GPC['userid'];
    $urlid = $vbulletin->GPC['urlid'];
    $categoryid = $vbulletin->GPC['categoryid'];
	$title = $db->escape_string($vbulletin->GPC['title']);
    $description = $db->escape_string($vbulletin->GPC['description']);
	if ($vbulletin->GPC['wysiwyg'])
	{
		require_once(DIR . '/includes/functions_wysiwyg.php');
		$vbulletin->GPC['message'] = convert_wysiwyg_html_to_bbcode($vbulletin->GPC['message'], 0);
	}
	$vbulletin->GPC['message'] = convert_url_to_bbcode($vbulletin->GPC['message']);
    $bodytext = $db->escape_string($vbulletin->GPC['message']);
    $premium = $vbulletin->GPC['premium'];
    $highlight = $vbulletin->GPC['highlight'];
    $useapproval=$vbulletin->options[microcms_approve];
    if ($useapproval=='1') {
        if(!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["moderate"])) {
             $active='0';
        } else {
             $active='1';
        }
    } else {
        $active='1';
    }
    if($itemid != 0)
    {
       $newitem = false;
       // Update Item
       $updated = time();
       $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microcms_items
                                    SET categoryid='$categoryid',
                                        title = '$title',
                                        description = '$description',
                                        bodytext='$bodytext',
                                        updated = '$updated',
                                        premium = '$premium',
                                        highlight = '$highlight',
                                        active = '$active' WHERE id=$itemid");
    } else {
	   $newitem = true;
       $created = time();
       $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "microcms_items
                                    SET categoryid = '$categoryid',
                    			        userid = '$userid',
                                        title = '$title',
                                        description = '$description',
                                        bodytext = '$bodytext',
                                        created = '$created',
                                        premium = '$premium',
                                        highlight = '$highlight',
                                        active = '$active'");
       $itemid=$vbulletin->GPC['itemid'] = $db->insert_id();
    }
    // Manage Photos
	$maxphotos = $vbulletin->options["microcms_max_photos"];
	$cnt = $db->query_first("
		   SELECT COUNT(".TABLE_PREFIX."microcms_item_photos.id) AS cnt
		   FROM ".TABLE_PREFIX."microcms_item_photos
		   JOIN ".TABLE_PREFIX."microcms_items
			    ON ".TABLE_PREFIX."microcms_items.id=".TABLE_PREFIX."microcms_item_photos.itemid
		   WHERE itemid=$itemid");
    $filename = "";
	$notuploaded = 0;
	$photos = $_FILES['photo'];
	if(!empty($photos))
    {
		foreach($photos['name'] as $key => $photoname)
        {
			$upload = 0;
			if($cnt["cnt"] < $maxphotos && $maxphotos > 0)
            {
			   $upload = 1;
			   $filename = '';
            }
		    if(!empty($photoname) && $_FILES["name"][$key]["error"] == UPLOAD_ERR_OK)
            {
				if($upload)
                {
		    	   $filename = processUploadedPhoto($photos["tmp_name"][$key], $photoname, '',
		           $vbulletin->options["microcms_photo_width"], $vbulletin->options["microcms_photo_height"],
		           $vbulletin->options["microcms_thumb_width"], $vbulletin->options["microcms_thumb_height"]);
				} else {
					$notuploaded = 1;
					break;
				}
		    }
			if(!empty($filename)) {
	            $phototitle = addslashes(strip_tags($_POST["phototitle"][$key]));
                if($phototitle == '')
                {
       			   $phototitle = $db->escape_string($vbulletin->input->clean_gpc('r', "phototitle$key", TYPE_NOHTML));
                }
                if($phototitle == '')
                {
                   $phototitle = $vbphrase["microbusiness_untitled"];
                }
				$db->query_write("INSERT INTO ".TABLE_PREFIX."microcms_item_photos
                                  SET itemid = '$itemid',
                                      photoname = '$filename',
                                      title = '$phototitle'");
                $db->insert_id();
			}
			$cnt["cnt"] = $cnt["cnt"] + 1;
		}
	}
    $mainphoto = $vbulletin->GPC['mainphoto'];
	if($mainphoto != 0)
    {
		$db->query_write("UPDATE ".TABLE_PREFIX."microcms_item_photos SET istitlephoto=0 WHERE itemid=$itemid");
		$db->query_write("UPDATE ".TABLE_PREFIX."microcms_item_photos SET istitlephoto=1 WHERE itemid=$itemid AND id=$mainphoto");
	}
	$delete = $_POST["delete"];
	if(!empty($delete)) {
		foreach(array_keys($delete) as $key)
        {
		  $db->query_write("DELETE FROM ".TABLE_PREFIX."microcms_item_photos WHERE id=".intval($key));
		}
	}
    // Manage Files
	$maxfiles = $vbulletin->options["microcms_max_files"];
	$cnt = $db->query_first("
		   SELECT COUNT(".TABLE_PREFIX."microcms_item_files.id) AS cnt
		   FROM ".TABLE_PREFIX."microcms_item_files
		   JOIN ".TABLE_PREFIX."microcms_items
			    ON ".TABLE_PREFIX."microcms_items.id=".TABLE_PREFIX."microcms_item_files.itemid
		   WHERE itemid=$itemid");
    $filename = "";
	$notuploaded = 0;
	$files = $_FILES['file'];
    $allowedfiletypes = explode(',',$vbulletin->options["microcms_upload_type"]);
	if(!empty($files))
    {
		foreach($files['name'] as $key => $attachment)
        {
			$upload = 0;
			if($cnt["cnt"] < $maxfiles && $maxfiles > 0)
            {
			   $upload = 1;
			   $filename = '';
            }
		    if(!empty($attachment) && $_FILES["name"][$key]["error"] == UPLOAD_ERR_OK)
            {
                $filetype = get_ext($attachment);
                if(in_array($filetype, $allowedfiletypes))
                {
				   if($upload)
                   {
		    	      $filename = processUploadedFile($files["tmp_name"][$key], $attachment, '');
				   } else {
				      $notuploaded = 1;
				      break;
				   }
                }
		    }
			if(!empty($filename)) {
	            $filetitle = addslashes(strip_tags($_POST["filetitle"][$key]));
                if($filetitle == '')
                {
       			   $filetitle = $db->escape_string($vbulletin->input->clean_gpc('r', "filetitle$key", TYPE_NOHTML));
                }
                if($filetitle == '')
                {
                   $filetitle = $vbphrase["microbusiness_untitled"];
                }
				$db->query_write("INSERT INTO ".TABLE_PREFIX."microcms_item_files
                                  SET itemid = '$itemid',
                                      filename = '$filename',
                                      title = '$filetitle'");
                $db->insert_id();
			}
			$cnt["cnt"] = $cnt["cnt"] + 1;
		}
	}
	$deletefile = $_POST["deletefile"];
	if(!empty($deletefile)) {
		foreach(array_keys($deletefile) as $key)
        {
		  $db->query_write("DELETE FROM ".TABLE_PREFIX."microcms_item_files WHERE id=".intval($key));
		}
	}
    // Redirect back
    if($urlid==1)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=myitems";
    } else {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=approveitems";
    }
    eval(print_standard_redirect('microcms_action_ok', true, true));
}

//  #######################################################################
//  ######################  Confirm Item's Deletion  ######################
//  #######################################################################
if ($_REQUEST['do'] == 'deleteitem')
{
    // Check for access permission
    if(!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microcms_invalid_data', true, true));
    }
    if(!$urlid)
    {
        $urlid = 1;
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microcms_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    // Who is the owner?
    $owner = $item["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["moderate"])))
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Everything is ok, lets prepare the confirmation form
    // Prepare Template
	$templater = vB_Template::create('microcms_delete_item');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("index.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microcms_navbar'], '' => $vbphrase['microcms_deletion_navbar']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('itemid', $item[id]);
    $templater->register('title', $item[title]);
    $templater->register('urlid', $urlid);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ##############################  Delete Item  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'yesdelete')
{
    // Check for access permission
    if(!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microcms_invalid_data', true, true));
    }
    if(!$urlid)
    {
        $urlid = 1;
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microcms_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    // Who is the owner?
    $owner = $item["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["moderate"])))
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Everything is ok, lets start deletion
    // Remove Photos
    $item_photos = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microcms_item_photos WHERE itemid=$itemid");
    while ($photo = $vbulletin->db->fetch_array($item_photos)){
	       $photoname = $photo["photoname"];
           $photoid = $photo["id"];
           unlink("microcms/photos/$photoname");
           unlink("microcms/photos/thumbs/$photoname");
           $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "microcms_item_photos
	    			                    WHERE id = $photoid");
    }
    // Remove Attachments
    $item_attachments = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microcms_item_files WHERE itemid=$itemid");
    while ($attachment = $vbulletin->db->fetch_array($item_attachments)){
	       $attachment_name = $attachment["filename"];
           $attachment_id = $attachment["id"];
           unlink("microcms/files/$attachment_name");
           $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "microcms_item_files
	    			                    WHERE id = $attachment_id");
    }
    // and finally let's remove the Article
    $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "microcms_items WHERE id = $itemid");
    // Redirect back
    if($urlid==1)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=myitems";
    } else {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=approveitems";
    }
    eval(print_standard_redirect('microcms_action_ok', true, true));
}


//  #######################################################################
//  ###############################  View Item  ###########################
//  #######################################################################
if ($_REQUEST['do'] == 'viewitem')
{
    // Check for access permission
    if(!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["access"]))
    {
         print_no_permission();
    }
    // Build Categories Menu
    $catid = 0;
    $listcategories = getCategories($catid);
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    if(!$itemid)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microcms_invalid_data', true, true));
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microcms_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    if(!$item)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microcms_invalid_data', true, true));
    }
    // Get Author's data
    $authorid = getRecordById("user",$item["userid"],"userid");
    $author = $authorid["username"];
    // Format Bodytext
	require_once(DIR . '/includes/class_bbcode.php');
	$bbcode_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
	$bodytext = $bbcode_parser->do_parse($item['bodytext'], false, true, true, true, true, $cachable);
    // Format Values
    $created = date($vbulletin->options['microcms_dateformat'], $item[created]);
    if($item["updated"]>0)
    {
       $updated = date($vbulletin->options['microcms_dateformat'], $item[updated]);
    } else {
       $updated = 0;
    }
    // Get Item Photos
    $item_photos = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_item_photos WHERE itemid=$itemid");
    $totalphotos = $db->num_rows($item_photos);
    while($item_photo = $db->fetch_array($item_photos)) {
          $templater = vB_Template::create('microcms_view_item_gallery');
	      $templater->register('photo_id', $item_photo[id]);
		  $templater->register('photo_itemid', $item_photo[itemid]);
		  $templater->register('photo_photoname', $item_photo[photoname]);
          $templater->register('photo_title', $item_photo[title]);
		  $templater->register('photo_istitlephoto', $item_photo[istitlephoto]);
		  $view_item_gallery .= $templater->render();
    }
    // Get Item Files
    $item_files = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_item_files WHERE itemid=$itemid");
    $totalfiles = $db->num_rows($item_files);
    while($item_file = $db->fetch_array($item_files)) {
          $templater = vB_Template::create('microcms_view_item_attachments');
	      $templater->register('file_id', $item_file[id]);
		  $templater->register('file_itemid', $item_file[itemid]);
		  $templater->register('file_filename', $item_file[filename]);
          $templater->register('file_title', $item_file[title]);
		  $view_item_attachments .= $templater->render();
	}
    $catid = $item["categoryid"];
    // Newest Articles
    $newests_articles = getNewest($catid);
    // Forums
    $forum_block = getForums();
    // Sticky Threads
    $sticky_threads = getSticky();
    // Latest Threads
    $latest_threads = getLatest();
    // Popular Threads
    $popular_threads = getPopular();
    // Custom Navbar
    $mynavbar = '';
    $mynavbar = getMyNavBar($mynavbar, $catid);
    // Prepare Template
	$templater = vB_Template::create('microcms_view_item');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("index.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microcms_navbar'],''.$mynavbar.'', '' => $item['title']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('id', $item[id]);
    $templater->register('authorid', $item[userid]);
    $templater->register('author', $author);
    $templater->register('title', $item[title]);
    $templater->register('description', $item[description]);
    $templater->register('bodytext', $bodytext);
    $templater->register('created', $created);
    $templater->register('updated', $updated);
    $templater->register('item_gallery', $view_item_gallery);
    $templater->register('totalphotos', $totalphotos);
    $templater->register('main_photo', $main_photo);
    $templater->register('item_attachments', $view_item_attachments);
    $templater->register('totalfiles', $totalfiles);
    $templater->register('newest_items', $newest_items);
    $templater->register('forum_items', $forum_items);
    $templater->register('sticky', $sticky);
    $templater->register('latest', $latest);
    $templater->register('popular', $popular);
    $templater->register('isadmin', $isadmin);
    $templater->register('categories', $categories);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}


//  #######################################################################
//  #########################  Hide/Unhide Item  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'changestatus')
{
    // Check for access permission
    if(!($permissions["microcms"] & $vbulletin->bf_ugp["microcms"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    $typeid = $vbulletin->input->clean_gpc('r', 'typeid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microcms_invalid_data', true, true));
    }
    // Then, check for missing vales
    if(!$typeid)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microcms_invalid_data', true, true));
    }
    // Find Item
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microcms_items WHERE id=$itemid LIMIT 1");
    $item = $db->fetch_array($qry);
    // Who is the owner?
    $owner = $item["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if($owner != $vbulletin->userinfo['userid'])
    {
        // Check failed. Send him back
        print_no_permission();
    }
    if($typeid==1)
    {
       $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microcms_items SET hidden=1 WHERE id=$itemid");
    }
    if($typeid==2)
    {
       $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microcms_items SET hidden=0 WHERE id=$itemid");
    }
    $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=myitems";
    eval(print_standard_redirect('microcms_action_ok', true, true));
}

//  #######################################################################
//  ##############################  My Items  #############################
//  #######################################################################
if ($_REQUEST['do'] == 'myitems'){
    global $sql;
    // Clean Post Values
    $vbulletin->input->clean_array_gpc('r', array(
        'userid'   => TYPE_INT,
	));
    // Get Values
    $userid = $vbulletin->userinfo['userid'];
    // Lets start query with some standards
    $sql = "SELECT * FROM ".TABLE_PREFIX."microcms_items WHERE userid=$userid ORDER BY created DESC";
    // Count records for pagination
    $totalarticles = $db->query_read($sql);
    $records = $db->num_rows($totalarticles);
    $perpage= $vbulletin->options['microcms_perpage'];
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    if (empty($pagenumber))
    {
        $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
    $limitupper = ($pagenumber) * $perpage;
    $counter = 0;
    if ($limitupper > $records)
	{
	    $limitupper = $records;
        if ($limitlower > $records)
	    {
	        $limitlower = $records-$perpage;
	    }
	}
	if ($limitlower <= 0)
	{
	    $limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'index.php?' . $vbulletin->session->vars['sessionurl'] . 'do=myitems');
    // We must add limit to sql
    $sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
    // Execute Query
    $articles = $db->query_read($sql);
    // Build Articles Bits
    while ($article = $vbulletin->db->fetch_array($articles)){
           // Format Values
           $created = date($vbulletin->options['microcms_dateformat'], $article[created]);
           if($article["updated"]>0)
           {
              $updated = date($vbulletin->options['microcms_dateformat'], $article[updated]);
           } else {
              $updated = 0;
           }
           // Prepare Templates
	       $templater = vB_Template::create('microcms_my_items_bit');
		   $templater->register('article_id', $article[id]);
		   $templater->register('article_title', $article[title]);
           $templater->register('article_created', $created);
           $templater->register('article_updated', $updated);
           $templater->register('article_hidden', $article[hidden]);
		   $my_items_bit .= $templater->render();
    }
    $catid = 0;
    // Build Categories Menu
    $listcategories = getCategories($catid);
    // Forums
    $forum_block = getForums();
    // Sticky Threads
    $sticky_threads = getSticky();
    // Latest Threads
    $latest_threads = getLatest();
    // Popular Threads
    $popular_threads = getPopular();
    // Page Templates
	$templater = vB_Template::create('microcms_my_items');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("index.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['microcms_navbar'], '' => $vbphrase['microcms_my_items']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('my_items_bit', $my_items_bit);
    $templater->register('pagenav', $pagenav);
    $templater->register('forum_items', $forum_items);
    $templater->register('sticky', $sticky);
    $templater->register('latest', $latest);
    $templater->register('popular', $popular);
    $templater->register('categories', $categories);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ############################  Approve Listing  ########################
//  #######################################################################
if ($_REQUEST['do'] == 'approveitems'){
    global $sql;
    // Check for permissions
    if(!($permissions['microcms'] & $vbulletin->bf_ugp['microcms']['moderate'])){
         print_no_permission();
    }
    // Lets start query with some standards
    $sql = "SELECT * FROM ".TABLE_PREFIX."microcms_items WHERE active=0 ORDER BY created ASC";
    // Count records for pagination
    $totalarticles = $db->query_read($sql);
    $records = $db->num_rows($totalarticles);
    $perpage= $vbulletin->options['microcms_perpage'];
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    if (empty($pagenumber))
    {
        $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
    $limitupper = ($pagenumber) * $perpage;
    $counter = 0;
    if ($limitupper > $records)
	{
	    $limitupper = $records;
        if ($limitlower > $records)
	    {
	        $limitlower = $records-$perpage;
	    }
	}
	if ($limitlower <= 0)
	{
	    $limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'index.php?' . $vbulletin->session->vars['sessionurl'] . 'do=approveitems');
    // We must add limit to sql
    $sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
    // Execute Query
    $articles = $db->query_read($sql);
    // Build Articles Bits
    while ($article = $vbulletin->db->fetch_array($articles)){
           $article_created = date($vbulletin->options['microcms_dateformat'], $article[ends]);
           $author_id = $article["userid"];
           $author_name = getRecordById("user",$author_id,"userid");
           $article_author = $author_name["username"];
           if($article["updated"]>0)
           {
              $article_updated = date($vbulletin->options['microcms_dateformat'], $article[updated]);
           } else {
              $article_updated = 0;
           }
           // Prepare Templates
	       $templater = vB_Template::create('microcms_approve_items_bit');
		   $templater->register('article_id', $article[id]);
		   $templater->register('article_title', $article[title]);
           $templater->register('article_author', $article_author);
           $templater->register('article_created', $article_created);
           $templater->register('article_updated', $article_updated);
		   $approve_items_bit .= $templater->render();
    }
    // Page Templates
	$templater = vB_Template::create('microcms_approve_items');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("index.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['microcms_navbar'], '' => $vbphrase['microcms_approve_items']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('approve_items_bit', $approve_items_bit);
    $templater->register('pagenav', $pagenav);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

//  #######################################################################
//  ###############################  Approve Item  ########################
//  #######################################################################
if ($_REQUEST['do'] == 'yesapprove'){

    // Check for permissions
    if(!($permissions['microcms'] & $vbulletin->bf_ugp['microcms']['moderate'])){
         print_no_permission();
    }
    // Clean input
    $itemid = $vbulletin->input->clean_gpc('r', 'itemid', TYPE_UINT);
    // Then, check for missing vales
    if(!$itemid)
    {
      $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microcms_invalid_data', true, true));
    }
    // Approve Item
    $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microcms_items SET active=1 WHERE id=$itemid");
    $vbulletin->url="index.php?" . $vbulletin->session->vars['sessionurl'] . "do=approveitems";
    eval(print_standard_redirect('microcms_action_ok', true, true));
}
?>
