<?php
/////////////////////// Categories /////////////////////////////////////////////
// Top Posters this week
function getTopThisWeek()
{
  global $db, $vbulletin, $top_this_week, $top_this_week_bit;

  // Get Maximum
  $maximum_top_this_week = $vbulletin->options["microcms_max_topthisweek"];
  // Current Week Top Posters
  $starttime = mktime(0, 0, 0, date('n'), date('j'), date('Y')) - ((date('N')-1)*3600*24);
  // Get Top Members for current week
  $mostactiveweek_get = vB::$db->query_read("
    SELECT ".TABLE_PREFIX."user.userid, ".TABLE_PREFIX."user.username, ".TABLE_PREFIX."user.usertitle,
  	  COUNT(".TABLE_PREFIX."post.postid) AS postcount
    FROM ".TABLE_PREFIX."user
  	  LEFT JOIN ".TABLE_PREFIX."post
  	   ON ".TABLE_PREFIX."post.userid=".TABLE_PREFIX."user.userid
       AND dateline>$starttime
    WHERE usergroupid=2
  	GROUP BY ".TABLE_PREFIX."user.userid
  	ORDER BY postcount DESC
  	LIMIT $maximum_top_this_week");
  $topposter = true;
  while($user = vB::$db->fetch_array($mostactiveweek_get))
  {
        if($topposter == true)
        {
           $avatarurl = fetch_avatar_url($user[userid]);
           if (!$avatarurl) {
   	           $useravatar = 'images/misc/avatar.png';
           } else 	{
  	           $useravatar = $avatarurl[0];
           }
           $topposter = false;
        } else {
           $useravatar = '';
        }
        $templater = vB_Template::create('microcms_top_this_week_bit');
		$templater->register('top_this_week_avatar', $useravatar);
        $templater->register('top_this_week_userid', $user[userid]);
        $templater->register('top_this_week_username', $user[username]);
        $templater->register('top_this_week_usertitle', $user[usertitle]);
        $templater->register('top_this_week_posts', $user[postcount]);
		$top_this_week_bit .= $templater->render();
  }
  $templater = vB_Template::create('microcms_top_this_week');
  $templater->register('top_this_week_bit', $top_this_week_bit);
  $top_this_week .= $templater->render();
  return;
}


// Top Posters Last week
function getTopLastWeek()
{
  global $db, $vbulletin, $top_last_week, $top_last_week_bit;

  // Get Maximum
  $maximum_top_last_week = $vbulletin->options["microcms_max_topthisweek"];
  // Current Week Top Posters
  $starttime = mktime(0, 0, 0, date('n'), date('j'), date('Y')) - ((date('N')-1)*3600*24);
  $endtime = mktime(23, 59, 59, date('n'), date('j'), date('Y')) - ((date('N'))*3600*24);
  // Get Top Members for current week
  $mostactiveweek_get = vB::$db->query_read("
    SELECT ".TABLE_PREFIX."user.userid, ".TABLE_PREFIX."user.username, ".TABLE_PREFIX."user.usertitle,
  	  COUNT(".TABLE_PREFIX."post.postid) AS postcount
    FROM ".TABLE_PREFIX."user
  	  LEFT JOIN ".TABLE_PREFIX."post
  	   ON ".TABLE_PREFIX."post.userid=".TABLE_PREFIX."user.userid
       AND dateline>$starttime AND dateline<$endtime
    WHERE usergroupid=2
  	GROUP BY ".TABLE_PREFIX."user.userid
  	ORDER BY postcount DESC
  	LIMIT $maximum_top_last_week");
  $topposter = true;
  while($user = vB::$db->fetch_array($mostactiveweek_get))
  {
        if($topposter == true)
        {
           $avatarurl = fetch_avatar_url($user[userid]);
           if (!$avatarurl) {
   	           $useravatar = 'images/misc/avatar.png';
           } else 	{
  	           $useravatar = $avatarurl[0];
           }
           $topposter = false;
        } else {
           $useravatar = '';
        }
        $templater = vB_Template::create('microcms_top_last_week_bit');
		$templater->register('top_last_week_avatar', $useravatar);
        $templater->register('top_last_week_userid', $user[userid]);
        $templater->register('top_last_week_username', $user[username]);
        $templater->register('top_last_week_usertitle', $user[usertitle]);
        $templater->register('top_last_week_posts', $user[postcount]);
		$top_last_week_bit .= $templater->render();
  }
  $templater = vB_Template::create('microcms_top_last_week');
  $templater->register('top_last_week_bit', $top_last_week_bit);
  $top_last_week .= $templater->render();
  return;
}


// Sticky Threads
function getSticky()
{
  global $db, $vbulletin, $sticky, $sticky_bit;

  // Get Defaults
  $maximum_sticky = $vbulletin->options["microcms_max_sticky"];
  $dateformat = $vbulletin->options["microcms_dateformat"];
  // Query
  $sticky_get = vB::$db->query_read("
    SELECT * FROM ".TABLE_PREFIX."thread
    WHERE visible=1 AND sticky=1
  	ORDER BY dateline DESC
  	LIMIT $maximum_sticky");

  while($sticky = $db->fetch_array($sticky_get))
  {
        $stickydate = date($dateformat, $sticky[dateline]);
        $templater = vB_Template::create('microcms_sticky_bit');
        $templater->register('sticky_userid', $sticky[postuserid]);
        $templater->register('sticky_username', $sticky[postusername]);
        $templater->register('sticky_threadid', $sticky[threadid]);
        $templater->register('sticky_title', $sticky[title]);
        $templater->register('sticky_date', $stickydate);
		$sticky_bit .= $templater->render();
  }
  $templater = vB_Template::create('microcms_sticky');
  $templater->register('sticky_bit', $sticky_bit);
  $sticky .= $templater->render();
  return;
}

// Latest Threads
function getLatest()
{
  global $db, $vbulletin, $latest, $latest_bit;

  // Get Defaults
  $maximum_latest = $vbulletin->options["microcms_max_latest"];
  $dateformat = $vbulletin->options["microcms_dateformat"];
  // Query
  $latest_get = $db->query_read("
    SELECT * FROM ".TABLE_PREFIX."thread
    WHERE visible=1 AND sticky=0
  	ORDER BY dateline DESC
  	LIMIT $maximum_latest");

  while($latest = $db->fetch_array($latest_get))
  {
        $latestdate = date($dateformat, $latest[dateline]);
        $templater = vB_Template::create('microcms_latest_bit');
        $templater->register('latest_userid', $latest[postuserid]);
        $templater->register('latest_username', $latest[postusername]);
        $templater->register('latest_threadid', $latest[threadid]);
        $templater->register('latest_title', $latest[title]);
        $templater->register('latest_date', $latestdate);
		$latest_bit .= $templater->render();
  }
  $templater = vB_Template::create('microcms_latest');
  $templater->register('latest_bit', $latest_bit);
  $latest .= $templater->render();
  return;
}

// Popular Threads
function getPopular()
{
  global $db, $vbulletin, $popular, $popular_bit;

  // Get Defaults
  $maximum_popular = $vbulletin->options["microcms_max_popular"];
  $dateformat = $vbulletin->options["microcms_dateformat"];
  // Query
  $popular_get = $db->query_read("
    SELECT * FROM ".TABLE_PREFIX."thread
    WHERE visible=1 AND sticky=0
  	ORDER BY replycount DESC
  	LIMIT $maximum_popular");

  while($popular = $db->fetch_array($popular_get))
  {
        $populardate = date($dateformat, $popular[dateline]);
        $templater = vB_Template::create('microcms_popular_bit');
        $templater->register('popular_userid', $popular[postuserid]);
        $templater->register('popular_username', $popular[postusername]);
        $templater->register('popular_threadid', $popular[threadid]);
        $templater->register('popular_title', $popular[title]);
        $templater->register('popular_date', $populardate);
		$popular_bit .= $templater->render();
  }
  $templater = vB_Template::create('microcms_popular');
  $templater->register('popular_bit', $popular_bit);
  $popular .= $templater->render();
  return;
}

// Just Join
function getJustJoin()
{
  global $db, $vbulletin, $just_join, $just_join_bit;

  // Get Defaults
  $maximum_just_join = $vbulletin->options["microcms_max_justjoin"];
  $shortdate = $vbulletin->options["microcms_short_dateformat"];
  // Run query
  $newusers_get = vB::$db->query_read("
    SELECT * FROM ".TABLE_PREFIX."user
    WHERE usergroupid=2
  	ORDER BY joindate DESC
  	LIMIT $maximum_just_join");
  while($user = vB::$db->fetch_array($newusers_get))
  {
        $joindate = date($shortdate, $user[joindate]);
        $templater = vB_Template::create('microcms_just_join_bit');
        $templater->register('just_join_userid', $user[userid]);
        $templater->register('just_join_username', $user[username]);
        $templater->register('just_join_date', $joindate);
		$just_join_bit .= $templater->render();
  }
  $templater = vB_Template::create('microcms_just_join');
  $templater->register('just_join_bit', $just_join_bit);
  $just_join .= $templater->render();
  return;
}

// Get Premium Items
function getPremium($catid)
{
    global $db, $vbulletin, $premium_items, $premium_items_bit, $catid;

    if (empty($catid))
    {
        $catid = 0;
    }
    $mainphotowidth= $vbulletin->options['microcms_main_photo_width'];
    // Premium Classifieds
    $maximum_premium = $vbulletin->options["microcms_premium_items"];
    $sql_premium = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_items WHERE categoryid=$catid AND active=1 AND premium=1 AND hidden=0 ORDER BY created DESC LIMIT $maximum_premium");
    $total_premium = $db->num_rows($sql_premium);
    if($total_premium == 0)
    {
       $sql_premium = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_items WHERE active=1 AND premium=1 AND hidden=0 ORDER BY created DESC LIMIT $maximum_premium");
    }
    while($premium = $db->fetch_array($sql_premium)) {
          $current_premium = $premium["id"];
          $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microcms_item_photos WHERE itemid=$current_premium AND istitlephoto=1");
          if(!$photo)
          {
              $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microcms_item_photos WHERE itemid=$current_premium");
          }
		  if($photo)
          {
		     $premium_photo = $photo["photoname"];
          } else {
             $premium_photo = '';
          }
		  $templater = vB_Template::create('microcms_premium_items_bit');
		  $templater->register('premium_title', $premium[title]);
		  $templater->register('premium_id', $premium[id]);
		  $templater->register('premium_photo', $premium_photo);
          $templater->register('premium_description', $premium[description]);
          $templater->register('main_photo_width', $mainphotowidth);
		  $premium_items_bit .= $templater->render();
    }
    $templater = vB_Template::create('microcms_premium_items');
    $templater->register('premium_items_bit', $premium_items_bit);
    $premium_items .= $templater->render();
    return;
}

// Get Highlight Items
function getHighlight($catid)
{
    global $db, $vbulletin, $highlight_items, $highlight_items_bit, $catid;

    if (empty($catid))
    {
        $catid = 0;
    }
    // Premium Classifieds
    $maximum_highlight = $vbulletin->options["microcms_highlight_items"];
    $blockwidth = 100 / $maximum_highlight;
    $blockwidth = $blockwidth.'%';
    $sql_highlight = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_items WHERE categoryid=$catid AND active=1 AND highlight=1 AND hidden=0 ORDER BY created DESC LIMIT $maximum_highlight");
    $total_highlight = $db->num_rows($sql_highlight);
    if($total_highlight == 0)
    {
       $sql_highlight = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_items WHERE active=1 AND highlight=1 AND hidden=0 ORDER BY created DESC LIMIT $maximum_highlight");
    }
    while($highlight = $db->fetch_array($sql_highlight)) {
          $current_highlight = $highlight["id"];
          $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microcms_item_photos WHERE itemid=$current_highlight AND istitlephoto=1");
          if(!$photo)
          {
              $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microcms_item_photos WHERE itemid=$current_highlight");
          }
		  if($photo)
          {
		     $highlight_photo = $photo["photoname"];
          } else {
             $highlight_photo = '';
          }
		  $templater = vB_Template::create('microcms_highlight_items_bit');
		  $templater->register('highlight_title', $highlight[title]);
		  $templater->register('highlight_id', $highlight[id]);
		  $templater->register('highlight_photo', $highlight_photo);
          $templater->register('blockwidth', $blockwidth);
		  $highlight_items_bit .= $templater->render();
    }
    $templater = vB_Template::create('microcms_highlight_items');
    $templater->register('highlight_items_bit', $highlight_items_bit);
    $highlight_items .= $templater->render();
    return;
}

// Get Newest Items
function getNewest($catid)
{
    global $db, $vbulletin, $newest_items, $newest_items_bit, $newest_items_bit_bit;

    if (empty($catid))
    {
        $catid = 0;
    }
    // Newest Items
    $maximum_newest = $vbulletin->options["microcms_newest_items"];
    $sql_newest = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_categories WHERE parentid=$catid ORDER BY displayorder ASC");
    $totalcats = $db->num_rows($sql_newest);
    if($totalcats==0)
    {
       $sql_newest = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_categories WHERE id=$catid ORDER BY displayorder ASC");
    }
    $activecategory = 0;
    while($newest = $db->fetch_array($sql_newest)) {
          $activecategory = $newest["id"];
          $sql_newest_bit = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_items WHERE categoryid=$activecategory AND active=1 AND hidden=0 ORDER BY created DESC LIMIT $maximum_newest");
          while($newest_bit = $db->fetch_array($sql_newest_bit)) {
                $templater = vB_Template::create('microcms_newest_items_bit_bit');
		        $templater->register('newest_bit_id', $newest_bit[id]);
		        $templater->register('newest_bit_title', $newest_bit[title]);
		        $newest_items_bit_bit .= $templater->render();
          }
		  $templater = vB_Template::create('microcms_newest_items_bit');
		  $templater->register('newest_id', $newest[id]);
		  $templater->register('newest_name', $newest[name]);
          $templater->register('newest_items_bit_bit', $newest_items_bit_bit);
          $newest_items_bit .= $templater->render();
          $newest_items_bit_bit = '';
    }
    $templater = vB_Template::create('microcms_newest_items');
    $templater->register('newest_items_bit', $newest_items_bit);
    $newest_items .= $templater->render();
    return;
}

// Get Forums
function getForums()
{
    global $db, $vbulletin, $forum_items, $forum_items_bit, $forum_items_bit_bit, $changeline;

    $maximum_forum = $vbulletin->options["microcms_max_forums"];
    $sql_forum = $db->query_read("SELECT * FROM ".TABLE_PREFIX."forum WHERE parentid=-1 ORDER BY displayorder ASC, forumid ASC");
    $activeforum = 0;
    $changeline = 0;
    $totalrecords = 0;
    $maxblocks = $vbulletin->options["microcms_blocks"];
    $blockwidth = 100 / $maxblocks;
    $blockwidth = $blockwidth.'%';
    while($forum = $db->fetch_array($sql_forum)) {
          $activeforum = $forum["forumid"];
          $sql_forum_bit = $db->query_read("SELECT * FROM ".TABLE_PREFIX."forum WHERE parentid=$activeforum ORDER BY displayorder ASC, forumid ASC LIMIT $maximum_forum");
          while($forum_bit = $db->fetch_array($sql_forum_bit)) {
                $templater = vB_Template::create('microcms_forum_items_bit_bit');
		        $templater->register('forum_bit_id', $forum_bit[forumid]);
		        $templater->register('forum_bit_title', $forum_bit[title]);
		        $forum_items_bit_bit .= $templater->render();
          }
          $totalrecords ++;
          if($totalrecords==$maxblocks)
          {
             $totalrecords = 0;
             $changeline = 1;
          } else {
             $changeline = 0;
          }
		  $templater = vB_Template::create('microcms_forum_items_bit');
		  $templater->register('forum_id', $forum[forumid]);
		  $templater->register('forum_title', $forum[title]);
          $templater->register('forum_items_bit_bit', $forum_items_bit_bit);
          $templater->register('changeline', $changeline);
          $templater->register('blockwidth', $blockwidth);
          $forum_items_bit .= $templater->render();
          $forum_items_bit_bit = '';
    }
    $templater = vB_Template::create('microcms_forum_items');
    $templater->register('maxblocks', $maxblocks);
    $templater->register('forum_items_bit', $forum_items_bit);
    $forum_items .= $templater->render();
    return;
}


// Save New Category
function SaveCategory($catid)
{
    global $db, $vbulletin, $catid;
    // Let's clean inputs
    $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("INSERT INTO ". TABLE_PREFIX ."microcms_categories
                      SET name='$name',
                          displayorder='0',
                          parentid='$catid'");
    $newid = $db->insert_id();

    return $catid;
}
// Remove Category and Subcategories
function DeleteCategory($catid)
{
  global $db, $vbulletin, $catid;
  // Now, let's remove Category
  $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microcms_categories WHERE id=$catid");
  $parentid = $category["parentid"];
  // Remove subcategories too
  $deletedId = array();
  _getChildId($deletedId, $catid);
  $idList = "'". implode("','", $deletedId)."'";
  $db->query_write("DELETE FROM ". TABLE_PREFIX ."microcms_categories WHERE id IN ($idList)");
  // Go back
  $catid = $parentid;
  return $catid;
}
// Get Subcategories
function _getChildId(&$outArray, $parentId) {
	global $db, $vbulletin, $catid;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."microcms_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subcategories)) {
			_getChildId($outArray, $category['id']);
	}
}
// Update Category
function UpdateCategory($catid)
{
    global $db, $vbulletin, $catid;
    $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $parentid = $vbulletin->input->clean_gpc('r', 'parentid', TYPE_UINT);
    $db->query_write("UPDATE ". TABLE_PREFIX ."microcms_categories
                      SET name='$name' WHERE id=$catid");
    // Go Back
    $catid = $parentid;
    return $catid;
}
// Update display order for Categories
function UpdateCategoriesOrder($catid)
{
  global $db, $vbulletin, $catid;
  $display = $_REQUEST["display"];
  $keys = array_keys($display);
  foreach($keys as $idx) {
    $order = $display[$idx];
    $db->query_write("UPDATE ".TABLE_PREFIX."microcms_categories SET displayorder=$order WHERE id=$idx");
  }
  $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
  return $catid;
}



function getCategories($catid)
{
  global $db, $vbphrase, $catid, $categories, $categories_bit, $total_articles;
  $vcategories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
  $activecategory = 0;
  while($category = $db->fetch_array($vcategories)) {
        $activecategory = $category["id"];
        $total_articles = getCountRecords($activecategory);
		$templater = vB_Template::create('microcms_categories_bit');
		$templater->register('category_id', $category[id]);
		$templater->register('category_name', $category[name]);
        $templater->register('total_articles', $total_articles);
		$categories_bit .= $templater->render();
  }
  $templater = vB_Template::create('microcms_categories');
  $templater->register('categories_bit', $categories_bit);
  $categories .= $templater->render();
  return;
}

function getCountRecords($activecategory)
{
  global $db, $vbulletin, $catid, $totalarticles;
  $totalarticles = 0;
  $get_records = '';
  $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microcms_categories WHERE id='$activecategory' LIMIT 1");
  $parentid = $category["parentid"];
  // Remove subcategories too
  $deletedId = array();
  _getCountChild($deletedId, $activecategory);
  $idList = "'". implode("','", $deletedId)."'";
  $get_records = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."microcms_items WHERE categoryid IN ($idList) AND active=1");
  $totalarticles = $db->num_rows($get_records);
  // Go back
  $activecategory = $parentid;
  return $totalarticles;
}

function _getCountChild(&$outArray, $parentId) {
	global $db, $vbulletin, $activecategory;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."microcms_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subcategories)) {
			_getCountChild($outArray, $category['id']);
	}
}

// Get Classifieds Custom NavBar
function getMyNavBar(&$output, $catid) {
	global $db, $vbulletin, $output, $url;
	if($catid < 0) {
		$output = '';
		return $output;
	}
    $arrow_icon = '<img border="0" src="microcms/images/navbit-arrow.png">';
	$qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_categories WHERE id = $catid");
	$row = $db->fetch_array($qry);
	$url = 'index.php?do=main&catid='.$row['id'];
	if(trim($output) == '')
    {
		$output = '<a href="'.$url.'">'.$row['name'].'</a>';
	} else {
		$output = '<a href="'.$url.'">'.$row['name'].'</a>&nbsp;&nbsp;'.$arrow_icon.'&nbsp;&nbsp;'.$output;
    }
	//- still have parents?
	if($row['parentid'] != 0) {
		getClassifiedsNavBar($output, $row['parentid']);
	} else {
		$output = $output;
	}
    return $output;
}


function getRecordById($tablename, $id, $rowname = 'id')
{
  global $db, $vbulletin;
  $result = $db->query_read("SELECT * FROM ".TABLE_PREFIX."".$tablename." WHERE ".$rowname."=".$id." LIMIT 1");
  if(!$result) return array ("id" => 0, "name" => '');
  if($db->num_rows($result) == 0) return array ("id" => 0, "name" => '');
  $ret = array();
  while($row = $db->fetch_array($result)) {
    $ret = $row;
  }
  $db->free_result($result);
  return $ret;
}




class SelectCategory {

	var $Name;
	var $SelectedId;
	var $IsMultiple;
	var $MultipleSize;
	var $ClassName;
	var $Id;
	var $Style;
	var $RootId;

	var $output;
	var $srcTable;
	var $firstOption;
	var $attributes;

	function SelectCategory($name, $table) {
		$this->Name = $name;
		$this->SelectedId = '';
		$this->IsMultiple = false;
		$this->MultipleSize = 5;
		$this->FirstOption = array('value' => '', 'text' => '');
		$this->ClassName = '' ;
		$this->Id = '';
		$this->Style = '';
		$this->RootId = 0;

		$this->output = '';
		$this->srcTable = $table;
	}

	function Output() {
		$options = '';
		$this->_getCategory($options, $this->RootId);

		$attributes = $this->_getAttributes();

		$output = '<select '.$attributes.'>'.$options.'</select>';

		return $output;
	}

	function SetFirstOption($text, $value) {
		$this->firstOption = array('value' => '', 'text' => '');
		$this->firstOption['value']	= $value;
		$this->firstOption['text'] = $text;
	}

	function SetMultiple($active, $rows) {
		$this->IsMultiple = $active;
		$this->MultipleSize = $rows;
	}

    function SetStyle($value)
    {
        $this->Style = $value;
    }

	function SetSelected($catid) {
		$this->SelectedId = $catid;
	}

	function _getAttributes() {
		$tmpAtt = array();

		$tmpAtt[] = 'name="'.$this->Name.'"';

		if($this->IsMultiple)
			$tmpAtt[] = 'multiple size="'.$this->MultipleSize.'"';

		if(trim($this->ClassName) != '')
			$tmpAtt[] = 'class="'.$this->ClassName.'"';

		if(trim($this->Style) != '')
			$tmpAtt[] = 'style="'.$this->Style.'"';

		if(count($tmpAtt) > 0)
        {
			$return = implode(', ', $tmpAtt);
		} else {
			$return = '';
        }
		return $return;
	}

	function _getCategory(&$options, $rootId, $level = 0) {
    global $db, $vbulletin, $catid;
		if(is_array($this->firstOption) && trim($options) == '') {
			$options .= '<option value="'.$this->firstOption['value'].'">'.
						$this->firstOption['text'].'</option>';
		}

		$qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_categories WHERE parentid=$rootId ORDER BY displayorder ASC, name ASC");
			while($row = $db->fetch_array($qry)) {
              if(is_array($this->SelectedId))
              {
				if(in_array($row['id'],$this->SelectedId))
                {
					$selected = ' selected';
				} else {
					$selected = '';
                }
              } else {
        		if($row['id'] == $this->SelectedId)
                {
            	    $selected = ' selected';
				} else {
					$selected = '';
                }
              }
				$options .= '<option value="'.$row['id'].'" '.$selected.'>'.str_repeat('&nbsp;', $level*4).'- '.$row['name']."</option>\n";
				$this->_getCategory($options, $row['id'], $level+1);
			}

	}

}





function parseBbCode($bbcode, $limit = 0)
{
  global $vbulletin;
  require_once(DIR . '/includes/class_bbcode.php');
  $parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
  $text = $parser->do_parse($bbcode);
  if($limit != 0) {
  	if(strlen($text) > $limit)
  		$text = substr($text, 0, $limit).' ...';
  	}
    return $text;
}


// Function to get the extension a file.
function get_ext($key) {
	$key=strtolower(substr(strrchr($key, "."), 1));
	// Cause there the same right?
	$key=str_replace("jpeg","jpg",$key);
	return $key;
}


function fileExtension($filename)
{
  $path_info = pathinfo($filename);
  return $path_info['extension'];
}

function processUploadedPhoto($tmpfilename, $name, $existingfilename, $maxwidth = 0, $maxheigth = 0, $maxthumbwidth = 0, $maxthumbheigth = 0)
{
  global $db, $vbulletin;
  $image = &vB_Image::fetch_library($vbulletin);
  $imageinfo = $image->fetch_image_info($tmpfilename);
  if(!$imageinfo)
  {
     return "";
  }
  if(!empty($existingfilename))
  {
     @unlink(DIR . '/microcms/photos/' . $existingfilename);
     @unlink(DIR . '/microcms/photos/thumbs/' . $existingfilename);
  }
  $filename = md5(time() + rand()).'.'.fileExtension($name);
  if($imageinfo[0] > $maxwidth || $imageinfo[1] > $maxheight)
  {
     if($image->is_valid_resize_type($imageinfo[2]))
     {
        move_uploaded_file($tmpfilename, DIR . '/microcms/photos/tmp/' . $filename);
        $resized = $image->fetch_thumbnail($filename, DIR . '/microcms/photos/tmp/' . $filename, $maxwidth, $maxheight);
        @$file = fopen(DIR . '/microcms/photos/' . $filename, 'w');
        @fwrite($file, $resized["filedata"]);
        @fclose($file);
        @unlink(DIR . '/microcms/photos/tmp/' . $filename);
     } else {
        return "";
     }
  } else {
     move_uploaded_file($tmpfilename, DIR . '/microcms/photos/' . $filename);
  }
  if($imageinfo[0] > $maxthumbwidth || $imageinfo[1] > $maxthumbheight)
  {
   	 $thumb = $image->fetch_thumbnail($filename, DIR . '/microcms/photos/' . $filename, $maxthumbwidth, $maxthumbheight);
     @$file = fopen(DIR . '/microcms/photos/thumbs/' . $filename, 'w');
     @fwrite($file, $thumb["filedata"]);
     @fclose($file);
  } else {
   	 @$file = fopen(DIR . '/microcms/photos/thumbs/' . $filename, 'w');
     @fwrite($file, $image["filedata"]);
     @fclose($file);
  }
  return $filename;
}

function processUploadedFile($tmpfilename, $name, $existingfilename)
{
  global $db, $vbulletin;

  if(!empty($existingfilename))
  {
     @unlink(DIR . '/microcms/files/' . $existingfilename);
  }
  $filename = md5(time() + rand()).'.'.fileExtension($name);
  move_uploaded_file($tmpfilename, DIR . '/microcms/files/' . $filename);

  return $filename;
}


function getCountItemHits($item)
{
  global $db, $vbulletin;
  $totalrecords = 0;
  $result = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microcms_item_hits WHERE itemid=$item");
  $totalrecords = $db->num_rows($result);
  if(!$result)
  {
      $totalrecords = 0;
  }
  return $totalrecords;
}



function getFormatPrice($price)
{
	global $vbulletin;
	$format = $vbulletin->options['microcms_priceformat'];
	switch($format) {
		case 1:
		case 3:
			$printprice = number_format(floatval($price), 2);
			break;
		case 2:
		case 4:
			$printprice = number_format(floatval($price), 0);
			break;
	}
	return $printprice;
}

function time_duration($seconds, $use = null, $zeros = true)
{
   // Define time periods
   $periods = array (
             'years'     => 31556926,
             'Months'    => 2629743,
             'weeks'     => 604800,
             'days'      => 86400,
             'hours'     => 3600,
             'minutes'   => 60,
             'seconds'   => 1
             );
   // Break into periods
   $seconds = (float) $seconds;
   foreach ($periods as $period => $value) {
      if ($use && strpos($use, $period[0]) === false) {
          continue;
      }
      $count = floor($seconds / $value);
      if ($count == 0 && !$zeros) {
          continue;
      }
      $segments[strtolower($period)] = $count;
      $seconds = $seconds % $value;
   }
   // Build the string
   foreach ($segments as $key => $value) {
            $segment_name = substr($key, 0, -1);
            $segment = $value . ' ' . $segment_name;
            if ($value != 1) {
                $segment .= 's';
            }
            $array[] = $segment;
   }
   $str = implode(', ', $array);
   return $str;
}

function time_duration_short($seconds, $use = null, $zeros = false)
{
   // Define time periods
   $periods = array (
             'ye'     => 31556926,
             'Mo'    => 2629743,
             'we'     => 604800,
             'da'      => 86400,
             'ho'     => 3600,
             'mi'   => 60,
             'se'   => 1
             );
   // Break into periods
   $seconds = (float) $seconds;
   foreach ($periods as $period => $value) {
      if ($use && strpos($use, $period[0]) === false) {
          continue;
      }
      $count = floor($seconds / $value);
      if ($count == 0 && !$zeros) {
          continue;
      }
      $segments[strtolower($period)] = $count;
      $seconds = $seconds % $value;
   }
   // Build the string
   foreach ($segments as $key => $value) {
            $segment_name = substr($key, 0, -1);
            $segment = $value . ' ' . $segment_name;
            if ($value != 1) {
                $segment .= 's';
            }
            $array[] = $segment;
   }
   $str = implode(', ', $array);
   return $str;
}
?>
