<?php
/*======================================================================*\
|| #################################################################### ||
|| # Copyright &copy;2009 Quoord Systems Ltd. All Rights Reserved.    # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # This file is part of the Tapatalk package and should not be used # ||
|| # and distributed for any other purpose that is not approved by    # ||
|| # Quoord Systems Ltd.                                              # ||
|| # http://www.tapatalk.com | http://www.tapatalk.com/license.html   # ||
|| #################################################################### ||
\*======================================================================*/
function construct_forum_bit_mobiquo($parentid, $depth = 0, $subsonly = 0)
{
    global $vbulletin, $stylevar, $vbphrase, $show;
    global $imodcache, $lastpostarray, $counters, $inforum;
    $return_forum = array();
    // this function takes the constant MAXFORUMDEPTH as its guide for how
    // deep to recurse down forum lists. if MAXFORUMDEPTH is not defined,
    // it will assume a depth of 2.

    // call fetch_last_post_array() first to get last post info for forums
    if (!is_array($lastpostarray))
    {
        fetch_last_post_array($parentid);
    }
    if (empty($vbulletin->iforumcache["$parentid"]))
    {
        return;
    }

    if (!defined('MAXFORUMDEPTH'))
    {
        define('MAXFORUMDEPTH', 2);
    }
        define('MAXFORUMDEPTH', 2);

    $forumbits = '';
        $return_forumbits = '';
    $depth++;

	//winter001 -start
	$mobiquo_config = new mobiquo_config();
    $config =$mobiquo_config->get_config();
	$hideForumList = explode(",", $config['hide_forum_id']);
	//winter001 -end

    foreach ($vbulletin->iforumcache["$parentid"] AS $forumid)
    {
        // grab the appropriate forum from the $vbulletin->forumcache
        $forum = $vbulletin->forumcache["$forumid"];

		//winter001 -start

		if (in_array($forum['forumid'], $hideForumList)) {
			continue;
		}
		//winter001 -end

        //$lastpostforum = $vbulletin->forumcache["$lastpostarray[$forumid]"];
        $lastpostforum = (empty($lastpostarray[$forumid]) ? array() : $vbulletin->forumcache["$lastpostarray[$forumid]"]);

        if (!$forum['displayorder'] OR !($forum['options'] & $vbulletin->bf_misc_forumoptions['active']))
        {
            continue;
        }

        $forumperms = $vbulletin->userinfo['forumpermissions']["$forumid"];
        $lastpostforumperms = (empty($lastpostarray[$forumid]) ? 0 : $vbulletin->userinfo['forumpermissions']["$lastpostarray[$forumid]"]);
        if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) AND ($vbulletin->forumcache["$forumid"]['showprivate'] == 1 OR (!$vbulletin->forumcache["$forumid"]['showprivate'] AND !$vbulletin->options['showprivateforums'])))
        { // no permission to view current forum
            continue;
        }

        if ($subsonly)
        {
            $childforumbits = construct_forum_bit_mobiquo($forum['forumid'], 1, $subsonly);
        }
        else if ($depth < MAXFORUMDEPTH)
        {
            $childforumbits = construct_forum_bit_mobiquo($forum['forumid'], $depth, $subsonly);
        }
        else
        {
            $childforumbits = '';
        }

        // do stuff if we are not doing subscriptions only, or if we ARE doing subscriptions,
        // and the forum has a subscribedforumid
        if (!$subsonly OR ($subsonly AND !empty($forum['subscribeforumid'])))
        {

            $GLOBALS['forumshown'] = true; // say that we have shown at least one forum

            if (($forum['options'] & $vbulletin->bf_misc_forumoptions['cancontainthreads']))
            { // get appropriate suffix for template name
                $tempext = '_post';
                $only_sub = 0;
                   
            }
            else

            {
                $tempext = '_nopost';
                $only_sub = 1;
            }

            if (!$vbulletin->options['showforumdescription'])
            { // blank forum description if set to not show
                $forum['description'] = '';
            }

            // dates & thread title
            $lastpostinfo = (empty($lastpostarray[$forumid]) ? array() : $vbulletin->forumcache["$lastpostarray[$forumid]"]);

            // compare last post time for this forum with the last post time specified by
            // the $lastpostarray, and if it's less, use the last post info from the forum
            // specified by $lastpostarray
            if (!empty($lastpostinfo) AND $vbulletin->forumcache["$lastpostarray[$forumid]"]['lastpost'] > 0)
            {
                if (!($lastpostforumperms & $vbulletin->bf_ugp_forumpermissions['canview']) OR (!($lastpostforumperms & $vbulletin->bf_ugp_forumpermissions['canviewothers']) AND $lastpostinfo['lastposter'] != $vbulletin->userinfo['username']))
                {
                    $forum['lastpostinfo'] = $vbphrase['private'];
                }
                else
                {
                    $lastpostinfo['lastpostdate'] = vbdate($vbulletin->options['dateformat'], $lastpostinfo['lastpost'], 1);
                    $lastpostinfo['lastposttime'] = vbdate($vbulletin->options['timeformat'], $lastpostinfo['lastpost']);
                    $lastpostinfo['trimthread'] = fetch_trimmed_title(fetch_censored_text($lastpostinfo['lastthread']));

                    if ($lastpostinfo['lastprefixid'] AND $vbulletin->options['showprefixlastpost'])
                    {
                        $lastpostinfo['prefix'] = ($vbulletin->options['showprefixlastpost'] == 2 ?
                            $vbphrase["prefix_$lastpostinfo[lastprefixid]_title_rich"] :
                            htmlspecialchars_uni($vbphrase["prefix_$lastpostinfo[lastprefixid]_title_plain"])
                        );
                    }
                    else
                    {
                        $lastpostinfo['prefix'] = '';
                    }

                    if ($vbulletin->forumcache["$lastpostforum[forumid]"]['options'] & $vbulletin->bf_misc_forumoptions['allowicons'] AND $icon = fetch_iconinfo($lastpostinfo['lasticonid']))
                    {
                        $show['icon'] = true;
                    }
                    else
                    {
                        $show['icon'] = false;
                    }

                    $show['lastpostinfo'] = (!$lastpostforum['password'] OR verify_forum_password($lastpostforum['forumid'], $lastpostforum['password'], false));

//                    eval('$forum[\'lastpostinfo\'] = "' . fetch_template('forumhome_lastpostby') . '";');
                }
            }
            else if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']))
            {
                $forum['lastpostinfo'] = $vbphrase['private'];
            }
            else
            {
                $forum['lastpostinfo'] = $vbphrase['never'];
            }

            // do light bulb
            $forum['statusicon'] = fetch_forum_lightbulb($forumid, $lastpostinfo, $forum);

            // add lock to lightbulb if necessary
            // from 3.6.9 & 3.7.0 we now show locks only if a user can not post AT ALL
            // previously it was just if they could not create new threads
            if (
                $vbulletin->options['showlocks'] // show locks to users who can't post
                AND !$forum['link'] // forum is not a link
                AND
                (
                    !($forum['options'] & $vbulletin->bf_misc_forumoptions['allowposting']) // forum does not allow posting
                    OR
                    (
                            !($forumperms & $vbulletin->bf_ugp_forumpermissions['canpostnew']) // can't post new threads
                        AND !($forumperms & $vbulletin->bf_ugp_forumpermissions['canreplyown']) // can't reply to own threads
                        AND !($forumperms & $vbulletin->bf_ugp_forumpermissions['canreplyothers']) // can't reply to others' threads                       
                    )
                )
            )
            {
                $forum['statusicon'] .= '_lock';
            }

            // get counters from the counters cache ( prepared by fetch_last_post_array() )
            $forum['threadcount'] = $counters["$forum[forumid]"]['threadcount'];
            $forum['replycount'] = $counters["$forum[forumid]"]['replycount'];

            // get moderators ( this is why we needed cache_moderators() )
            if ($vbulletin->options['showmoderatorcolumn'])
            {
                $showmods = array();
                $listexploded = explode(',', $forum['parentlist']);
                foreach ($listexploded AS $parentforumid)
                {
                    if (!isset($imodcache["$parentforumid"]) OR $parentforumid == -1)
                    {
                        continue;
                    }
                    foreach($imodcache["$parentforumid"] AS $moderator)
                    {
                        if (isset($showmods["$moderator[userid]"]))
                        {
                            continue;
                        }



                        $showmods["$moderator[userid]"] = true;

                        $show['comma_leader'] = isset($forum['moderators']);
                        if (!isset($forum['moderators']))
                        {
                            $forum['moderators'] = '';
                        }

                       // eval('$forum[\'moderators\'] .= "' . fetch_template('forumhome_moderator') . '";');
                    }
                }
                if (!isset($forum['moderators']))
                {
                    $forum['moderators'] = '';
                }
            }

            if ($forum['link'])
            {
                $forum['replycount'] = '-';
                $forum['threadcount'] = '-';
                $forum['lastpostinfo'] = '-';
            }
            else
            {
                $forum['replycount'] = vb_number_format($forum['replycount']);
                $forum['threadcount'] = vb_number_format($forum['threadcount']);
            }

            if ($subsonly OR $depth == MAXFORUMDEPTH )
            {
                $forum['subforums'] = construct_subforum_bit_mobiquo($forumid, ($forum['options'] & $vbulletin->bf_misc_forumoptions['cancontainthreads'] ) );
            }
            else
            {
                            $forum['subforums'] ="";
 
            }

            $forum['browsers'] = 0;
            $children = explode(',', $forum['childlist']);
            foreach($children AS $childid)
            {
                $forum['browsers'] += (isset($inforum["$childid"]) ? $inforum["$childid"] : 0);
            }

            if ($depth == 1 AND $tempext == '_nopost')
            {
                global $vbcollapse;
                $collapseobj_forumid =& $vbcollapse["collapseobj_forumbit_$forumid"];
                $collapseimg_forumid =& $vbcollapse["collapseimg_forumbit_$forumid"];
                $show['collapsebutton'] = true;
            }
            else
            {
                $show['collapsebutton'] = false;
            }

            $show['forumsubscription'] = ($subsonly ? true : false);
            $show['forumdescription'] = ($forum['description'] != '' ? true : false);
            $show['subforums'] = ($forum['subforums'] != '' ? true : false);
            $show['browsers'] = ($vbulletin->options['displayloggedin'] AND !$forum['link'] AND $forum['browsers'] ? true : false);
             if(file_exists(CWD1.'/forum_icons/'.$forum[forumid].'.png')){
                   $icon_url = $vbulletin->options[bburl].'/mobiquo/forum_icons/'.$forum[forumid].'.png';
            }
            elseif(file_exists(CWD1.'/forum_icons/default.png')){
            	 $icon_url = $vbulletin->options[bburl].'/mobiquo/forum_icons/default.png';
            }
             else {
            	$icon_url = '';
            }
            $forumbits_list = array('forum_id'=>new xmlrpcval($forum[forumid],"string"),
                                    'forum_name'=>new xmlrpcval(mobiquo_encode($forum[title]),"base64"),
                                     'description'=>new xmlrpcval(mobiquo_encode($forum[description]),"base64"),
                                     'sub_only'   => new xmlrpcval($only_sub,"boolean"),
                                     'parent_id' =>new xmlrpcval($forum[parentid],"string"),
                                     'is_protected' => new xmlrpcval(0,"boolean"),
                                      'logo_url'    => new xmlrpcval($icon_url,'string'),
                                     'url'          => new xmlrpcval($forum[link],"string"),
                                      );

             if($forum[password]) { $forumbits_list[is_protected] =  new xmlrpcval(1,"boolean");
                    }
                             if($childforumbits){
                                   $forumbits_list[child] = new xmlrpcval($childforumbits,"array");

                       }
             if($forum[subforums]){
                                 $forumbits_list[child] = $forum[subforums];
                       } 
                          $return_forumbits[$forum[forumid]]  = new xmlrpcval($forumbits_list,'struct');
        } // end if (!$subsonly OR ($subsonly AND !empty($forum['subscribeforumid'])))
        else
        {
           
             if(empty($forumbits['child'])){
                  
                    $forumbits['child']=  array($childforumbits);
                  
                } else {
                        array_push(    $forumbits['child'],$childforumbits);
               }
        }
    }
    if(is_array($return_forumbits)){
	    return array_values($return_forumbits);
	    } else {
	    return;
    }
}

function construct_subforum_bit_mobiquo($parentid, $cancontainthreads, $output = array(), $depthmark = '--', $depth = 0)
{
    global $vbulletin, $stylevar, $vbphrase;
    global $lastpostinfo, $lastpostarray;
    static $splitter;

    if ($cancontainthreads)
    {
        $canpost = 'post';
        $only_sub = 0;
    }
    else
    {
        $canpost = 'nopost';
            $only_sub = 1;
    }
    // get the splitter template


    if (!isset($vbulletin->iforumcache["$parentid"]))
    { 
       if($output[forum_id]){
        $xmlrpc_output =new xmlrpcval(array('forum_id'=>new xmlrpcval($output[forum_id],"string"),
                                    'forum_name'=>new xmlrpcval(mobiquo_encode($output[forum_name]),"base64"),
                                      'description'=>new xmlrpcval(mobiquo_encode($output[description]),"base64"),
                                       'sub_only'   => new xmlrpcval($output['sub_only'],"boolean"),
                                     'parent_id' =>new xmlrpcval($output[parent_id],"string"),
                                     ),"struct");
       }else {
       // $xmlrpc_output =  new xmlrpcval($output[child],"array");
      }  

       return $xmlrpc_output;

    }

    foreach($vbulletin->iforumcache["$parentid"] AS $forumid)
    {
        $forum = $vbulletin->forumcache["$forumid"];
        $forumperms = $vbulletin->userinfo['forumpermissions']["$forumid"];
        if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) AND ($vbulletin->forumcache["$forumid"]['showprivate'] == 1 OR (!$vbulletin->forumcache["$forumid"]['showprivate'] AND !$vbulletin->options['showprivateforums'])))
        { // no permission to view current forum
            continue;
        }

        if (!$forum['displayorder'] OR !($forum['options'] & $vbulletin->bf_misc_forumoptions['active']))
        {
            // forum not active
            continue;
        }
        else
        { // get on/off status
            $lastpostinfo = $vbulletin->forumcache["$lastpostarray[$forumid]"];
            $forum['statusicon'] = fetch_forum_lightbulb($forumid, $lastpostinfo, $forum);
            $show['newposticon'] = ($forum['statusicon'] ? true : false);

       
      
                $subforum = array('forum_id'=>$forum[forumid],
                                    'forum_name'=>$forum[title],
                                      'description'=>$forum[description],
                                       'sub_only'   => $only_sub,
                                     'parent_id' =>$forum[parentid]);
           
             

       
       
                    if(empty(    $output['child'])){
                        $output['child'] = array(construct_subforum_bit_mobiquo($forumid, $cancontainthreads, $subforum, $depthmark . '--', $depth + 1));
                    } else {
                        array_push(    $output['child'],construct_subforum_bit_mobiquo($forumid, $cancontainthreads, $subforum, $depthmark . '--', $depth + 1));
                    }
               
             

        }
    }
    if($output[forum_id]){
        $xmlrpc_output =new xmlrpcval(array('forum_id'=>new xmlrpcval($output[forum_id],"string"),
                                    'forum_name'=>new xmlrpcval(mobiquo_encode($output[forum_name]),"base64"),
                                      'description'=>new xmlrpcval(mobiquo_encode($output[description]),"base64"),
                                       'sub_only'   => new xmlrpcval($output[sub_only],"boolean"),
                                     'parent_id' =>new xmlrpcval($output[parent_id],"string"),
                                     'child'     =>new xmlrpcval($output[child],"array")),"array");
    }else {
        $xmlrpc_output = new xmlrpcval( $output[child],"array");
    }
    return $xmlrpc_output;

}

?>
