<?php

// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################

define('THIS_SCRIPT', 'market');
define('CSRF_PROTECTION', true);  
// change this depending on your filename

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array(
'pointmarket'
);

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array('MARKET', 'market_sidebar',
);

// pre-cache templates used by specific actions
$actiontemplates = array('market_category',
'market_itemlist',
'market_itembuy',
'market_itembuy_do',
'market_refund',
'market_steal_history',
'market_steal_history_bit', 
'market_donate_history',
);

// ######################### REQUIRE BACK-END ############################
// if your page is outside of your normal vb forums directory, you should change directories by uncommenting the next line
// chdir ('/path/to/your/forums');
require_once('./global.php');

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################

$navbits = construct_navbits(array('' => 'Point Market'));
$navbar = render_navbar_template($navbits);

// ############# PAGE TITLE ##############
$pagetitle = 'Point Market';
$pointfield = $vbulletin->options['market_point_name'];
$points = $vbulletin->userinfo[$pointfield];
$userid = $vbulletin->userinfo['userid'];  
$purchases = $db->num_rows($db->query_read("SELECT * FROM " . TABLE_PREFIX . "market_transactions where userid='$userid'"));
$discount = $permissions['market_discount'];
$discount_percentage = $discount*100;  

// ########### Point Market Open? ######## 
if (!$vbulletin->options['market_active'])
{
        standard_error($vbulletin->options['market_closed']);
}
// ########### User is a Guest ######## 
if ($vbulletin->userinfo[usergroupid] == 1)
{
    print_no_permission();  
}
// ########### No Point Field ######## 
if (!$vbulletin->options['market_point_name'])
{
        standard_error($vbphrase['market_no_point_field']);
}
// ########### Incorrect Point Field ######## 
if (!$vbulletin->userinfo[$pointfield])
{
        standard_error($vbphrase['market_bad_point_field']);
}
// ###### Grab Standard Permissions ###### 
if (!($permissions['market_permissions']))
{
    print_no_permission();
}


// #######################################################################
// ######################## MAIN PAGE SCRIPT #############################
// #######################################################################

if (!$_REQUEST['do'] OR $_REQUEST['do'] == "cat")
{

if ($_REQUEST['id']) {
	$id = $_REQUEST['id'];
    $catinfo = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_items where `marketid` = ".addslashes($id).""); 
} else {
    $catinfo = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_items where `iscategory`='1' AND `active`='1' order by `name` ASC"); 
}
$catinfo = $vbulletin->db->fetch_array($catinfo);
if (!$id AND $catinfo[marketid] > 0) {
    $id = $catinfo[marketid]; // First Found Category   
}
if (!$catinfo OR $catinfo[active] == 0) {
// ###### Category is Inactive or Doesn't Exist. Display No Permissions error ###### 
    print_no_permission();
}

$templater = vB_Template::create('market_category');
$templater->register('name', $catinfo[name]); 
$templater->register('pointfield', $pointfield);
$templater->register('points', $points);
$market_category .= $templater->render();


// ###### Display Possible Items ######
$getitems = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_items where parentid= ".addslashes($id)." AND active='1' ORDER BY `order` ASC");
// Loop through all results
while ($item = $vbulletin->db->fetch_array($getitems))
{
    
// Build Item Image
$image = "".stripslashes($item[image])."";   
$total_bought = $db->num_rows($db->query_read("SELECT * FROM " . TABLE_PREFIX . "market_transactions where marketid='$item[marketid]'"));  

// Configure Amount
    $amount = $item[amount]-($item[amount]*$discount);   
    // Generate Variables to be used
    $templater = vB_Template::create('market_itemlist');
    $templater->register('item_marketid', $item[marketid]);
    $templater->register('item_type', $item[type]);  
    $templater->register('item_name', $item[name]);
    $templater->register('item_parentid', $item[parentid]);
    $templater->register('item_iscategory', $item[iscategory]);
    $templater->register('item_amount', $amount);
    $templater->register('total_bought', $total_bought); 
    $templater->register('image', $image);  
    $templater->register('item_description', $item[description]);
    // Register market_itemlist template 
    $market_itemlist .= $templater->render();
}


}


// #######################################################################
// ######################### Purchase Item ###############################
// #######################################################################

if ($_REQUEST['do'] == "item")
{

$itemid = $_REQUEST['id'];
$getitem = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_items where marketid ='".addslashes($itemid)."'");
$itembuy = $vbulletin->db->fetch_array($getitem);
$item_type = $itembuy['type'];

// ###### Grab Standard Permissions ###### 
if ($itembuy['active'] != 1)
{
    print_no_permission();
}	

// Apply 2 Decimal Rule
$item_amount = number_format($itembuy[amount], 2, '.', ',');
$item_new_amount = $itembuy[amount]-($itembuy[amount]*$discount); 
$current_points = number_format($points, 2, '.', ','); 
// Calculate Theoretical Remaining Amount With 2 Decimals
$remaining = round($points-$item_new_amount, 3);
$remaining = ($points-$item_new_amount)-$remaining;
if ($remaining < 0) {
    $remaining = round($points-$item_new_amount, 3) - .01; // Corrects Remaining Bug
} else {
    $remaining = round($points-$item_new_amount, 3);    
}
$remaining = number_format($remaining, 2, '.', ',');
// Disable Purchase
if ($remaining < 0) {
$disabled = "disabled";    
}

// Create Max Characters
$maxchar = 25; // Default
    // Custom User Title
    if ($itembuy[marketid] == 2)  {
       $maxchar = $vbulletin->options[ctMaxChars];  
    }
    if ($itembuy[marketid] == 13)  {
       $maxchar = $vbulletin->options[maxuserlength]; 
    }                                          

// Create Instructions
$instructions = "".stripslashes($itembuy[instructions])."";
if ($points < $item_new_amount) {
$disabled = "disabled";
}
$max_donate = $permissions['market_maxdonate'];
if ($max_donate == 0) {
$max_donate = "Unlimited";
}
if ($max_donate < 0) {
$max_donate = "0.00";   
}
// Build Item's Image
$image = "".stripslashes($itembuy[image])."";

$templater = vB_Template::create('market_itembuy');
$templater->register('name', $itembuy[name]);
$templater->register('item_id', $itembuy[marketid]);
$templater->register('item_type', $item_type);  
$templater->register('amount', $item_amount);
$templater->register('new_amount', number_format($item_new_amount, 2, '.', ','));
$templater->register('current_points', $current_points);
$templater->register('discount_percentage', number_format($discount_percentage, 2, '.', ''));
$templater->register('remaining', $remaining);
$templater->register('image', $image);
$templater->register('disabled', $disabled);  
$templater->register('maxchar', $maxchar);
$templater->register('instructions', $instructions);
if ($itembuy[type] == 4) {
$templater->register('max_donate', $max_donate);   
}  
$market_itembuy .= $templater->render();

}


// #######################################################################
// ########################## Do Purchase ################################
// #######################################################################

if ($_REQUEST['do'] == "purchase")
{
$error = 0;
if ($_POST) { 
$item_id = $_POST['item_id'];
$affected_user = $_POST['affected_user'];
$donate_amount = $_POST['donate_amount'];
$new_username = $_POST['new_username'];
$new_feature = $_POST['new_feature'];
$color = $_POST['color'];   
$getitem = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_items where marketid ='".addslashes($item_id)."'");
$itembuy = $vbulletin->db->fetch_array($getitem);
 
// Check if Item Can Be Purchased
if ($itembuy[active] != 1) {
    $error = 2; // Item Isn't Active
}
if ($points < $itembuy[amount]-($itembuy[amount]*$discount)) {
    $error = 3; // Not Enough Points
}
// Check if User Exists
if ($affected_user OR $itembuy[type] == 2) {
$findother = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "user where username='".addslashes($affected_user)."'");
$findother = $vbulletin->db->fetch_array($findother);   
    if (!$findother) {
        print "$affected_user and $findother[username]";
        $error = 5; // No User Found
    }
}

// Begin Script
if ($error == 0) {
$time = time();
$userid = $vbulletin->userinfo['userid'];
$amount = $itembuy[amount]-($itembuy[amount]*$discount);

// *********** Custom User Title Purchase ************
    if ($itembuy[marketid] == 2 OR $itembuy[marketid] == 5 OR $itembuy[marketid] == 6) {
        $usertitle = $_POST['usertitle'];
        if ($usertitle == "") {
        $error = 4; // Nothing Entered
        }
        // Basic or Advanced Custom Title
        if ($itembuy[marketid] == 5) {
        $customtitle = 1;    
        } else { $customtitle = 2; }
        
        if ($error == 0) {
        // User Edits Own User Title  
        if ($itembuy[marketid] != 6) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount, customtitle='$customtitle', usertitle ='".addslashes($usertitle)."' where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
        } else {
        // User Edits Someone Else's Usertitle
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set customtitle='$customtitle', usertitle ='".addslashes($usertitle)."' where userid='$findother[userid]'");
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$findother[userid]', amount='$amount'");     
        }
        $points = $points - $amount;
        $purchases = $purchases+1;
        }
    }
// *********** Steal Member's Amounts ************
    if ($itembuy[marketid] == 7 OR $itembuy[marketid] == 8 OR $itembuy[marketid] == 9) {
            // Calculate User's Points
            $stolen = $findother[$pointfield];
            if ($findother['market_steal_protect'] == 1) {
                $error = 14; // User is protected
            } 
            // Calculate Percentage Stealing
            if ($itembuy[marketid] == 7) {
            $stealamount = 0.25;
            }
            else if ($itembuy[marketid] == 8) {
            $stealamount = 0.50;
            }
            else if ($itembuy[marketid] == 9) {
            $stealamount = 0.75;
            }
            // Calculate Amount Stolen
            $stolen = round($stolen*$stealamount,2);
            if ($stolen <= 0) {
                $error = 6; // User has no points to steal   
            }          
             
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$pointfield-$stolen where userid='$findother[userid]'");
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount+$stolen where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$findother[userid]', amount='$amount', stolenamount='$stolen'");     
        $points = $points - $amount;
        $points = $points + $stolen;
        $purchases = $purchases+1;
    }       
}
// *********** Change User Title Color ************* 
    if ($itembuy[marketid] == 3) { 
        if (!$color) {
            $error = 9; // User did not select a color.
        }
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount, market_ct_color='$color' where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
            $points = $points - $amount;
            $purchases = $purchases+1;
        } 
    }
// *********** Change User Title Glow *************   
    if ($itembuy[marketid] == 11) { 
        if (!$color) {
            $error = 9; // User did not select a color.
        }
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount, market_ct_glow='$color' where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
            $points = $points - $amount;
            $purchases = $purchases+1;
        } 
    }
// *********** Donate to Another Member ************
    if ($itembuy[marketid] == 10) {
           
        if ($points < $donate_amount OR ($donate_amount+$amount > $points)) {
            $error = 7; // User doesn't have that much to give away.   
        }
        if ($donate_amount > $permissions['market_maxdonate'] AND $permissions['market_maxdonate'] != 0)  {
            $error = 8; // User is trying to donate more then usergroup is permitted.
        }
        if ($donate_amount < 0 OR !is_numeric($donate_amount))  {
            $error = 13; // User is trying to donate more then usergroup is permitted.
        }
        if ($findother[userid] == $userid) {
            $error = 16; // User is trying to donate to self.
        }
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$pointfield+$donate_amount where userid='$findother[userid]'"); 
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount-$donate_amount where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$findother[userid]', amount='$amount', donatedamount='$donate_amount'");     
            $points = $points - $amount - $donate_amount;
            $purchases = $purchases+1;
        }   
    }
// *********** Change Username ************
    if ($itembuy[marketid] == 13) {
            $findother = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "user where username='".addslashes($new_username)."'");
            $findother = $vbulletin->db->fetch_array($findother);  
        if ($findother)  {
            $error = 10; // Someone has that username.
        }
        $minchar = $vbulletin->options[minuserlength];
        $maxchar = $vbulletin->options[maxuserlength];      
        if ($minchar > strlen($new_username)) {
            $error = 11;
        }
        if ($maxchar < strlen($new_username)) {
            $error = 12;
        }
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `username`='".addslashes($new_username)."', `$pointfield`=$points-$amount where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
            $points = $points - $amount;
            $purchases = $purchases+1;
        }   
    }
// *********** Change User Title Color ************* 
    if ($itembuy[marketid] == 14) { 
        if (!$color) {
            $error = 9; // User did not select a color.
        }
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount, market_username_color='$color' where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
            $points = $points - $amount;
            $purchases = $purchases+1;
        } 
    }
// *********** Change User Title Glow *************   
    if ($itembuy[marketid] == 15) { 
        if (!$color) {
            $error = 9; // User did not select a color.
        }  
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount, market_username_glow='$color' where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
            $points = $points - $amount;
            $purchases = $purchases+1;
        } 
    }
// ************ Add Steal Protection **************   
    if ($itembuy[marketid] == 17) { 
        if (!$new_feature or $new_feature != 1) {
            $error = 4; // User did not select the checkbox.
        } 
        if ($vbulletin->userinfo['market_steal_protect'] == 1) {
            $error = 15; // User has already purchased this item.
        }
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount, market_steal_protect='$new_feature' where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
            $points = $points - $amount;
            $purchases = $purchases+1;
        } 
    }
// *************** Donation History ***************   
    if ($itembuy[marketid] == 18) { 
        if (!$new_feature or $new_feature != 1) {
            $error = 4; // User did not select the checkbox.
        } 
        if ($vbulletin->userinfo['market_donate_history'] == 1) {
            $error = 15; // User has already purchased this item.
        }
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount, market_donate_history='$new_feature' where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
            $points = $points - $amount;
            $purchases = $purchases+1;
        } 
    }
// *************** Stolen Point History *************** 
    if ($itembuy[marketid] == 19) { 
        if (!$new_feature or $new_feature != 1) {
            $error = 4; // User did not select the checkbox.
        } 
        if ($vbulletin->userinfo['market_steal_history'] == 1) {
            $error = 15; // User has already purchased this item.
        }
        if ($error == 0) {
            $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points-$amount, market_steal_history='$new_feature' where userid='$userid'");
            $vbulletin->db->query_read("insert into " . TABLE_PREFIX . "market_transactions set `date`='$time', marketid='$itembuy[marketid]', userid='$userid', affecteduser='$userid', amount='$amount'");     
            $points = $points - $amount;
            $purchases = $purchases+1;
        } 
    }
   
}
} else {
$error = 1; // Error Finding Item      
}

$templater = vB_Template::create('market_itembuy_do');  
$templater->register('error', $error);  
$market_itembuy_do .= $templater->render(); 
  
}

// #######################################################################
// ########################### Do Refund #################################
// #######################################################################

if ($_REQUEST['do'] == "giverefund")
{
$error = 0;
if ($_POST) { 
$tran_id = $_POST['tranid'];
 
$get_transaction = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_transactions where tranid ='".addslashes($tran_id)."' AND refund_date=''");
$transaction = $vbulletin->db->fetch_array($get_transaction);

if (!$transaction) {
    $error = 1;
}
if ($transaction[marketid] == 3) {
    $field = "market_ct_color"; // User Title Color
}
else if ($transaction[marketid] == 11) {
    $field = "market_ct_glow"; // User Title Glow
}
else if ($transaction[marketid] == 14) {
    $field = "market_username_color"; // Username Color
}
else if ($transaction[marketid] == 15) {
    $field = "market_username_glow"; // Username Glow
}

// Calculate Expiration
$expires = $permissions['market_undo_time']*3600;
$expire_date = $transaction[date]+$expires;
// Calculate Refund Amount 
$refund_amount = $transaction[amount]*$permissions['market_undo_penalty'];
// Calculate Remaining Time
$countdown = $expire_date-time();

if ($countdown <= 0) {
    $error = 17; // Time has Expired
}
$date = time();

// ****** Do Update Query ********
if ($error == 0) {
    $vbulletin->db->query_read("update " . TABLE_PREFIX . "user set `$pointfield`=$points+$refund_amount, `$field`='' where userid='$userid'");   
    $vbulletin->db->query_read("update " . TABLE_PREFIX . "market_transactions set `refund_amount`=$refund_amount, `refund_date`='$date' where tranid='".addslashes($tran_id)."'");
    $error = 18; // Refund Purchased Successfully
}

} else {
$error = 1; // Error Finding Item 
}

$templater = vB_Template::create('market_itembuy_do');  
$templater->register('error', $error);  
$market_itembuy_do .= $templater->render(); 

}


// #######################################################################
// ########################## Refund Item ################################
// #######################################################################

if ($_REQUEST['do'] == "refund")
{
$itemid = $_REQUEST['id'];
$getitem = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_items where marketid ='".addslashes($itemid)."'");
$itembuy = $vbulletin->db->fetch_array($getitem);

if (!$itembuy OR $itembuy[type] != 3) {
    print_no_permission();    
}

$fid = $_REQUEST['id'];
$finditem = $vbulletin->db->fetch_array($vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_transactions where marketid ='$itembuy[marketid]' AND userid='$userid' order by date DESC limit 0,1"));

// Calculate Expiration
$expires = $permissions['market_undo_time']*3600;
$expire_date = $finditem[date]+$expires;
// Calculate Refund Amount 
$refund_amount = $finditem[amount]*$permissions['market_undo_penalty'];
// Calculate Remaining Time
$countdown = $expire_date-time();

$days_left = floor($countdown/86400);
$hours_left = floor(($countdown - (86400*$days_left))/3600);
$minutes_left = floor(($countdown - (86400*$days_left)-($hours_left*3600))/60);

$templater = vB_Template::create('market_refund');
    $templater->register('expire_date', $expire_date);
    $templater->register('item_date_format', 'F j, Y, g:i a');
    $templater->register('countdown', $countdown); 
    $templater->register('name', $itembuy[name]);
    $templater->register('days_left', $days_left);
    $templater->register('hours_left', $hours_left);
    $templater->register('minutes_left', $minutes_left);
    $templater->register('amount', $finditem[amount]);
    $templater->register('refund_amount', $refund_amount);  
    $templater->register('purchase_date', $finditem[date]);
    $templater->register('tranid', $finditem[tranid]);
    $templater->register('refund_date', $finditem[refund_date]);
$market_refund .= $templater->render();  
 
    
}

// #######################################################################
// ######################### Steal History ###############################
// #######################################################################

if ($_REQUEST['do'] == "steal_history")
{
     
    if ($_REQUEST['type'] != "2") {
    $type=1;    
    }
    else { 
    $type=2; 
    }
    
    
 // ******************* Actions Done By User ************************* 
    if ($type == 1) {
    $who = "userid";
    $opp = "affecteduser";    
    }
  // **************** Actions Done By Someone Else *******************
    if ($type == 2) {
    $who = "affecteduser";
    $opp = "userid";    
    }
  
  
  
    // Check if User Has Purchased Access
    if ($vbulletin->userinfo[market_steal_history] != 1){
        standard_error($vbphrase['market_error_nopurchase']);    
    }
    // Pageinating for points user has stolen
    $vbulletin->input->clean_array_gpc('r', array(
    'perpage'    => TYPE_UINT,
    'pagenumber' => TYPE_UINT,
    ));
    $cel_users = $db->query_first("
    SELECT COUNT('tranid') AS users_stolen
    FROM " . TABLE_PREFIX . "market_transactions AS market_transactions
    WHERE `$who` = '$userid' AND (marketid='7' or marketid='8' or marketid='9') 
");
    // Sanitize for points user has stolen
    sanitize_pageresults($cel_users['users_stolen'], $pagenumber, $perpage, 100, 20);
    if ($vbulletin->GPC['pagenumber'] < 1)
    {
        $vbulletin->GPC['pagenumber'] = 1;
    }
    else if ($vbulletin->GPC['pagenumber'] > ceil(($cel_users['users_stolen'] + 1) / $perpage))
    {
        $vbulletin->GPC['pagenumber'] = ceil(($cel_users['users_stolen'] + 1) / $perpage);
    }
    $limitlower = ($vbulletin->GPC['pagenumber'] - 1) * $perpage;
    $limitupper = ($vbulletin->GPC['pagenumber']) * $perpage;
    // Main Query to find who user has stolen from
    $result = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "market_transactions WHERE `$who` = '$userid' AND (marketid='7' or marketid='8' or marketid='9') ORDER BY date DESC LIMIT $limitlower, $perpage");
    while ($shu = $vbulletin->db->fetch_array($result))
    {
    ++$loop_count;  
    $other_user = $db->fetch_array($db->query_read("SELECT userid,username FROM " . TABLE_PREFIX . "user where userid='$shu[$opp]'"));  
// Configure Amount
    $amount = $item[amount]-($item[amount]*$discount);   
    // Generate Variables to be used
    $templater = vB_Template::create('market_steal_history_bit');
    $templater->register('item_date', $shu[date]);
    $templater->register('item_date_format', 'F j, Y, g:i a');
    $templater->register('item_affected_name', $other_user[username]);
    $templater->register('item_affected_userid', $other_user[userid]);
    $templater->register('item_stolen_amount', $shu[stolenamount]);
    // Register market_itemlist template 
    $market_steal_history_bit .= $templater->render();
    }

  $pagenav = construct_page_nav(
    $vbulletin->GPC['pagenumber'],
    $perpage,
    $cel_users['users_stolen'],
    'market.php?do=steal_history&type=$type' . $vbulletin->session->vars['sessionurl'], // the pagenav-link
    '', // to pass a second portion or the pagenav-link, gets directly appended to above
    '', // to pass an anchor
    '', // SEO-Link for thread, forum, member... pages - make the pagenav-links seo'ed if you use the paginator on one of those
    '', // Array to pass linkinfo for SEO-Link-Method
    ''  // Array to pass additional Info for SEO-Link-Method
);


$templater = vB_Template::create('market_steal_history');
    $templater->register('market_steal_history_bit', $market_steal_history_bit);
    $templater->register('pagenav', $pagenav);
    $templater->register('pagenumber', $pagenumber);
    $templater->register('type', $type);
    $templater->register('perpage', $perpage);
    $templater->register('loop_count', $loop_count);
    $templater->register('output', $output); 
$market_steal_history .= $templater->render();  

             
}


// #######################################################################
// ######################## Donate History ###############################
// #######################################################################

if ($_REQUEST['do'] == "donate_history")
{

    // Check if User Has Purchased Access
    if ($vbulletin->userinfo[market_donate_history] != 1){
        standard_error($vbphrase['market_error_nopurchase']);    
    }
    if ($_REQUEST['type'] != "2") {
    $type=1;    
    }
    else { 
    $type=2; 
    } 
    
  // ******************* Actions Done By User ************************* 
    if ($type == 1) {
    $who = "userid";
    $opp = "affecteduser";    
    }
  // **************** Actions Done By Someone Else *******************
    if ($type == 2) {
    $who = "affecteduser";
    $opp = "userid";    
    }
  
    // Check if User Has Purchased Access
    if ($vbulletin->userinfo[market_steal_history] != 1){
        standard_error($vbphrase['market_error_nopurchase']);    
    }
    // Pageinating for points user has donated
    $vbulletin->input->clean_array_gpc('r', array(
    'perpage'    => TYPE_UINT,
    'pagenumber' => TYPE_UINT,
    ));
    $cel_users = $db->query_first("
    SELECT COUNT('tranid') AS users_donate
    FROM " . TABLE_PREFIX . "market_transactions AS market_transactions
    WHERE `$who` = '$userid' AND marketid='10' 
");
    // Sanitize for points user has stolen
    sanitize_pageresults($cel_users['users_stolen'], $pagenumber, $perpage, 100, 20);
    if ($vbulletin->GPC['pagenumber'] < 1)
    {
        $vbulletin->GPC['pagenumber'] = 1;
    }
    else if ($vbulletin->GPC['pagenumber'] > ceil(($cel_users['users_donate'] + 1) / $perpage))
    {
        $vbulletin->GPC['pagenumber'] = ceil(($cel_users['users_donate'] + 1) / $perpage);
    }
    $limitlower = ($vbulletin->GPC['pagenumber'] - 1) * $perpage;
    $limitupper = ($vbulletin->GPC['pagenumber']) * $perpage;
    // Main Query to find who user has stolen from
    $result = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "market_transactions WHERE `$who` = '$userid' AND marketid='10' ORDER BY date DESC LIMIT $limitlower, $perpage");
    while ($shu = $vbulletin->db->fetch_array($result))
    {  
    $other_user = $db->fetch_array($db->query_read("SELECT userid,username FROM " . TABLE_PREFIX . "user where userid='$shu[$opp]'"));  
// Configure Amount
    $amount = $item[amount]-($item[amount]*$discount);
    ++$loop_count;   
    // Generate Variables to be used
    $templater = vB_Template::create('market_steal_history_bit');
    $templater->register('item_date', $shu[date]);
    $templater->register('item_date_format', 'F j, Y, g:i a');
    $templater->register('item_affected_name', $other_user[username]);
    $templater->register('item_affected_userid', $other_user[userid]);
    $templater->register('item_stolen_amount', $shu[donatedamount]);
    // Register market_itemlist template 
    $market_steal_history_bit .= $templater->render();
    }

  $pagenav = construct_page_nav(
    $vbulletin->GPC['pagenumber'],
    $perpage,
    $cel_users['users_donate'],
    'market.php?do=donate_history&type=$type' . $vbulletin->session->vars['sessionurl'], // the pagenav-link
    '', // to pass a second portion or the pagenav-link, gets directly appended to above
    '', // to pass an anchor
    '', // SEO-Link for thread, forum, member... pages - make the pagenav-links seo'ed if you use the paginator on one of those
    '', // Array to pass linkinfo for SEO-Link-Method
    ''  // Array to pass additional Info for SEO-Link-Method
);


$templater = vB_Template::create('market_donate_history');
    $templater->register('market_steal_history_bit', $market_steal_history_bit);
    $templater->register('pagenav', $pagenav);
    $templater->register('pagenumber', $pagenumber);
    $templater->register('type', $type);
    $templater->register('perpage', $perpage);
    $templater->register('loop_count', $loop_count);
    $templater->register('output', $output); 
$market_steal_history .= $templater->render();  

             
}






// #######################################################################
// ######################## SIDEBAR SCRIPT ###############################
// #######################################################################

$results = $vbulletin->db->query_read("SELECT * from " . TABLE_PREFIX . "market_items where iscategory='1' AND active='1' ORDER BY `order` ASC");
while ($row = $vbulletin->db->fetch_array($results))
{ 	
    $templater = vB_Template::create('market_sidebar');
    $templater->register('marketid', $row[marketid]);
    $templater->register('id', $id);
    $templater->register('name', $row[name]);
    $templater->register('parentid', $row[paretid]);
    $templater->register('iscategory', $row[iscategory]);
    $templater->register('type', $row[type]);
    $market_sidebar .= $templater->render();
	
}


// #######################################################################
// ###################### Point Market Information #######################
// #######################################################################
$market_purchases = $db->num_rows($db->query_read("SELECT tranid FROM " . TABLE_PREFIX . "market_transactions"));
$market_refunds = $db->num_rows($db->query_read("SELECT tranid FROM " . TABLE_PREFIX . "market_transactions where refund_date != '0'"));
$market_version = "<a href='http://www.vbulletin.org/forum/showthread.php?t=232676'>1.0.2</a>";




// ###### DISPLAY MAIN TEMPLATES ######
$templater = vB_Template::create('MARKET');
	/* register variables */
// ###### PAGE VARIABLES ######
    $templater->register('pointfield', $pointfield);
    $templater->register('points', $points);
    $templater->register('purchases', $purchases);
    $templater->register('market_purchases', $market_purchases);
    $templater->register('market_refunds', $market_refunds);
    $templater->register('market_version', $market_version);
    $templater->register('discount_percentage', $discount_percentage);
    $templater->register('market_side_donate_history', $vbulletin->userinfo[market_donate_history]); 
    $templater->register('market_side_steal_history', $vbulletin->userinfo[market_steal_history]);  
	$templater->render();  
  
$templater->register_page_templates();

$templater->register('market_sidebar', $market_sidebar);
$templater->register('market_category', $market_category);
$templater->register('market_itemlist', $market_itemlist);
$templater->register('market_itembuy', $market_itembuy);
$templater->register('market_refund', $market_refund);
$templater->register('market_itembuy_do', $market_itembuy_do); 
$templater->register('market_steal_history', $market_steal_history);       
$templater->register('navbar', $navbar);
$templater->register('pagetitle', $pagetitle);
print_output($templater->render());



?> 