<?php

   /*
      vBulletin (RAS v2.1) User Authentication for AddonChat
      
      Script Parameters
         username: UTF-8 encoded username
         password: UTF-8 encoded password (allow for both plain text, and pre-md5 encoded)
         ip      : IP (v4) Address
         
      Specification URL: http://support.addoninteractive.com/index.php?action=kb&article=70
      Direct Settings  : http://support.addoninteractive.com/index.php?action=kb&article=32
      
   */

   header("Content-type: text/plain; charset=iso-8859-1");
   
   error_reporting(E_ALL & ~E_NOTICE);
   define('NO_REGISTER_GLOBALS', 1);
   define('SESSION_BYPASS', 1);
   define('LOCATION_BYPASS', 1);
   define('THIS_SCRIPT', 'addonchat_auth');      
   define('DEBUG_AUTH', FALSE);
   define('VB_AREA', TRUE);
      
   define('CWD', (($getcwd = getcwd()) ? $getcwd : '.'));
   require_once(CWD . '/includes/init.php');   
   
   $addonchat_general = array(
      'can_login',
      'can_msg',
      'idle_kick',
      'can_action',
      'allow_pm',
      'allow_room_create',
      'allow_avatars',
      'can_random',
      'allow_bbcode',
      'allow_color',
      'msg_scroll',
      'filter_shout',
      'filter_profanity',
      'filter_word_replace',
      'can_nick',
   );

   $addonchat_admin = array(
      'is_admin',
      'allow_html',
      'can_kick',
      'can_affect_admin',
      'can_grant',
      'can_cloak',
      'can_see_cloak',
      'login_cloaked',
      'can_ban',
      'can_ban_subnet',
      'can_system_speak',
      'can_silence',
      'can_fnick',
      'can_launch_website',
      'can_transfer',
      'can_join_nopw',
      'can_topic',
      'can_close',
      'can_ipquery',
      'can_geo_locate',
      'can_query_ether',
      'can_clear_screen',
      'clear_history',
      'allow_img_tag'
   );

   $addonchat_moderator = array(
      'is_speaker',
      'is_super_moderator',
      'can_enable_moderation',
      'is_unmoderated'
   );
   
   $addonchat_rac = array(
      'allow_admin_console',
      'can_view_transcripts'
   );

   
   if(intval($addonchat['ras_enabled'])==0)
   {
      echo "user.usergroup.id = 0\n";
      echo "user.usergroup.can_login = 0\n";
      echo "vb.auth.msg = Remote Authentication Disabled\n";
      die;
   }         
   
   /*
      Grab GET Parameters
   */
   $get_username  = utf8_to_html($_GET['username']);
   $get_password  = utf8_to_html($_GET['password']);
   $get_ip        = $_GET['ip'];                           
     
   /*
      Required Fields
   */
   echo "scras.version = 2.1\n";
   
   /*
      For debugging purposes
   */
   echo "vb.auth.un = $get_username\n";
   echo "vb.auth.pw = $get_password\n";
      
   if(DEBUG_AUTH)
   {
      $fp = fopen("addonchat_debug.txt", "ab");
      fwrite($fp, "UN: " . $_GET['username'] . " (" . $get_username . ")\n");
      fwrite($fp, "PW: " . $_GET['password'] . " (" . $get_password . ")\n\n\n");
      fclose($fp);
   }

   /*
      Load User from Database
         TABLE_PREFIX.user: userid, username, usergroupid, membergroupids, password, salt
         e.g., SELECT userid, usergroupid, membergroupids, password, salt FROM TABLE_PREFIX.user WHERE username="Bob"
   */
   if ($userinfo = $db->query_first('SELECT userid, usergroupid, membergroupids, password, salt FROM ' . TABLE_PREFIX . 'user WHERE username = "' . $db->escape_string($get_username) . '"'))
   {
      /* Invalid Password */
      if (($userinfo['password'] != $get_password) && ($userinfo['password'] != md5(md5($get_password) . $userinfo['salt'])))
      {
         echo "user.usergroup.id = 0\n";
         echo "user.usergroup.can_login = 0\n";
         echo "vb.auth.msg = Invalid Username or Password\n";
         exit;      
      }
      else
         echo "user.uid = " . intval($userinfo['userid']) . "\n";
   }
   
   /* This user is a guest */
   else
   {
      /* Hard coded (and strongly recommended) default settings for guests. All other settings will use control panel defaults */
      if($addonchat['allow_unregistered_guests']==1)
      {     
         echo "user.uid = 0\n";
         echo "user.usergroup.id = 0\n";
         echo "user.usergroup.can_login = 1\n";
         echo "user.usergroup.icon = 1\n";
         echo "user.usergroup.post_delay = 0\n";
         echo "user.usergroup.max_msg_length = 512\n";
         echo "user.usergroup.level = 2\n";         
         echo "user.usergroup.can_msg = 1\n";
         echo "user.usergroup.can_action = 1\n";       
         echo "user.usergroup.is_admin = 0\n";
         echo "user.usergroup.is_speaker = 0\n";
         echo "user.usergroup.is_super_moderator = 0\n";
         echo "user.usergroup.allow_html = 0\n";
         echo "user.usergroup.icon = 4\n";
         echo "vb.auth.msg = Guest Access\n";
         exit;
      }
      /* Do not permit guests */
      else
      {
         echo "user.usergroup.id = 0\n";
         echo "user.usergroup.can_login = 0\n";
         echo "vb.auth.msg = Guest Access Not Permitted\n";
         exit;
      }
   }
   
   /*******************************
    User DB Validation Successful
   *******************************/   
   
   /*
      Merge usergroupid, membergroupids to create list of all groups this user belongs to.
   */
   $member_groups = array();
   $member_groups[ intval($userinfo['usergroupid'])] = 0;
   
   if($userinfo['membergroupids'] != '')
   {
      $additional_groups = explode(",", $userinfo['membergroupids']);

      foreach($additional_groups as $group)
         $member_groups[intval($group)] = 0;   
   }   
      
   /*
      Load Usergroup Data from Database, Perform Binary OR on results
   */ 
   $dbresult = array(
      'addonchat_general' => 0,
      'addonchat_admin' => 0,
      'addonchat_moderator' => 0,
      'addonchat_rac' => 0,
      'addonchat_ugp_icon' => 0,
      'addonchat_ugp_post_delay' => 0,
      'addonchat_ugp_max_msg_length' => 0,
      'addonchat_ugp_level' => 0
   );      
   
   if ($groupinfo = $db->query_read_slave('SELECT addonchat_general,addonchat_admin,addonchat_moderator,addonchat_rac,addonchat_ugp_icon,addonchat_ugp_post_delay,addonchat_ugp_max_msg_length,addonchat_ugp_level FROM ' . TABLE_PREFIX . 'usergroup WHERE usergroupid IN (' . implode(",", array_keys($member_groups)) . ')'))
   {
      while($group = $db->fetch_array($groupinfo))
      {         
         $dbresult['addonchat_general']      |= intval($group['addonchat_general']);
         $dbresult['addonchat_admin']        |= intval($group['addonchat_admin']);
         $dbresult['addonchat_moderator']    |= intval($group['addonchat_moderator']);
         $dbresult['addonchat_rac']          |= intval($group['addonchat_rac']);
         
         $dbresult['addonchat_ugp_icon']           = (intval($group['addonchat_ugp_icon']) > $dbresult['addonchat_ugp_icon']) ? intval($group['addonchat_ugp_icon']) : $dbresult['addonchat_ugp_icon'];
         $dbresult['addonchat_ugp_post_delay']     = (intval($group['addonchat_ugp_post_delay']) > $dbresult['addonchat_ugp_post_delay']) ? intval($group['addonchat_ugp_post_delay']) : $dbresult['addonchat_ugp_post_delay'];
         $dbresult['addonchat_ugp_max_msg_length'] = (intval($group['addonchat_ugp_max_msg_length']) > $dbresult['addonchat_ugp_max_msg_length']) ? intval($group['addonchat_ugp_max_msg_length']) : $dbresult['addonchat_ugp_max_msg_length'];
         $dbresult['addonchat_ugp_level']          = (intval($group['addonchat_ugp_level']) > $dbresult['addonchat_ugp_level']) ? intval($group['addonchat_ugp_level']) : $dbresult['addonchat_ugp_level'];
      }
         
      $db->free_result($groupinfo);
   }
   /* Error reading groups, treat as guest but provide notice message */
   else
   {
      echo "user.uid = 0\n";
      echo "user.usergroup.id = 0\n";
      echo "user.usergroup.can_login = 1\n";
      echo "user.usergroup.icon = 1\n";
      echo "user.usergroup.post_delay = 0\n";
      echo "user.usergroup.max_msg_length = 512\n";
      echo "user.usergroup.level = 2\n";         
      echo "user.usergroup.can_msg = 1\n";
      echo "user.usergroup.can_action = 1\n";        
      echo "user.usergroup.is_admin = 0\n";
      echo "user.usergroup.is_speaker = 0\n";
      echo "user.usergroup.is_super_moderator = 0\n";
      echo "user.usergroup.allow_html = 0\n";
      echo "user.usergroup.icon = 4\n";
      echo "vb.auth.msg = Error reading usergroup.addonchat table. Guest access provided.\n";
      exit;   
   }      
   
   /*
      Is this user banned? 
   */
   if($dbresult['addonchat_general'] & 32768)
   {
      echo "user.usergroup.id = 0\n";
      echo "user.usergroup.can_login = 0\n";
      echo "vb.auth.msg = User is Banned\n";
      exit;      
   }
      
   /*
      Display RAUTH Output
   */
   print "user.usergroup.id = 0\n";   
   print "user.usergroup.icon = " . $dbresult['addonchat_ugp_icon'] . "\n";
   print "user.usergroup.post_delay = " . $dbresult['addonchat_ugp_post_delay'] . "\n";
   print "user.usergroup.max_msg_length = " . $dbresult['addonchat_ugp_max_msg_length'] . "\n";
   print "user.usergroup.level = " . $dbresult['addonchat_ugp_level'] . "\n";   
   
   $bitfields = array('addonchat_general', 'addonchat_admin', 'addonchat_moderator', 'addonchat_rac');
   foreach($bitfields as $bf)
   {
      $i = 1;
      foreach($$bf as $naam)
      {
         print "user.usergroup." . $naam . " = " . ((($dbresult[$bf] & $i) == 0) ? 0 : 1) . "\n";
         $i *= 2;
      }   
   }

   /*
      Remote/External Functions
   */   
   $remote_functions = array(
      'ef_profile'      => array($addonchat['ef_profile'], "View Profile", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_profile', "_blank", "false"),
      'ef_find_posts'   => array($addonchat['ef_find_posts'], "View Forum Posts", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_find_posts', "_blank", "false"),
      'ef_email'        => array($addonchat['ef_email'], "eMail User", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_email', "_blank", "false"),
      'ef_pm'           => array($addonchat['ef_pm'], "Send Private Message", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_pm', "_blank", "false"),
      'ef_add_buddy'    => array($addonchat['ef_add_buddy'], "Add to Contact List", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_add_buddy', "_blank", "false"),
      'ef_forum_ignore' => array($addonchat['ef_forum_ignore'], "Ignore in Forums", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_forum_ignore', "_blank", "false"),      
      'ef_blogs'        => array($addonchat['ef_blogs'], "View Blog Entries", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_blogs', "_blank", "false"),
      'ef_albums'       => array($addonchat['ef_albums'], "View Albums", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_albums', "_blank", "false"),
      'ef_articles'     => array($addonchat['ef_articles'], "View Articles", $addonchat['forum_url'] . '/addonchat_func.php?do=ef_articles', "_blank", "false"),
   );
   
   $i = 0;
   foreach($remote_functions as $func_name => $func_array)
   {
      if($func_array[0] == 1)
      {
         echo "url.remote.user.$i = \"" . $func_array[1] . "\", \"" . $func_array[2] . "\", \"" . $func_array[3] . "\", \"" . $func_array[4] . "\"\n";
         $i++;
      }
   }
   
   /*
      Direct Settings 
   */
   print($addonchat['direct_settings'] . "\n");
   
   /*
      If automatic login is enabled, can_login is set, and who's chatting is enabled, put this user in the who's chatting list.
      Do not list cloaked users.
   */
   if( (intval($addonchat['enable_auto_login'])==1) && 
       (($dbresult['addonchat_general'] & 1) != 0) && 
       (($dbresult['addonchat_admin'] & 128) == 0) && 
       (intval($addonchat['vb_enable_whos_chatting'])==1) )
   {
      $dquery = "DELETE FROM addonchat_who WHERE username=\"" . $db->escape_string(htmlspecialchars_uni($get_username)) . "\"";
      $query = "INSERT INTO addonchat_who (id, username, subroom, uid, admin) VALUES (NULL, \"" . 
                     $db->escape_string(htmlspecialchars_uni($get_username)) . "\", \"\", " . $userinfo['userid'] . ", " . ((($dbresult['addonchat_admin'] & 1) == 0) ? 0 : 1) . ")";
      $db->hide_errors();
      $db->query_write($dquery);
      $db->query_write($query);
      $db->show_errors();
      echo "vb.addonchat_who.msg = addonchat_who table updated\n";
   }

   /*
      Script completed successfully
   */   
   echo "vb.auth.msg = Success\n";
   
   /*
      UTF-8 to Numeric HTML Entity Conversion      
         Credit to: http://us3.php.net/manual/en/function.utf8-decode.php#75941
         ** Modified to only return HTML entities for characters out of 8 bit ASCII range.
         ** Modified to use htmlspecialchars_uni() function.
   */
   function utf8_to_html ($data)
   {
      return htmlspecialchars_uni(preg_replace("/([\\xC0-\\xF7]{1,1}[\\x80-\\xBF]+)/e", '_utf8_to_html("\\1")', $data));
   }

   function _utf8_to_html ($data)
   {
      $ret = 0;
      foreach((str_split(strrev(chr((ord($data{0}) % 252 % 248 % 240 % 224 % 192) + 128) . substr($data, 1)))) as $k => $v)
         $ret += (ord($v) % 128) * pow(64, $k);
         
      if($ret < 256)
         return chr($ret);
         
      return "&#$ret;";
   }

?>
