<?php

   error_reporting(E_ALL & ~E_NOTICE);  
   
   $phrasegroups = array('cpuser', 'cpoption');
   $specialtemplates = array();
          
   require_once('./global.php');
   require_once(DIR . '/includes/adminfunctions_options.php');
   require_once(DIR . '/includes/functions_addonchat.php');
   
   /*
      Code still needs to be tied in with vB phrase system.
      addonchat related phrases used here:
         
         addonchat_update_success
         addonchat_update_error
         addonchat_update_new
         addonchat_update_failure
   */
   
   if (!can_administer('canadminsettings'))
   {
	   print_cp_no_permission();
      die;
   }  
   
   /* Load the current settings, or create defaults */
   $account_settings_db = $db->query_read_slave("SELECT * FROM addonchat_settings LIMIT 1");
   $account_settings = $db->fetch_array($account_settings_db);
   if($account_settings['account_id'] == '')
   {
      if(endsWith($vbulletin->options['bburl'], "/"))
         $auth_url = "addonchat_auth.php";
      else
         $auth_url = "/addonchat_auth.php";
      $db->query_write("INSERT INTO addonchat_settings (forum_url, url_exit, ras_url) VALUES (" . 
         "\"" . $db->escape_string($vbulletin->options['bburl']) . "\", " . 
         "\"" . $db->escape_string($vbulletin->options['bburl']) . "\", " .
         "\"" . $db->escape_string($vbulletin->options['bburl']) . $auth_url ."\")");
      
      sleep(1);
      
      print_cp_message($vbphrase['addonchat_update_new'], 'addonchat.php?do=settings', 1, NULL, true);
      exit;
   }
   

   /*
      do values:
      
         settings: No update, show form
         auto_update: Save basic account info, perform automatic query update at addonchat.com
         update_details: Manual update of server, port, and language
         update_auth: Save auth info to db, call set remote auth script at addonchat.com
         update_misc: Update misc db settings
      
   */
   if (empty($_REQUEST['do']))
   {
	   $_REQUEST['do'] = 'settings';
   }   
   
   
   /* auto_update 
         account_id
         login_password         
         forum_url
         update_auth_now
   */
   if($_REQUEST['do'] == 'auto_update')
   {      
      // Sanitize...
      if($_POST['login_password'] == '')
         $_POST['login_password'] = $account_settings['login_md5pass'];
      else
         $_POST['login_password'] = md5($_POST['login_password']); 
      $_POST['account_id'] = intval(preg_replace('/\D*/', '', $_POST['account_id']));
      if(strpos($_POST['forum_url'], 'http') !== 0)
         $_POST['forum_url'] = "http://" . $_POST['forum_url'];
	   $vbulletin->input->clean_array_gpc('p', array(
		   'account_id'      => TYPE_UINT,
		   'login_password'  => TYPE_STR,
         'forum_url'       => TYPE_STR,                  
	   ));      
      
      // Update Database
      $query = "UPDATE addonchat_settings SET account_id=\"" . $vbulletin->GPC['account_id'] . 
                  "\", login_md5pass=\"" . $db->escape_string($vbulletin->GPC['login_password']) . 
                  "\", forum_url=\"" . $db->escape_string($vbulletin->GPC['forum_url']) . "\"";
      $db->query_write($query);
      
      /****************************
          Fetch Account Details
      ****************************/
      $remote_link = "http://clientx.addonchat.com/queryaccount.php?id=" . $vbulletin->GPC['account_id'] . "&md5pw=" . urlencode($vbulletin->GPC['login_password']);
      if( ($data_lines = addonchat_geturl($remote_link)) === FALSE)
      {                        
   	   print_cp_message($vbphrase['addonchat_update_error'], 'addonchat.php?do=settings', 1, NULL, true);
         exit;
      }
      
      // On error, edition==-1, ras_capable is error message
      $qra = array();          
      list($qra['edition'], $qra['modules'], $qra['ras_capable'], $qra['edition_name'], $qra['expire_date'],
           $qra['ras_enabled'], $qra_IGNORED['ras_url'], $qra['server_name'], $qra['server_port'], $qra['cpanel_login'], 
           $qra['title'], $qra['account_id_fq'], $qra['customer_id_fq']) = $data_lines;           
         
      // Sanitize  
      $vbulletin->input->clean_array($qra, array(
         'edition'         => TYPE_INT,
         'modules'         => TYPE_STR,
         'ras_capable'     => TYPE_UINT,
         'edition_name'    => TYPE_STR,
         'expire_date'     => TYPE_STR,
         'ras_enabled'     => TYPE_UINT,
         //'ras_url'         => TYPE_STR,
         'server_name'     => TYPE_STR,
         'server_port'     => TYPE_UINT,
         'cpanel_login'    => TYPE_STR,
         'title'           => TYPE_STR,
         'account_id_fq'   => TYPE_STR,
         'customer_id_fq'  => TYPE_STR,
      ));      
                      
      if(intval($data_lines[0] == -1))
      {
   	   print_cp_message($vbphrase['addonchat_update_failure'], 'addonchat.php?do=settings', 1, NULL, true);
         exit;      
      }  
      
      // Update database with newly retrieved settings...
      $query = "UPDATE addonchat_settings SET ";
      foreach($qra as $qra_key => $qra_data) {
         $query_array[] = "$qra_key = \"" . $db->escape_string($qra_data) . "\"";
      }      
      $query .= implode(", ", $query_array);
      
      $db->query_write($query);     
      
      /*********************************
         Enable Remote Authentication
      *********************************/  
      if(intval($_POST['update_auth_now'])==1)
      {
         $remote_link = "http://clientx.addonchat.com/setras.php?id=" . $vbulletin->GPC['account_id'] . 
            "&md5pw=" . urlencode($vbulletin->GPC['login_password']) . 
            "&rasurl=" . urlencode($account_settings['ras_url']);            
            
         if( ($data_lines = addonchat_geturl($remote_link)) === FALSE)
         {                        
   	      print_cp_message($vbphrase['addonchat_update_error'], 'addonchat.php?do=settings', 1, NULL, true);
            exit;
         }
         else if(intval($data_lines[0]) == 0)
         {
   	      print_cp_message($vbphrase['addonchat_update_failure_auth'], 'addonchat.php?do=settings', 1, NULL, true);
            exit;         
         }      
         
         $db->query_write("UPDATE addonchat_settings SET ras_enabled=1");
      }                 
   	 
      print_cp_message($vbphrase['addonchat_update_success'], 'addonchat.php?do=settings', 1, NULL, false);
      exit;      
   }
   
   /* update_details 
         server_name
         server_port
         language
   */
   if($_REQUEST['do'] == 'update_details')
   { 
      // Sanitize...
	   $vbulletin->input->clean_array_gpc('p', array(
		   'server_name'     => TYPE_STR,
		   'server_port'     => TYPE_UINT,
         'language'        => TYPE_STR,                  
	   )); 
      
      // Update Database
      $query = "UPDATE addonchat_settings SET server_name=\"" . $db->escape_string($vbulletin->GPC['server_name']) . 
                  "\", server_port=\"" . intval($vbulletin->GPC['server_port']) . 
                  "\", language=\"" . $db->escape_string($vbulletin->GPC['language']) . "\"";
      $db->query_write($query);      
            
      print_cp_message($vbphrase['addonchat_update_success'], 'addonchat.php?do=settings', 1, NULL, false);
      exit;      
   }
   
   /* update_auth 
         ras_enabled
         ras_url
         allow_unregistered_guests
         enable_auto_login
   */
   if($_REQUEST['do'] == 'update_auth')
   { 
      // Sanitize...
      $post_vars = array(
		   'ras_enabled'                 => TYPE_UINT,
         'ras_url'                     => TYPE_STR,
         'allow_unregistered_guests'   => TYPE_UINT,
         'enable_auto_login'           => TYPE_UINT,                      
	   );
	   $vbulletin->input->clean_array_gpc('p', $post_vars);
      
      // Update Database
      $query = "UPDATE addonchat_settings SET ras_enabled=\"" . intval($vbulletin->GPC['ras_enabled']) . 
                  "\", ras_url=\"" . $db->escape_string($vbulletin->GPC['ras_url']) .
                  "\", allow_unregistered_guests=\"" . intval($vbulletin->GPC['allow_unregistered_guests']) .
                  "\", enable_auto_login=\"" . intval($vbulletin->GPC['enable_auto_login']) . "\"";      
      $db->query_write($query);     
      
      // Set remote authentication script at clientx.addonchat.com if requested
      if($_POST['ras_enabled'] == 1)
      {
         $remote_link = "http://clientx.addonchat.com/setras.php?id=" . $account_settings['account_id'] . 
            "&md5pw=" . urlencode($account_settings['login_md5pass']) . 
            "&rasurl=" . urlencode($_POST['ras_url']);
            
         if( ($data_lines = addonchat_geturl($remote_link)) === FALSE)
         {                        
   	      print_cp_message($vbphrase['addonchat_update_error'], 'addonchat.php?do=settings', 1, NULL, true);
            exit;
         }
         else if(intval($data_lines[0]) == 0)
         {
   	      print_cp_message($vbphrase['addonchat_update_failure_auth'], 'addonchat.php?do=settings', 1, NULL, true);
            exit;         
         }
      }
      
      // Added 5-20-08; unset RAS -- we ignore error results here.
      else
      {
         $remote_link = "http://clientx.addonchat.com/setras.php?id=" . $account_settings['account_id'] . 
            "&md5pw=" . urlencode($account_settings['login_md5pass']) . 
            "&unset=1";
         @addonchat_geturl($remote_link);
      }
               
      print_cp_message($vbphrase['addonchat_update_success'], 'addonchat.php?do=settings', 1, NULL, false);
      exit;      
   }   
   
   /* update_misc     
         -vb_enable_embed
         vb_enable_popup
         vb_enable_whos_chatting
         **vb_enable_whos_chatting_main
         width
         height
         width_float
         height_float
         ef_profile
         ef_find_posts
         ef_email
         ef_pm
         ef_add_buddy
         ef_forum_ignore         
   */
   
   if($_REQUEST['do'] == 'update_misc')
   { 
      // Sanitize...
      $post_vars = array(
		   //'vb_enable_embed'                => TYPE_UINT,
         'vb_enable_popup'                => TYPE_UINT,
         'link_enable_tab'                => TYPE_UINT,
         'link_enable_community'          => TYPE_UINT,
         'link_enable_quick'              => TYPE_UINT,
         'link_show_user_count'           => TYPE_UINT,
         'vb_enable_whos_chatting'        => TYPE_UINT,
         //'vb_enable_whos_chatting_main'   => TYPE_UINT,
         'width'                          => TYPE_STR,
         'height'                         => TYPE_STR,
         'width_float'                    => TYPE_UINT,
         'height_float'                   => TYPE_UINT,
         'ef_profile'                     => TYPE_UINT,
         'ef_find_posts'                  => TYPE_UINT,
         'ef_email'                       => TYPE_UINT,
         'ef_pm'                          => TYPE_UINT,
         'ef_add_buddy'                   => TYPE_UINT,
         'ef_forum_ignore'                => TYPE_UINT,         
         'ef_blogs'                       => TYPE_UINT,
         'ef_articles'                    => TYPE_UINT,
         'ef_albums'                      => TYPE_UINT,
	   );
	   $vbulletin->input->clean_array_gpc('p', $post_vars); 
      
      // Update Database
      $query = "UPDATE addonchat_settings SET ";
      foreach(array_keys($post_vars) as $var)
         $query_array[] = "$var = \"" . $_POST[$var] . "\"";
      $query .= implode(", ", $query_array);
      
      $db->query_write($query);;
   
      print_cp_message($vbphrase['addonchat_update_success'], 'addonchat.php?do=settings', 1, NULL, false);
      exit;      
   } 
   
   if($_REQUEST['do'] == 'update_adv')
   { 
      // Sanitize...
      $post_vars = array(
         'applet_parameters'              => TYPE_STR,
         'direct_settings'                => TYPE_STR,
	   );
	   $vbulletin->input->clean_array_gpc('p', $post_vars); 
      
      // Update Database
      $query = "UPDATE addonchat_settings SET ";
      foreach(array_keys($post_vars) as $var)
         $query_array[] = "$var = \"" . $_POST[$var] . "\"";
      $query .= implode(", ", $query_array);
      
      $db->query_write($query);;
   
      print_cp_message($vbphrase['addonchat_update_success'], 'addonchat.php?do=settings', 1, NULL, false);
      exit;      
   }      
              
   // **************************************************************************
   
   showAddonChatMenuForm();
   
   // **************************************************************************
   
   function showAddonChatMenuForm()
   {   
      global $account_settings;
      global $vbphrase;    
      
      $PRO_REQUIRED = "<dfn>Professional PLUS or Enterprise account required.</dfn>";
      $PRO_STANDARD_REQUIRED = "<dfn>Professional, Professional PLUS, or Enterprise account required.</dfn>";
      $WIDTH_LEFT  = "52%";
      $WIDTH_RIGHT = "48%";      
      
      print_cp_header($vbphrase['addonchat_settings_title']);
      
      print_form_header('addonchat', 'auto_update');
      print_column_style_code(array("width:$WIDTH_LEFT", "width:$WIDTH_RIGHT; white-space:nowrap"));
      print_table_header("Account Information<dfn>Enter your account number and password only and click 'Automatic Lookup' to automatically fill account details.<br>You may sign up for a free AddonChat account at <a href=\"http://www.addonchat.com/signup.html\" target=\"addonchat\">www.addonchat.com</a></dfn>");
      
      print_input_row("Account Number (e.g., SC-12345)", 'account_id', "SC-" . $account_settings['account_id'], 0, 14);
      print_password_row("Account Password<dfn>Leave blank if you do not wish to update password.</dfn>", 'login_password');   
      print_input_row("Forum URL<dfn>This URL is used only to set remote authentication and function links for Professional PLUS and Enterprise AddonChat accounts.", 'forum_url', $account_settings['forum_url'], '', 48);      
      print_yes_no_row("Enable vBulletin Authentication Now?<dfn>When enabled, user access to your AddonChat chat room will be managed by your vBulletin forum usergroup settings. You may then modify chat room permissions from the Usergroups menu in the Admin Control Panel. For this feature to work, you must have purchased the remote authentication module, or have an AddonChat Professional PLUS or Enterprise account.</dfn>", 'update_auth_now', 1);
      
      print_submit_row('Automatic Lookup');
      
      print_form_header('addonchat', 'update_details');
      print_column_style_code(array("width:$WIDTH_LEFT", "width:$WIDTH_RIGHT; white-space:nowrap"));
      print_table_header("Account Details<dfn>If Automatic Lookup fails, enter your account details here.</dfn>");      
      
      for($server = 0; $server < 33; $server++)
         $server_array["client" . $server . ".addonchat.com"] = "client" . $server . ".addonchat.com";
      $server_array["betaclient.addonchat.com"] = "betaclient.addonchat.com";
      /*$server_array["web100/sigma8.com/client/"] = "web100/sigma8.com/client/";*/
      print_select_row("Assigned Server", 'server_name', $server_array, $account_settings['server_name']);
       
      print_select_row("Assigned Port", 'server_port', array(
         8000 => "TCP 8000",
         8001 => "TCP 8001",
         8002 => "TCP 8002",
         8003 => "TCP 8003",
         8004 => "TCP 8004",
         8005 => "TCP 8005",
         8006 => "TCP 8006",
         8007 => "TCP 8007",
         8008 => "TCP 8008",
         8009 => "TCP 8009",
         8080 => "TCP 8080",                                                                                 
      ), $account_settings['server_port']);
       
	   print_select_row("Language", 'language', array(
         "ar"     => "Arabic / Arabe (Traditional, Persian Gulf)",                  
         "bg"     => "Bulgarian / Bulgare (Bulgaria)",    
         "cz"     => "Czech / Tch&#232;que (Czech Republic)",
         "da"     => "Danish / Danois (Kingdom of Denmark)",
         "nl"     => "Dutch / N&#233;erlandais (Netherlands; Formal)",
         "nl_i"   => "Dutch / N&#233;erlandais (Netherlands; Informal)",
         "en_uk"  => "English / Anglais (United Kingdom)",                 
         "en"     => "English / Anglais (United States)",
         "fr"     => "French / Fran&#231;ais (France; Universal)",
         "de"     => "German / Allemand (Germany; Formal)",
         "de_i"   => "German / Allemand (Germany; Informal)",
         "fi"     => "Finnish / Finnois",
         "he"     => "Hebrew / H&#233;breu (Israel)",
         "hu"     => "Hungarian / Hongrois (Hungary)",
         "it"     => "Italian / Italien (Italy)",
         "jp"     => "Japanese / Japonais (Japan)",
         "pl"     => "Polish / Polonais (Poland)",  
         "pt_br"  => "Portuguese / Portugais (Brazil)",
         "ru"     => "Russian / Russe (Russian Federation)",
         "sl"     => "Slovenian / Slov&#232;ne (Slovenia)",
         "es_mx"  => "Spanish; Castellano / Espagnol; Castillan (Mexico)",
         "es_pe"  => "Spanish; Castellano / Espagnol; Castillan (Peru)",
         "es_es"  => "Spanish / Espagnol (Spain; Universal)",
         "sv"     => "Swedish / Su&#233;dois (Sweden)",
         "tr"     => "Turkish / Turc (Republic of Turkey) [1]",     
         "tr2"    => "Turkish / Turc (Republic of Turkey) [2]", 
   	),  $account_settings['language']);         
            
      print_submit_row($vbphrase['save']);
      
      print_form_header('addonchat', 'update_auth');
      print_column_style_code(array("width:$WIDTH_LEFT", "width:$WIDTH_RIGHT; white-space:nowrap"));
      print_table_header("vBulletin User Authentication &amp; Automatic Login<dfn>Click 'Update' to update your remote authentication settings at addonchat.com</dfn>");             
      
      print_yes_no_row("Enable vBulletin Authentication<dfn>Permissions may be modified from the Usergroups menu.<br>A Professional PLUS or Enterprise account is required for this feature to work correctly. Once enabled, this function can presently only be disabled from your AddonChat account control panel.</dfn>", 'ras_enabled', $account_settings['ras_enabled']); 
      print_input_row("Authentication URL", 'ras_url', $account_settings['ras_url'], '', 48);
      print_yes_no_row("Allow Unregistered Guest Access", 'allow_unregistered_guests', $account_settings['allow_unregistered_guests']);                  
      print_yes_no_row("Enable Automatic Login$PRO_STANDARD_REQUIRED", 'enable_auto_login', $account_settings['enable_auto_login']);
      
      print_submit_row('Update');
      
      print_form_header('addonchat', 'update_misc');
      print_column_style_code(array("width:$WIDTH_LEFT", "width:$WIDTH_RIGHT; white-space:nowrap"));  
      print_table_header("Forum Integration");    
      //print_yes_no_row("Enable Embedded Chat Link", 'vb_enable_embed', $account_settings['vb_enable_embed']);

      print_yes_no_row("Use Popup Chat Link", 'vb_enable_popup', $account_settings['vb_enable_popup']);
                
      print_yes_no_row("Navigation: Enable Tab Link", 'link_enable_tab', $account_settings['link_enable_tab']);
      print_yes_no_row("Navigation: Enable Community Link", 'link_enable_community', $account_settings['link_enable_community']);
      print_yes_no_row("Navigation: Enable Quick Link", 'link_enable_quick', $account_settings['link_enable_quick']);
      print_yes_no_row("Show User Chatting Count in Navigation Links", 'link_show_user_count', $account_settings['link_show_user_count']);

      print_yes_no_row("Enable Who's Chatting Feature$PRO_STANDARD_REQUIRED", 'vb_enable_whos_chatting', $account_settings['vb_enable_whos_chatting']);
      //print_yes_no_row("Show Who's Chatting on Forum Index$PRO_STANDARD_REQUIRED", 'vb_enable_whos_chatting_main', $account_settings['vb_enable_whos_chatting_main']);

      print_input_row("Chat Room Width (Embedded)", 'width', $account_settings['width'], 0, 7);
      print_input_row("Chat Room Height (Embedded)", 'height', $account_settings['height'], 0, 7);
      print_input_row("Chat Room Width (Popup)<dfn>Value must be specified in pixels.</dfn>", 'width_float', $account_settings['width_float'], 0, 7);
      print_input_row("Chat Room Height (Popup)<dfn>Value must be specified in pixels.</dfn>", 'height_float', $account_settings['height_float'], 0, 7);     
      
      print_yes_no_row("Link Chat to Forum - User Profiles$PRO_REQUIRED", 'ef_profile', $account_settings['ef_profile']);
      print_yes_no_row("Link Chat to Forum - Find Posts By User$PRO_REQUIRED", 'ef_find_posts', $account_settings['ef_find_posts']);
      print_yes_no_row("Link Chat to Forum - Send eMail$PRO_REQUIRED", 'ef_email', $account_settings['ef_email']);
      print_yes_no_row("Link Chat to Forum - Send Private Message$PRO_REQUIRED", 'ef_pm', $account_settings['ef_pm']);
      print_yes_no_row("Link Chat to Forum - Add to Contact List$PRO_REQUIRED", 'ef_add_buddy', $account_settings['ef_add_buddy']);
      print_yes_no_row("Link Chat to Forum - Ignore User in Forum$PRO_REQUIRED", 'ef_forum_ignore', $account_settings['ef_forum_ignore']);
      print_yes_no_row("Link Chat to Forum - User Blogs$PRO_REQUIRED", 'ef_blogs', $account_settings['ef_blogs']);
      print_yes_no_row("Link Chat to Forum - User Articles$PRO_REQUIRED", 'ef_articles', $account_settings['ef_articles']);
      print_yes_no_row("Link Chat to Forum - User Albums$PRO_REQUIRED", 'ef_albums', $account_settings['ef_albums']);      
             
      print_submit_row($vbphrase['save']);
      
      print_form_header('addonchat', 'update_adv');
      print_column_style_code(array("width:$WIDTH_LEFT", "width:$WIDTH_RIGHT; white-space:nowrap"));  
      print_table_header("Advanced Settings");
      
      print_textarea_row(  "Applet Parameters<dfn><a href=\"http://support.addoninteractive.com/index.php?action=kb&article=57\" target=\"addonchat_ap\">Learn More...</a></dfn>", 
                           'applet_parameters', 
                           htmlspecialchars($account_settings['applet_parameters']),
                           10, '45" style="width:100%',
                           false,
                           true,
                           'ltr',
                           'code'
                        );
                        
      print_textarea_row(  "Direct Settings<dfn><a href=\"http://support.addoninteractive.com/index.php?action=kb&article=32\" target=\"addonchat_ds\">Learn More...</a></dfn>", 
                           'direct_settings', 
                           htmlspecialchars($account_settings['direct_settings']),
                           10, '45" style="width:100%',
                           false,
                           true,
                           'ltr',
                           'code'
                        );                        
             
      print_submit_row($vbphrase['save']);    
      
      print_cp_footer();         
   }   
   
   function endsWith($haystack, $needle)
   {
      return strrpos($haystack, $needle) === strlen($haystack)-strlen($needle);
   }
   

?>
