<?php
/*============================================================================*\
|| ########################################################################## ||
|| # vB Directory                                                           # ||
|| #                                                                        # ||
|| # ---------------------------------------------------------------------- # ||
|| # Copyright  2008-.... pHp-unlimited / pHp-united. All Rights Reserved. # ||
|| # This file may not be redistributed in whole or significant part.       # ||
|| # It's not allowed to delete this Information.                           # ||
|| ########################################################################## ||
\*============================================================================*/

// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define ('THIS_SCRIPT', 'forums_directory');
define ('CSRF_PROTECTION', true);

$phrasegroups = array('holiday');

// get special data templates from the datastore
$specialtemplates = array(
	'userstats',
	'birthdaycache',
	'maxloggedin',
	'iconcache',
	'eventcache',
	'mailqueue',
	'blogstats',
	'blogcategorycache',
);

$globaltemplates = array (
	'directory_forums',
	'forumhome_event',
	'forumhome_loggedinuser',
	'forumhome_birthdaybit'
);

require ('./global.php');
require_once (DIR . '/includes/functions_bigthree.php');
require_once (DIR . '/includes/functions_forumlist.php');

$alternative = 0;
if ($vbulletin->products['langtitles']) $alternative = 1;

$subs_per_line = 7;		// 
$dir_all     = $vbulletin->options['directory_depth'];				// shows the whole depth
$dir_icons   = $vbulletin->options['directory_icons'];				// sahows Icons before subs
$dir_style   = $vbulletin->options['directory_style'];				// set Style
$dir_ordered = $vbulletin->options['directory_order'];				// 0 = unordered 1 = ordered
$dir_numbers = $vbulletin->options['directory_numbers'];			// 0 = no numbers 1 = show numbers

// get permissions to view forumhome
$_permsgetter_ = 'forums_directory';
if (!($permissions['forumpermissions'] & $vbulletin->bf_ugp_forumpermissions['canview'])) print_no_permission ();

$navbits = array ();

if (empty ($foruminfo['forumid']))
{
	$forumid = -1;
	$main_fid = -1;

	$_permsgetter_ = 'index';
	$forumperms = fetch_permissions ($foruminfo['forumid']);
	if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview'])) print_no_permission ();

	verify_forum_password ($foruminfo['forumid'], $foruminfo['password']);

	$navbits[''] = $vbphrase['forumsdirecory'];
}
else
{
	// check forum permissions
	$_permsgetter_ = 'index';
	$forumperms = fetch_permissions($foruminfo['forumid']);

	if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']))
	{
		print_no_permission();
	}

	// check if there is a forum password and if so, ensure the user has it set
	verify_forum_password($foruminfo['forumid'], $foruminfo['password']);

	// draw nav bar
	$navbits['forums_directory.php' . $vbulletin->session->vars['sessionurl_q']] = $vbphrase['forumsdirecory'];

//	$navbits[$vbulletin->options['forumhome'] . '.php' . $vbulletin->session->vars['sessionurl_q']] = $vbphrase['forum'];
	$parentlist = array_reverse (explode(',', substr ($foruminfo['parentlist'], 0, -3)));
	foreach ($parentlist AS $forumID)
	{
		$forumTitle =& $vbulletin->forumcache["$forumID"]['title'];
		$navbits[fetch_seo_url('forum', array ('forumid' => $forumID, 'title' => $forumTitle))] = $forumTitle;
	}

	// pop the last element off the end of the $nav array so that we can show it without a link
	array_pop ($navbits);

	$navbits[''] = $foruminfo['title'];
}
$today = vbdate('Y-m-d', TIMENOW, false, false);

// ### TODAY'S BIRTHDAYS #################################################
if ($vbulletin->options['showbirthdays'])
{
	if (!is_array($vbulletin->birthdaycache)
		OR ($today != $vbulletin->birthdaycache['day1'] AND $today != $vbulletin->birthdaycache['day2'])
		OR !is_array($vbulletin->birthdaycache['users1'])
	)
	{
		// Need to update!
		require_once(DIR . '/includes/functions_databuild.php');
		$birthdaystore = build_birthdays();
		DEVDEBUG('Updated Birthdays');
	}
	else
	{
		$birthdaystore = $vbulletin->birthdaycache;
	}

	switch ($today)
	{
		case $birthdaystore['day1']:
			$birthdaysarray = $birthdaystore['users1'];
			break;

		case $birthdaystore['day2']:
			$birthdaysarray = $birthdaystore['users2'];
			break;
	}
	// memory saving
	unset($birthdaystore);

	$birthdaybits = array();

	foreach ($birthdaysarray AS $birthday)
	{
		$templater = vB_Template::create('forumhome_birthdaybit');
			$templater->register('birthday', $birthday);
		$birthdaybits[] = $templater->render();
	}

	$birthdays = implode(', ', $birthdaybits);

	if (vB_Template_Runtime::fetchStyleVar('dirmark'))
	{
		$birthdays = str_replace('<!--rlm-->', $stylevar['dirmark'], $birthdays);
	}

	$show['birthdays'] = iif ($birthdays, true, false);
}
else
{
	$show['birthdays'] = false;
}

// ### TODAY'S EVENTS #################################################
if ($vbulletin->options['showevents'])
{
	require_once(DIR . '/includes/functions_calendar.php');

	$future = gmdate('n-j-Y' , TIMENOW + 86400 + 86400 * $vbulletin->options['showevents']);

	if (!is_array($vbulletin->eventcache) OR $future != $vbulletin->eventcache['date'])
	{
		// Need to update!
		$eventstore = build_events();
		DEVDEBUG('Updated Events');
	}
	else
	{
		$eventstore = $vbulletin->eventcache;
	}

	unset($eventstore['date']);
	$events = array();
	$eventcount = 0;

	foreach ($eventstore AS $eventid => $eventinfo)
	{
		$offset = $eventinfo['dst'] ? $vbulletin->userinfo['timezoneoffset'] : $vbulletin->userinfo['tzoffset'];
		$eventstore["$eventid"]['dateline_from_user'] = $eventinfo['dateline_from_user'] = $eventinfo['dateline_from'] + $offset * 3600;
		$eventstore["$eventid"]['dateline_to_user'] = $eventinfo['dateline_to_user'] = $eventinfo['dateline_to'] + $offset * 3600;
		$gettime = TIMENOW - $vbulletin->options['hourdiff'];
		$iterations = 0;
		$todaydate = getdate($gettime);

		if (!$eventinfo['singleday'] AND !$eventinfo['recurring'] AND $eventinfo['dateline_from_user'] < gmmktime(0, 0, 0, $todaydate['mon'], $todaydate['mday'], $todaydate['year']))
		{
			$sub = -3;
		}
		else if ($eventinfo['holidayid'])
		{
			$sub = -2;
		}
		else if ($eventinfo['singleday'])
		{
			$sub = -1;
		}
		else
		{
			$sub = $eventinfo['dateline_from_user'] - (86400 * (intval($eventinfo['dateline_from_user'] / 86400)));
		}

		if ($vbulletin->userinfo['calendarpermissions']["$eventinfo[calendarid]"] & $vbulletin->bf_ugp_calendarpermissions['canviewcalendar'] OR ($eventinfo['holidayid'] AND $vbulletin->options['showholidays']))
		{
			if ($eventinfo['userid'] == $vbulletin->userinfo['userid'] OR $vbulletin->userinfo['calendarpermissions']["$eventinfo[calendarid]"] & $vbulletin->bf_ugp_calendarpermissions['canviewothersevent'] OR ($eventinfo['holidayid'] AND $vbulletin->options['showholidays']))
			{
				if (!$eventinfo['recurring'] AND !$vbulletin->options['showeventtype'] AND !$eventinfo['singleday'] AND cache_event_info($eventinfo, $todaydate['mon'], $todaydate['mday'], $todaydate['year']))
				{
					$events["$eventid"][] = $gettime . "_$sub";
				}
				else
				{
					while ($iterations < $vbulletin->options['showevents'])
					{
						$addcache = false;

						$todaydate = getdate($gettime);
						if ($eventinfo['holidayid'] AND $eventinfo['recurring'] == 6)
						{
							if ($eventinfo['recuroption'] == "$todaydate[mon]|$todaydate[mday]")
							{
								$addcache = true;
							}
						}
						else if (cache_event_info($eventinfo, $todaydate['mon'], $todaydate['mday'], $todaydate['year']))
						{
							$addcache = true;
						}

						if ($addcache)
						{
							if (!$vbulletin->options['showeventtype'])
							{
								$events["$eventid"][] = $gettime . "_$sub";
							}
							else
							{
								$events["$gettime"][] = $eventid;
							}
							$eventcount++;
						}

						$iterations++;
						$gettime += 86400;
					}
				}
			}
		}
	}

	if (!empty($events))
	{
		if ($vbulletin->options['showeventtype'])
		{
			ksort($events, SORT_NUMERIC);
		}
		else
		{
			function groupbyevent($a, $b)
			{
				if ($a[0] == $b[0])
				{
					return 0;
				}
				else
				{
					$values1 = explode('_', $a[0]);
					$values2 = explode('_', $b[0]);
					if ($values1[0] != $values2[0])
					{
						return ($values1[0] < $values2[0]) ? -1 : 1;
					}
					else
					{
						// Same day events. Check the event start time to order them properly (compare number of seconds from 00:00)
						return ($values1[1] < $values2[1]) ? -1 : 1;
					}
				}
			}
			uasort($events, 'groupbyevent');
			// this crazy code is to remove $sub added above that ensures a event maintains its position after the sort
			// if associative values are the same
			foreach($events AS $eventid => $times)
			{
				foreach ($times AS $key => $time)
				{
					$events["$eventid"]["$key"] = intval($time);
				}
			}
		}

		$upcomingevents = '';
		foreach($events AS $index => $value)
		{
			$pastevent = 0;
			$pastcount = 0;

			$comma = $eventdates = $daysevents = '';
			if (!$vbulletin->options['showeventtype'])
			{	// Group by Event // $index = $eventid
				$eventinfo = $eventstore["$index"];
				if (empty($eventinfo['recurring']) AND empty($eventinfo['singleday']))
				{	// ranged event -- show it from its real start and real end date (vbgmdate)
					$fromdate = vbdate($vbulletin->options['dateformat'], $eventinfo['dateline_from_user'], false, true, false, true);
					$todate = vbdate($vbulletin->options['dateformat'], $eventinfo['dateline_to_user'], false, true, false, true);
					if ($fromdate != $todate)
					{
						$eventdates = construct_phrase($vbphrase['event_x_to_y'], $fromdate, $todate);
					}
					else
					{
						$eventdates = vbdate($vbulletin->options['dateformat'], $eventinfo['dateline_from_user'], false, true, false, true);
					}
					$day = vbdate('Y-n-j', $eventinfo['dateline_from_user'], false, false);
				}
				else
				{
					unset($day);
					foreach($value AS $key => $dateline)
					{
						if (($dateline - 86400) == $pastevent AND !$eventinfo['holidayid'])
						{
							$pastevent = $dateline;
							$pastcount++;
							continue;
						}
						else
						{
							if ($pastcount)
							{
								$eventdates = construct_phrase($vbphrase['event_x_to_y'], $eventdates, vbdate($vbulletin->options['dateformat'], $pastevent, false, true, false));
							}
							$pastcount = 0;
							$pastevent = $dateline;
						}
						if (!$day)
						{
							$day = vbdate('Y-n-j', $dateline, false, false, false);
						}
						$eventdates .= $comma . vbdate($vbulletin->options['dateformat'], $dateline, false, true, false);
						$comma = ', ';
					}
					if ($pastcount)
					{
						$eventdates = construct_phrase($vbphrase['event_x_to_y'], $eventdates, vbdate($vbulletin->options['dateformat'], $pastevent, false, true, false));
					}
				}

				if ($eventinfo['holidayid'])
				{
					$callink = '<a href="calendar.php?' . $vbulletin->session->vars['sessionurl'] . "do=getinfo&amp;day=$day\">" . $vbphrase['holiday' . $eventinfo['holidayid'] . '_title'] . "</a>";
				}
				else
				{
					$callink = '<a href="calendar.php?' . $vbulletin->session->vars['sessionurl'] . "do=getinfo&amp;day=$day&amp;e=$eventinfo[eventid]&amp;c=$eventinfo[calendarid]\">$eventinfo[title]</a>";
				}
			}
			else
			{	// Group by Date
				$eventdate = vbdate($vbulletin->options['dateformat'], $index, false, true, false);

				$day = vbdate('Y-n-j', $index, false, false, false);
				foreach($value AS $key => $eventid)
				{
					$eventinfo = $eventstore["$eventid"];
					if ($eventinfo['holidayid'])
					{
						$daysevents .= $comma . '<a href="calendar.php?' . $vbulletin->session->vars['sessionurl'] . "do=getinfo&amp;day=$day\">" . $vbphrase['holiday' . $eventinfo['holidayid'] . '_title'] . "</a>";
					}
					else
					{
						$daysevents .= $comma . '<a href="calendar.php?' . $vbulletin->session->vars['sessionurl'] . "do=getinfo&amp;day=$day&amp;e=$eventinfo[eventid]&amp;c=$eventinfo[calendarid]\">$eventinfo[title]</a>";
					}
					$comma = ', ';
				}
			}
			$templater = vB_Template::create('forumhome_event');
				$templater->register('callink', $callink);
				$templater->register('daysevents', $daysevents);
				$templater->register('eventdate', $eventdate);
				$templater->register('eventdates', $eventdates);
			$upcomingevents .= $templater->render();
		}
		// memory saving
		unset($events, $eventstore);
	}
	$show['upcomingevents'] = iif ($upcomingevents, true, false);
	$show['todaysevents'] = iif ($vbulletin->options['showevents'] == 1, true, false);
}
else
{
	$show['upcomingevents'] = false;
}

// ### LOGGED IN USERS #################################################
$activeusers = '';
if (($vbulletin->options['displayloggedin'] == 1 OR $vbulletin->options['displayloggedin'] == 2 OR ($vbulletin->options['displayloggedin'] > 2 AND $vbulletin->userinfo['userid'])) AND !$show['search_engine'])
{
	$datecut = TIMENOW - $vbulletin->options['cookietimeout'];
	$numbervisible = 0;
	$numberregistered = 0;
	$numberguest = 0;

	$hook_query_fields = $hook_query_joins = $hook_query_where = '';

	$forumusers = $db->query_read_slave("
		SELECT
			user.username, (user.options & " . $vbulletin->bf_misc_useroptions['invisible'] . ") AS invisible, user.usergroupid,
			session.userid, session.inforum, session.lastactivity,
			IF(displaygroupid=0, user.usergroupid, displaygroupid) AS displaygroupid, infractiongroupid
			$hook_query_fields
		FROM " . TABLE_PREFIX . "session AS session
		LEFT JOIN " . TABLE_PREFIX . "user AS user ON(user.userid = session.userid)
		$hook_query_joins
		WHERE session.lastactivity > $datecut
			$hook_query_where
		" . iif($vbulletin->options['displayloggedin'] == 1 OR $vbulletin->options['displayloggedin'] == 3, "ORDER BY username ASC") . "
	");

	if ($vbulletin->userinfo['userid'])
	{
		// fakes the user being online for an initial page view of index.php
		$vbulletin->userinfo['joingroupid'] = iif($vbulletin->userinfo['displaygroupid'], $vbulletin->userinfo['displaygroupid'], $vbulletin->userinfo['usergroupid']);
		$userinfos = array
		(
			$vbulletin->userinfo['userid'] => array
			(
				'userid'            =>& $vbulletin->userinfo['userid'],
				'username'          =>& $vbulletin->userinfo['username'],
				'invisible'         =>& $vbulletin->userinfo['invisible'],
				'inforum'           => 0,
				'lastactivity'      => TIMENOW,
				'usergroupid'       =>& $vbulletin->userinfo['usergroupid'],
				'displaygroupid'    =>& $vbulletin->userinfo['displaygroupid'],
				'infractiongroupid' =>& $vbulletin->userinfo['infractiongroupid'],
			)
		);
	}
	else
	{
		$userinfos = array();
	}
	$inforum = array();

	while ($loggedin = $db->fetch_array($forumusers))
	{
		$userid = $loggedin['userid'];
		if (!$userid)
		{	// Guest
			$numberguest++;
			$inforum["$loggedin[inforum]"]++;
		}
		else if (empty($userinfos["$userid"]) OR ($userinfos["$userid"]['lastactivity'] < $loggedin['lastactivity']))
		{
			$userinfos["$userid"] = $loggedin;
		}
	}

	if (!$vbulletin->userinfo['userid'] AND $numberguest == 0)
	{
		$numberguest++;
	}

	foreach ($userinfos AS $userid => $loggedin)
	{
		$numberregistered++;
		if ($userid != $vbulletin->userinfo['userid'])
		{
			$inforum["$loggedin[inforum]"]++;
		}
		fetch_musername($loggedin);

		if (fetch_online_status($loggedin))
		{
			$numbervisible++;
			$show['comma_leader'] = ($activeusers != '');
			$templater = vB_Template::create('forumhome_loggedinuser');
				$templater->register('loggedin', $loggedin);
			$activeusers .= $templater->render();
		}
	}

	// memory saving
	unset($userinfos, $loggedin);

	$db->free_result($forumusers);

	$totalonline = $numberregistered + $numberguest;
	$numberinvisible = $numberregistered - $numbervisible;

	// ### MAX LOGGEDIN USERS ################################
	if (intval($vbulletin->maxloggedin['maxonline']) <= $totalonline)
	{
		$vbulletin->maxloggedin['maxonline'] = $totalonline;
		$vbulletin->maxloggedin['maxonlinedate'] = TIMENOW;
		build_datastore('maxloggedin', serialize($vbulletin->maxloggedin), 1);
	}

	$recordusers = vb_number_format($vbulletin->maxloggedin['maxonline']);
	$recorddate = vbdate($vbulletin->options['dateformat'], $vbulletin->maxloggedin['maxonlinedate'], true);
	$recordtime = vbdate($vbulletin->options['timeformat'], $vbulletin->maxloggedin['maxonlinedate']);

	$show['loggedinusers'] = true;
}
else
{
	$show['loggedinusers'] = false;
}

$sub_text = '';
$sc = 0;
$subcount = $subsubcount = $sscount = 0;

cache_ordered_forums (1, 1);

$forumbits = '';
define ('MAXFORUMDEPTH', $vbulletin->options['forumhomedepth']);
$forumbits = construct_direcory_bit ($forumid);

// ### BOARD STATISTICS #################################################

// get total threads & posts from the forumcache
$totalthreads = 0;
$totalposts = 0;
if (is_array($vbulletin->forumcache))
{
	foreach ($vbulletin->forumcache AS $forum)
	{
		$totalthreads += $forum['threadcount'];
		$totalposts += $forum['replycount'];
	}
}
$totalthreads = vb_number_format($totalthreads);
$totalposts = vb_number_format($totalposts);

// get total members and newest member from template
$numbermembers = vb_number_format($vbulletin->userstats['numbermembers']);
$newuserinfo = array(
	'userid'   => $vbulletin->userstats['newuserid'],
	'username' => $vbulletin->userstats['newusername']
);
$activemembers = vb_number_format($vbulletin->userstats['activemembers']);
$show['activemembers'] = ($vbulletin->options['activememberdays'] > 0 AND ($vbulletin->options['activememberoptions'] & 2)) ? true : false;

$navbar = render_navbar_template(construct_navbits($navbits));
$templater = vB_Template::create('directory_forums');
	$templater->register_page_templates();
	$templater->register('forumbits', $forumbits);

	$templater->register('activemembers', $activemembers);
	$templater->register('activeusers', $activeusers);
	$templater->register('ad_location', $ad_location);
	$templater->register('birthdays', $birthdays);
	$templater->register('forumbits', $forumbits);
	$templater->register('forumhome_markread_script', $forumhome_markread_script);
	$templater->register('navbar', $navbar);
	$templater->register('newuserinfo', $newuserinfo);
	$templater->register('numberguest', $numberguest);
	$templater->register('numbermembers', $numbermembers);
	$templater->register('numberregistered', $numberregistered);
	$templater->register('recorddate', $recorddate);
	$templater->register('recordtime', $recordtime);
	$templater->register('recordusers', $recordusers);
	$templater->register('template_hook', $template_hook);
	$templater->register('today', $today);
	$templater->register('totalonline', $totalonline);
	$templater->register('totalposts', $totalposts);
	$templater->register('totalthreads', $totalthreads);
	$templater->register('upcomingevents', $upcomingevents);
print_output($templater->render());
exit ();

function construct_direcory_bit ($parentid, $depth = 0, $subsonly = 0)
{
	global $vbulletin, $stylevar, $vbphrase, $show;
	global $imodcache, $lastpostarray, $counters, $inforum;
	global $main_text, $sub_text, $subcount, $subsubcount, $sscount, $subs_per_line, $dir_all, $dir_icons, $dir_style, $dir_ordered, $sc, $alternative, $main_fid, $dir_numbers, $subsub_text;

	$list_sign = ($dir_ordered ? 'ol' : 'ul');
	$list_sign = ($dir_ordered ? 'ul class="blockrow faqlinks faqlinks"' : 'ul class="blockrow faqlinks faqlinks"');
	if (!is_array ($lastpostarray)) fetch_last_post_array ($parentid);

	if (empty ($vbulletin->iforumcache["$parentid"]))
	{
		return;
	}

	if (!defined('MAXFORUMDEPTH'))
	{
		define('MAXFORUMDEPTH', 2);
	}

	$forumbits = '';
	$depth++;

	$mf_depth = MAXFORUMDEPTH;
	if ($main_fid == -1)
	{
		$mf_depth = 2;
//		$vbulletin->options['subforumdepth'] = 0;
	}

	foreach ($vbulletin->iforumcache["$parentid"] AS $forumid)
	{
		$forum = $vbulletin->forumcache["$forumid"];
		$lastpostforum = (empty ($lastpostarray[$forumid]) ? array() : $vbulletin->forumcache["$lastpostarray[$forumid]"]);

		if (!$forum['displayorder'] OR !($forum['options'] & $vbulletin->bf_misc_forumoptions['active']))
		{
			continue;
		}

		$forumperms = $vbulletin->userinfo['forumpermissions']["$forumid"];
		$lastpostforumperms = (empty ($lastpostarray[$forumid]) ? 0 : $vbulletin->userinfo['forumpermissions']["$lastpostarray[$forumid]"]);
		if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) AND ($vbulletin->forumcache["$forumid"]['showprivate'] == 1 OR (!$vbulletin->forumcache["$forumid"]['showprivate'] AND !$vbulletin->options['showprivateforums']))) continue;

		if ($subsonly)
		{
			$childforumbits = construct_direcory_bit ($forum['forumid'], 1, $subsonly);
		}
		else if ($depth < $mf_depth)
		{
			$childforumbits = construct_direcory_bit ($forum['forumid'], $depth, $subsonly);
		}
		else
		{
			$childforumbits = '';
		}

		if (!$subsonly OR ($subsonly AND !empty($forum['subscribeforumid'])))
		{

			$GLOBALS['forumshown'] = true; // say that we have shown at least one forum

			if (($forum['options'] & $vbulletin->bf_misc_forumoptions['cancontainthreads']))
			{
				$tempext = '_post';
			}
			else
			{
				$tempext = '_nopost';
			}

			if (!$vbulletin->options['showforumdescription'])
			{
				$forum['description'] = '';
			}

			// dates & thread title
			$lastpostinfo = (empty ($lastpostarray[$forumid]) ? array () : $vbulletin->forumcache["$lastpostarray[$forumid]"]);

			// compare last post time for this forum with the last post time specified by
			// the $lastpostarray, and if it's less, use the last post info from the forum
			// specified by $lastpostarray
			if (!empty($lastpostinfo) AND $vbulletin->forumcache["$lastpostarray[$forumid]"]['lastpost'] > 0)
			{
				if (!($lastpostforumperms & $vbulletin->bf_ugp_forumpermissions['canview']) OR (!($lastpostforumperms & $vbulletin->bf_ugp_forumpermissions['canviewothers']) AND $lastpostinfo['lastposter'] != $vbulletin->userinfo['username']))
				{
					$forum['lastpostinfo'] = $vbphrase['private'];
				}
				else
				{
					$lastpostinfo['lastpostdate'] = vbdate ($vbulletin->options['dateformat'], $lastpostinfo['lastpost'], 1);
					$lastpostinfo['lastposttime'] = vbdate ($vbulletin->options['timeformat'], $lastpostinfo['lastpost']);
					$lastpostinfo['trimthread'] = fetch_trimmed_title (fetch_censored_text ($lastpostinfo['lastthread']));

					if ($lastpostinfo['lastprefixid'] AND $vbulletin->options['showprefixlastpost'])
					{
						$lastpostinfo['prefix'] = ($vbulletin->options['showprefixlastpost'] == 2 ?
							$vbphrase["prefix_$lastpostinfo[lastprefixid]_title_rich"] :
							htmlspecialchars_uni ($vbphrase["prefix_$lastpostinfo[lastprefixid]_title_plain"])
						);
					}
					else
					{
						$lastpostinfo['prefix'] = '';
					}

					if ($vbulletin->forumcache["$lastpostforum[forumid]"]['options'] & $vbulletin->bf_misc_forumoptions['allowicons'] AND $icon = fetch_iconinfo ($lastpostinfo['lasticonid']))
					{
						$show['icon'] = true;
					}
					else
					{
						$show['icon'] = false;
					}

					$show['lastpostinfo'] = (!$lastpostforum['password'] OR verify_forum_password ($lastpostforum['forumid'], $lastpostforum['password'], false));
				}
			}
			else if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']))
			{
				$forum['lastpostinfo'] = $vbphrase['private'];
			}
			else
			{
				$forum['lastpostinfo'] = $vbphrase['never'];
			}

			// do light bulb
			$forum['statusicon'] = fetch_forum_lightbulb ($forumid, $lastpostinfo, $forum);
			if (
				$vbulletin->options['showlocks'] // show locks to users who can't post
				AND !$forum['link'] // forum is not a link
				AND
				(
					!($forum['options'] & $vbulletin->bf_misc_forumoptions['allowposting']) // forum does not allow posting
					OR
					(
						    !($forumperms & $vbulletin->bf_ugp_forumpermissions['canpostnew']) // can't post new threads
						AND !($forumperms & $vbulletin->bf_ugp_forumpermissions['canreplyown']) // can't reply to own threads
						AND !($forumperms & $vbulletin->bf_ugp_forumpermissions['canreplyothers']) // can't reply to others' threads						
					)
				)
			)
			{
				$forum['statusicon'] .= '_lock';
			}

			if (($subsonly OR $depth == $mf_depth) AND $vbulletin->options['subforumdepth'] > 0)
			{
				$forum['subforums'] = directory_subforum_bit ($forumid, ($forum['options'] & $vbulletin->bf_misc_forumoptions['cancontainthreads']));
			}
			else
			{
				$forum['subforums'] = '';
			}

			$forum['browsers'] = 0;
			$children = explode (',', $forum['childlist']);
			foreach ($children AS $childid)
			{
				$forum['browsers'] += (isset ($inforum["$childid"]) ? $inforum["$childid"] : 0);
			}

			if ($alternative)
			{
				$new = get_new_forumtitle ($forum['forumid']);
				if ($new['title']) $forum['title'] = $new['title'];
			}

			// build the template for the current forum
			$a = "$depth$tempext";

			if ($a == '1_nopost')
			{
				$numbers = $image = '';
				if ($dir_icons)
				{
					if ($forum['options'] & $vbulletin->bf_misc_forumoptions['cancontainthreads'])
					{
						$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'miniforum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
					}
					else
					{
						$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'minicategory_forum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
					}
				}
				if ($dir_numbers) $numbers = '<small">(' . $subcount . ')</small>';
				if ($subsubcount)
				{
					$main_text = $image . '<a href="forums_directory.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><b>' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</b></a> ' . $numbers . '<br />';
				}
				else
				{
					$main_text = $image . '<b>' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</b> ' . $numbers . '<br />';
				}
				$subcount = 0;
				$subforumbits = '';
				if ($sub_text)
				{
					if (!$dir_style) $sub_text = substr ($sub_text, 0, strlen ($sub_text) - 2);
					$subforumbits = $sub_text;
					$sub_text = '';
				}
				$subsubcount = $sscount = 0;
				if (!$dir_style)
				{
//					$forumbits .= '<ul><li>' . $main_text . '</li>' . $subforumbits . '</ul>';
					$forumbits .= '<ul class="blockrow faqlinks faqlinks"><li>' . $main_text . '</li>' . $subforumbits . '</ul>';
				}
				else
				{
//					$forumbits .= '<ul><li>' . $main_text . '</li><' . $list_sign . '>' . $subforumbits . '</' . $list_sign . '></ul>';
					$forumbits .= '<ul class="blockrow faqlinks faqlinks"><li>' . $main_text . '</li><' . $list_sign . '>' . $subforumbits . '</' . $list_sign . '></ul>';
				}
				$subforumbits = '';
			}
			else if ($a == '1_post')
			{
				$numbers = $image = '';
				if ($dir_numbers) $numbers = '<small">(' . $subcount . ')</small>';

				if ($dir_icons)
				{
					if ($forum['options'] & $vbulletin->bf_misc_forumoptions['cancontainthreads'])
					{
						$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'miniforum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
					}
					else
					{
						$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'minicategory_forum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
					}
				}

				if ($subcount)
				{
					if ($subsubcount)
					{
						$main_text = $image . '<a href="forums_directory.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><b>' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</b></a> ' . $numbers . '<br />';
					}
					else
					{
						$main_text = $image . '<b>' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</b> ' . $numbers . '<br />';
					}
					$subcount = 0;
					$subforumbits = '';
					if ($sub_text)
					{
						if (!$dir_style) $sub_text = substr ($sub_text, 0, strlen ($sub_text) - 2);
						$subforumbits = $sub_text;
						$sub_text = '';
					}
					$subsubcount = $sscount = 0;
					if (!$dir_style)
					{
//						$forumbits .= '<ul><li>' . $main_text . '</li>' . $subforumbits . '</ul>';
						$forumbits .= '<ul class="blockrow faqlinks faqlinks"><li>' . $main_text . '</li>' . $subforumbits . '</ul>';
					}
					else
					{
//						$forumbits .= '<ul><li>' . $main_text . '</li><' . $list_sign . '>' . $subforumbits . '</' . $list_sign . '></ul>';
						$forumbits .= '<ul class="blockrow faqlinks faqlinks"><li>' . $main_text . '</li><' . $list_sign . '>' . $subforumbits . '</' . $list_sign . '></ul>';
					}
					$subforumbits = '';
				}
				else
				{
					if ($dir_all)
					{
						if ($dir_icons)
						{
							$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'miniforum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
						}

						$fdt = str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']);
						$main_text = $image . '<a href="' . fetch_seo_url('forum', array ('forumid' => $forum['forumid'], 'title' => $fdt)) . '"><b>' . $fdt . '</b></a><br /><br />';
//						$main_text = $image . '<a href="forumdisplay.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</a><br /><br />';
						if (!$dir_style)
						{
//							$forumbits .= '<ul><li>' . $main_text . '</li>' . $subforumbits . '</ul>';
							$forumbits .= '<ul class="blockrow faqlinks faqlinks"><li>' . $main_text . '</li>' . $subforumbits . '</ul>';
						}
						else
						{
//							$forumbits .= '<ul><li>' . $main_text . '</li><' . $list_sign . '>' . $subforumbits . '</' . $list_sign . '></ul>';
							$forumbits .= '<ul class="blockrow faqlinks faqlinks"><li>' . $main_text . '</li><' . $list_sign . '>' . $subforumbits . '</' . $list_sign . '></ul>';
						}
						$subforumbits = '';
					}
					else
					{
						if ($dir_icons)
						{
							$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'miniforum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
						}

						$fdt = str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']);
						$main_text = $image . '<a href="' . fetch_seo_url('forum', array ('forumid' => $forum['forumid'], 'title' => $fdt)) . '"><b>' . $fdt . '</b></a><br /><br />';
//						$main_text = $image . '<a href="forumdisplay.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</a><br /><br />';
						if (!$dir_style)
						{
//							$forumbits .= '<ul><li>' . $main_text . '</li>' . $subforumbits . '</ul>';
							$forumbits .= '<ul class="blockrow faqlinks faqlinks"><li>' . $main_text . '</li>' . $subforumbits . '</ul>';
						}
						else
						{
//							$forumbits .= '<ul><li>' . $main_text . '</li><' . $list_sign . '>' . $subforumbits . '</' . $list_sign . '></ul>';
							$forumbits .= '<ul class="blockrow faqlinks faqlinks"><li>' . $main_text . '</li><' . $list_sign . '>' . $subforumbits . '</' . $list_sign . '></ul>';
						}
						$subforumbits = '';
					}
				}
			}
			else if ($a == '2_nopost')
			{
				$image = '';
				if ($dir_icons)
				{
					if ($forum['options'] & $vbulletin->bf_misc_forumoptions['cancontainthreads'])
					{
					$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'miniforum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
					}
					else
					{
						$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'minicategory_forum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
					}
					$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'miniforum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
				}
				$sub_text .= $image . '<a href="forums_directory.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</a><br />';
//				$main_text = $image . '<a href="forumdisplay.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</a><br />';
			}
			else if ($a == '2_post')
			{
				$subcount++;
				$numbers = $image = '';
				if ($dir_numbers) $numbers = ' <small">(' . $sscount . ')</small>';
				if ($dir_icons)
				{
					$image = '<img src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/' . $forum['imageprefix'] . 'miniforum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';
				}

				if (!$dir_style)
				{
					if ($sscount)
					{
						if ($dir_all)
						{
							$sub_text .= $image . '<a href="forums_directory.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><small">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</small></a>' . $numbers . ', ';
						}
						else
						{
							$sub_text .= $image . '<a href="forums_directory.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><small>' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</small>' . $numbers . '</a>, ';
						}
					}
					else
					{
						$fdt = str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']);
						$sub_text .= $image . '<a href="' . fetch_seo_url('forum', array ('forumid' => $forum['forumid'], 'title' => $fdt)) . '"><small>' . $fdt . '</small></a>, ';
//						$sub_text .= $image . '<a href="forumdisplay.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><span class="smallfont">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</span></a>, ';
					}
				}
				else
				{
					if ($sscount)
					{
						if ($dir_all)
						{
							$sub_text .= '<li>' . $image . '<a href="forums_directory.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><small>' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</small></a>' . $numbers . '</li>';
							if ($subsub_text)
							{
//								$sub_text .= '<ul>' . $subsub_text . '</ul>';
								$sub_text .= '<ul class="blockrow faqlinks faqlinks">' . $subsub_text . '</ul>';
								$subsub_text = '';
							}
						}
						else
						{
							$sub_text .= '<li>' . $image . '<a href="forums_directory.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><small>' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</small></a>' . $numbers . '</li>';
						}
					}
					else
					{
						$fdt = str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']);
						$sub_text .= '<li>' . $image . '<a href="' . fetch_seo_url('forum', array ('forumid' => $forum['forumid'], 'title' => $fdt)) . '"><small>' . $fdt . '</small></a></li>';
//						$sub_text .= '<li>' . $image . '<a href="forumdisplay.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><span class="smallfont">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</span></a></li>';
					}
				}
				$sscount = 0;
			}

		}
		else
		{
//			$forumbits .= $childforumbits;
		}
	}

	return $forumbits;
}

function directory_subforum_bit ($parentid, $cancontainthreads, $output = '', $depthmark = '--', $depth = 0)
{
	global $vbulletin, $stylevar, $vbphrase, $subcount, $subsubcount, $sscount, $subs_per_line, $sc, $dir_style, $dir_all, $main_fid, $dir_numbers;
	global $lastpostinfo, $lastpostarray, $main_text, $sub_text, $dir_icons, $alternative, $forumid, $subsub_text;
	static $splitter;

	if ($cancontainthreads) $canpost = 'post';
	else $canpost = 'nopost';

	if (!isset ($vbulletin->iforumcache["$parentid"]))
	{
		return $output;
	}

	foreach ($vbulletin->iforumcache["$parentid"] AS $forumid)
	{
		$forum = $vbulletin->forumcache["$forumid"];
		$forumperms = $vbulletin->userinfo['forumpermissions']["$forumid"];
		if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) AND ($vbulletin->forumcache["$forumid"]['showprivate'] == 1 OR (!$vbulletin->forumcache["$forumid"]['showprivate'] AND !$vbulletin->options['showprivateforums']))) continue;

		if (!$forum['displayorder'] OR !($forum['options'] & $vbulletin->bf_misc_forumoptions['active'])) continue;
		else
		{
			$lastpostinfo = $vbulletin->forumcache["$lastpostarray[$forumid]"];
			$forum['statusicon'] = fetch_forum_lightbulb ($forumid, $lastpostinfo, $forum);

			$image = '';
			if ($dir_icons) $image = '<img class="inlineimg" src="' . vB_Template_Runtime::fetchStyleVar('imgdir_statusicon') . '/subforum_' . $forum['statusicon'] . '.gif" alt="" border="0" /> ';

			if ($alternative)
			{
				$new = get_new_forumtitle ($forum['forumid']);
				if ($new['title']) $forum['title'] = $new['title'];
			}

			if ($canpost == 'post')
			{
				$subcount++;
				$sscount++;
				$subsubcount++;
				if ($main_fid != -1 AND $dir_all)
				{
					if ($dir_style)
					{
						$fdt = str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']);
						$subsub_text .= '<li>' . $image . '<a href="' . fetch_seo_url('forum', array ('forumid' => $forum['forumid'], 'title' => $fdt)) . '"><small>' . $fdt . '</small></a></li>';
//						$subsub_text .= '<li>' . $image . '<a href="forumdisplay.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><span class="smallfont">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</span></a></li>';
					}
					else
					{
						$fdt = str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']);
						$subsub_text .= $image . '<a href="' . fetch_seo_url('forum', array ('forumid' => $forum['forumid'], 'title' => $fdt)) . '"><small>' . $fdt . '</small></a>';
//						$subsub_text .= $image . '<a href="forumdisplay.php?' . $session['sessionurl'] . 'f=' . $forum['forumid'] . '"><span class="smallfont">' . str_replace ('{username}', $vbulletin->userinfo['username'], $forum['title']) . '</span></a>';
					}

					if (!$dir_style)
					{
						$sc++;
						if ($sc < $subs_per_line)
						{
							$subsub_text .= ', ';
						}
						else
						{
							$sc = 0;
							$subsub_text .= '<br />';
						}
					}
				}
			}
			else
			{
				$subcount++;
//				$sub_text .= '???, ';
			}

			if (!empty ($output))
			{
				$subforum = $splitter["$canpost"] . $subforum;
			}
			if ($depth < $vbulletin->options['subforumdepth'])
			{
				$output .= directory_subforum_bit ($forumid, $cancontainthreads, $subforum, $depthmark . '--', $depth + 1);
			}
		}
	}

	return $output;

}
?>