<?php
/*======================================================================*\
|| #################################################################### ||
|| # Modification-System                                              # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2008 php-unlimited. All Rights Reserved.              # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| #                   http://www.php-unlimited.com                   # ||
|| #################################################################### ||
\*======================================================================*/

class vB_ProfileBlock_modsystem extends vB_ProfileBlock
{
	var $template_name = 'memberinfo_block_modsystem';

	function confirm_empty_wrap()
	{
		return false;
	}

	function confirm_display()
	{
		return ($this->block_data['modsystem'] != '');
	}

	function prepare_output($id = '', $options = array())
	{
		global $stylevar, $db, $vbulletin, $vbphrase;

		$mymods = '';
		$modcache = array ();
		$mc = $install_count = $hack_count = 0;

		// get modifications
		$modifications = $db->query_read ("SELECT 
			mods.author,mods.mod_version,mods.mod_vbversion,mods.author,mods.threadid,mods.mod_installcount,mods.dateline,mods.last_update,
			thread.title,thread.prefixid, 
			forum.title as forumtitle, forum.forumid AS forumid 
			FROM " . TABLE_PREFIX . "modsys_settings AS mods 
			LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON(thread.threadid=mods.threadid) 
			LEFT JOIN " . TABLE_PREFIX . "forum AS forum ON(forum.forumid=thread.forumid) 
			WHERE mods.author=" . intval ($vbulletin->GPC['userid']) . " 
			AND thread.visible=1 
			ORDER BY forumtitle ASC,mods.dateline DESC 
		");
		while ($mod = $db->fetch_array ($modifications))
		{
			$mod['ismodification'] ='mod';
			$t = strtoupper ($mod['forumtitle']);
			$u = strtoupper ($mod['title']);
			$modcache["$t"]["$u"] = $mod;
		}
		$db->free_result ($modifications);

		// get articles
		$aids = explode (',', $vbulletin->options['modsettings_articles']);
		if (!empty ($aids) AND $vbulletin->options['modsettings_articles'] != '')
		{
			$articles = $db->query_read ("SELECT 
				thread.title,thread.prefixid, 
				forum.title as forumtitle, forum.forumid AS forumid 
				FROM " . TABLE_PREFIX . "thread AS thread 
				LEFT JOIN " . TABLE_PREFIX . "forum AS forum ON(forum.forumid=thread.forumid) 
				WHERE forum.forumid IN (0," . implode (',', $aids) . ") 
				AND thread.visible=1 
				AND thread.postuserid=" . intval ($vbulletin->GPC['userid']) . " 
				ORDER BY thread.dateline DESC 
			");
			while ($art = $db->fetch_array ($articles))
			{
				$art['ismodification'] ='art';
				$t = strtoupper ($art['forumtitle']);
				$u = strtoupper ($art['title']);
				$modcache["$t"]["$u"] = $art;
			}
			$db->free_result ($articles);
		}

		if (sizeof ($modcache) >= 1)
		{
			$mymods = $forumgroups = '';

			$show['link'] = 1;
			$total_hacks = $total_install = 0;
			foreach ($modcache AS $forums)
			{
				$art = $mymods = '';
				$hack_count = $install_count = 0;
				foreach ($forums AS $forum)
				{
					$art = $forum['ismodification'];
					if ($art != 'art')
					{
						$hack_count++;
					}
					$mod['title'] = $forum['title'];
					$mod['threadid'] = $forum['threadid'];

					if ($forum['prefixid'] == '')
					{
						$prefix = '&nbsp;';
					}
					else
					{
						$prefix = $vbphrase['prefix_' . $forum['prefixid'] . '_title_plain'];
					}

					$vers = '&nbsp;';
					if ($forum['mod_version']) $vers = '<span class="smallfont" style="color:gray">&nbsp;[' . $forum['mod_version'] . ']</span>';

					$mod['mod_vbversion'] = $forum['mod_vbversion'];
					if (!$mod['mod_vbversion']) $mod['mod_vbversion'] = '&nbsp;';

					$mod['mod_installcount'] = $forum['mod_installcount'];
					if ($art != 'art')
					{
						$install_count += $mod['mod_installcount'];
					}

					$update = $vbphrase['modsystem_profile_mod_never'];
					if ($forum['last_update']) $update = vbdate ($vbulletin->options['dateformat'], $forum['last_update']);
					$date = vbdate ($vbulletin->options['dateformat'], $forum['dateline']);

					$show['article'] = false;
					if ($art == 'art')
					{
						$show['article'] = true;
						$mod['mod_installcount'] = 0;
						$update = $vbphrase['modsystem_profile_mod_never'];
					}
					$templater = vB_Template::create('memberinfo_modsystem_inblock_bit');
						$templater->register('mod', $mod);
						$templater->register('vers', $vers);
						$templater->register('show', $show);
						$templater->register('date', $date);
						$templater->register('prefix', $prefix);
						$templater->register('update', $update);
					$mymods .= $templater->render();
				}

				$total_hacks += $hack_count;
				$total_install += $install_count;
				$desc = construct_phrase ($vbphrase['modsystem_profile_mod_addon_desc'], $hack_count, $install_count);

				$show['article'] = false;
				if ($art == 'art') $show['article'] = true;
				$templater = vB_Template::create('memberinfo_modsystem_inblock_forumgroups');
					$templater->register('show', $show);
					$templater->register('desc', $desc);
					$templater->register('forum', $forum);
					$templater->register('mymods', $mymods);
				$forumgroups .= $templater->render();
			}

			$u = $vbulletin->GPC['userid'];
			$desc = construct_phrase ($vbphrase['modsystem_profile_mod_addon_desc2'], $total_hacks, $total_install);

			$templater = vB_Template::create('memberinfo_modsystem_inblock');
				$templater->register('u', $u);
				$templater->register('desc', $desc);
				$templater->register('forumgroups', $forumgroups);
			$mod_content = $templater->render();

		}
		else
		{
			$mod_content = $vbphrase['modsystem_profile_mod_no_addons'];
		}

		$this->block_data['modsystem'] = $mod_content;
	}
}
?>