<?php
/*======================================================================*\
|| #################################################################### ||
|| # Modification-System                                              # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2008 php-unlimited. All Rights Reserved.              # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| #                   http://www.php-unlimited.com                   # ||
|| #################################################################### ||
\*======================================================================*/

define ('MODSYS', 'v2.0');
function mod_get_similar_thread ($thread)
{
	global $db, $vbulletin, $vbphrase, $stylevar, $bgclass;

	$tagbits = '';

	if ($vbulletin->options['modsettings_forumids'])
	{
		// get forum ids for all forums user is allowed to view
		$forumids = array_keys ($vbulletin->forumcache);
		$self_only = array ();

		foreach ($forumids AS $key => $forumid)
		{
			$forum = $vbulletin->forumcache["$forumid"];

			$forumperms = fetch_permissions ($forumid);
			if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) OR !verify_forum_password ($forumid, $forum['password'], false))
			{
				unset ($forumids["$key"]);
				continue;
			}

			if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canviewothers']))
			{
				$self_only[] = $forumid;
			}
		}

		if ($forumids AND $thread['taglist'] != '' AND $vbulletin->options['modsettings_global_modsystem'])
		{
			// get our tagids from the selected thread
			$threadtagids = array ();
			$thread_tags = explode (',', $thread['taglist']);
			foreach ($thread_tags AS $tagtext)
			{
				$tags = $db->query_read ("SELECT
					tag.tagid,tagcontent.contentid as cthreadid
					FROM " . TABLE_PREFIX . "tag AS tag 
					JOIN " . TABLE_PREFIX . "tagcontent AS tagcontent ON (tagcontent.tagid = tag.tagid) 
					LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.threadid = tagcontent.contentid)
					WHERE tag.tagtext='" . $db->escape_string (trim ($tagtext)) . "'
					AND tagcontent.contenttypeid=2 
					AND thread.forumid IN(" . implode (', ', $forumids) . ")
					" . ($self_only ? 'AND IF(thread.forumid IN (' . implode(',', $self_only) . '), thread.postuserid = ' . $vbulletin->userinfo['userid'] . ', 1)' : '') . "
				");

				while ($tag = $db->fetch_array ($tags))
				{
					if ($thread['threadid'] != $tag['cthreadid'])
					{
						$threadtagids[] = $tag['cthreadid'];
					}
				}
			}
			$threadtagids = array_unique ($threadtagids);

			if (!empty ($threadtagids))
			{
				// needed to prevent mass amounts of queries
				require_once (DIR . '/includes/functions_forumlist.php');
				cache_moderators ();

				$coventry = fetch_coventry ('string');
				$globalignore = ($coventry ? "AND thread.postuserid NOT IN ($coventry) " : '');

				// get the threads similar with the tags
				$thread_sql = $db->query_read_slave("
					SELECT
						thread.forumid, forum.title AS forumtitle,
						thread.threadid, thread.title AS threadtitle, postusername, postuserid, thread.visible,
						thread.lastpost, thread.replycount
					FROM " . TABLE_PREFIX . "thread AS thread
						" . (($vbulletin->options['threadsubscribed'] AND $vbulletin->userinfo['userid']) ?  " LEFT JOIN " . TABLE_PREFIX . "subscribethread AS subscribethread ON(subscribethread.threadid = thread.threadid AND subscribethread.userid = " . $vbulletin->userinfo['userid'] . " AND canview = 1)" : "") . "
					LEFT JOIN " . TABLE_PREFIX . "forum AS forum ON (forum.forumid=thread.forumid)
					WHERE thread.threadid IN (" . implode(',', $threadtagids) . ")
					AND thread.visible = 1
					AND forum.forumid IN (" . $vbulletin->options['modsettings_forumids'] . ")
					LIMIT " . intval ($vbulletin->options['modsettings_similar_threads'])
				);
				while ($tagthread = $db->fetch_array ($thread_sql))
				{
					$posttime = vbdate ($vbulletin->options['timeformat'], $tagthread['lastpost']);
					$postdate = vbdate ($vbulletin->options['dateformat'], $tagthread['lastpost']);

					$templater = vB_Template::create('modsystem_similarmod_bit');
						$templater->register('tagthread', $tagthread);
						$templater->register('posttime', $posttime);
						$templater->register('postdate', $postdate);
					$tagbits .= $templater->render();
				}
				$db->free_result ($thread_sql);
			}
		}
	}

	return $tagbits;
}

function mod_process_showgroups_userinfo($user)
{
	global $vbulletin, $permissions, $stylevar, $show;

	$user = array_merge($user, convert_bits_to_array($user['options'], $vbulletin->bf_misc_useroptions));
	$user = array_merge($user, convert_bits_to_array($user['adminoptions'], $vbulletin->bf_misc_adminoptions));
	
	cache_permissions($user, false);
  
	require_once(DIR . '/includes/functions_bigthree.php');
	fetch_online_status($user, true);

	if ((!$user['invisible'] OR $permissions['genericpermissions'] & $vbulletin->bf_ugp_genericpermissions['canseehidden']))
	{
		$user['lastonline'] = vbdate($vbulletin->options['dateformat'], $user['lastactivity'], 1);
	}
	else
	{
		$user['lastonline'] = '&nbsp;';
	}

	fetch_musername($user);
	fetch_avatar_from_userinfo($user, true);

	return $user;
}

function showgroups_cdm ($do = '')
{
	global $db, $vbulletin, $vbphrase, $stylevar, $usergroupbits, $usergroups, $moderatorbits, $bgclass;

	if ($do != '' AND $vbulletin->options['modsettings_global_modsystem'])
	{
		if ($do == 'coder' OR $do == 'designer')
		{
			// 2 is the default location field and the one we always use in the template
			$show['locationfield'] = $db->query_first("
				SELECT profilefieldid
					FROM " . TABLE_PREFIX . "profilefield
				WHERE profilefieldid = 2
			");

			$show['contactinfo'] = (bool)$vbulletin->userinfo['userid'];

			$geta = 'codercount';
			$getb = 'modsys_coder';
			if ($do == 'designer')
			{
				$geta = 'designercount';
				$getb = 'modsys_designer';
			}

			$users = $db->query_read_slave("
				SELECT user.*,
					modc.mincount,modc.maxcount,modc.title AS modtitle,modc.title_clean AS modtitle_clean,
					usergroup.usergroupid, usergroup.title,
					user.options, usertextfield.buddylist,
					" . ($show['locationfield'] ? 'userfield.field2,' : '') . "
					IF(user.displaygroupid = 0, user.usergroupid, user.displaygroupid) AS displaygroupid
					" . ($vbulletin->options['avatarenabled'] ? ",avatar.avatarpath, NOT ISNULL(customavatar.userid) AS hascustomavatar, customavatar.dateline AS avatardateline,customavatar.width AS avwidth,customavatar.height AS avheight, customavatar.width_thumb AS avwidth_thumb, customavatar.height_thumb AS avheight_thumb, filedata_thumb, NOT ISNULL(customavatar.userid) AS hascustom" : "") . "
				FROM " . TABLE_PREFIX . $getb . " AS modc, " . TABLE_PREFIX . "user AS user
				LEFT JOIN " . TABLE_PREFIX . "usergroup AS usergroup ON(usergroup.usergroupid = user.usergroupid OR FIND_IN_SET(usergroup.usergroupid, user.membergroupids))
				LEFT JOIN " . TABLE_PREFIX . "userfield AS userfield ON(userfield.userid = user.userid)
				LEFT JOIN " . TABLE_PREFIX . "usertextfield AS usertextfield ON(usertextfield.userid=user.userid)
				" . ($vbulletin->options['avatarenabled'] ? "LEFT JOIN " . TABLE_PREFIX . "avatar AS avatar ON(avatar.avatarid = user.avatarid) LEFT JOIN " . TABLE_PREFIX . "customavatar AS customavatar ON(customavatar.userid = user.userid)" : "") . "
				WHERE user." . $geta . " BETWEEN modc.mincount AND modc.maxcount
				ORDER BY modc.title DESC, user." . $geta . " DESC, user.username ASC
			");

			$groupcache = array ();
			while ($user = $db->fetch_array($users))
			{
				$user = array_merge ($user , convert_bits_to_array ($user['options'], $vbulletin->bf_misc_useroptions));
				$user = array_merge ($user , convert_bits_to_array ($user['adminoptions'] , $vbulletin->bf_misc_adminoptions));
				cache_permissions ($user, false);

				$t = strtoupper ($user['modtitle']);
				$u = strtoupper ($user['username']);
				$groupcache["$t"]["$u"] = $user;
			}
			$db->free_result($users);

			if (sizeof ($groupcache) >= 1)
			{
				$usergroupbits = $usergroups = $moderatorbits = '';
				foreach ($groupcache AS $users)
				{
					$usergroupbits = '';
					foreach ($users AS $user)
					{
						exec_switch_bg ();
						$user = mod_process_showgroups_userinfo ($user);

						if ($vbulletin->options['enablepms'] AND $vbulletin->userinfo['permissions']['pmquota'] AND ($vbulletin->userinfo['permissions']['adminpermissions'] & $vbulletin->bf_ugp_adminpermissions['cancontrolpanel']
	 							OR ($user['receivepm'] AND $user['permissions']['pmquota']
	 							AND (!$user['receivepmbuddies'] OR can_moderate() OR strpos(" $user[buddylist] ", ' ' . $vbulletin->userinfo['userid'] . ' ') !== false))
			 			))
						{
							$show['pmlink'] = true;
						}
						else
						{
							$show['pmlink'] = false;
						}

						if ($user['showemail'] AND $vbulletin->options['displayemails'] AND (!$vbulletin->options['secureemail'] OR ($vbulletin->options['secureemail'] AND $vbulletin->options['enableemail'])) AND $vbulletin->userinfo['permissions']['genericpermissions'] & $vbulletin->bf_ugp_genericpermissions['canemailmember'] AND $vbulletin->userinfo['userid'])
						{
							$show['emaillink'] = true;
						}
						else
						{
							$show['emaillink'] = false;
						}
						$templater = vB_Template::create('showgroups_usergroupbit');
							$templater->register('bgclass', $bgclass);
							$templater->register('show', $show);
							$templater->register('showforums', $showforums);
							$templater->register('user', $user);
							$templater->register('xhtml_id', ++$xhtmlid2);
						$usergroupbits .= $templater->render();
					}
					$user['title'] = $user['modtitle'];

					$templater = vB_Template::create('showgroups_usergroup');
						$templater->register('user', $user);
						$templater->register('usergroupbits', $usergroupbits);
						$templater->register('xhtml_id', ++$xhtmlid);
					$usergroups .= $templater->render();
				}
			}
			unset ($groupcache);
		}
		else if ($do == 'codemod' OR $do == 'designmod')
		{
			$perpage = $vbulletin->input->clean_gpc('r', 'perpage', TYPE_UINT);
			$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);

			$show['mods'] = false;
			if ($do == 'codemod' AND $vbulletin->options['modsettings_coder'] != '' AND $vbulletin->options['modsettings_forumids'] != '')
			{
				$show['mods'] = true;
				$modtitle = 'modsystem_admin_code_mods';
				$forumids = $vbulletin->options['modsettings_coder'];
			}
			else if ($do == 'designmod' AND $vbulletin->options['modsettings_designer'] != '' AND $vbulletin->options['modsettings_forumids'] != '')
			{
				$show['mods'] = true;
				$modtitle = 'modsystem_admin_style_mods';
				$forumids = $vbulletin->options['modsettings_designer'];
			}

			if ($show['mods'])
			{
				require_once (DIR . '/includes/functions_databuild.php');
				fetch_phrase_group ('modsystem');

				$modtitle = $vbphrase["$modtitle"];
				$usergroupbits = $usergroups = $moderatorbits = '';

				$threadcount = $db->query_first_slave ("SELECT
					COUNT(*) AS threads
					FROM " . TABLE_PREFIX . "modsys_settings AS mods
					LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.threadid=mods.threadid)
					WHERE thread.forumid IN (0," . $forumids . ")
					AND thread.visible=1
				");
				$totalthreads = $threadcount['threads'];

				sanitize_pageresults ($totalthreads, $pagenumber, $perpage, 100, 20);

				$limitlower = ($pagenumber - 1) * $perpage + 1;
				$limitupper = ($pagenumber) * $perpage;
				$counter = 0;

				if ($limitupper > $totalthreads)
				{
					$limitupper = $totalthreads;
					if ($limitlower > $totalthreads)
					{
						$limitlower = $totalthreads - $perpage;
					}
				}
				if ($limitlower <= 0) $limitlower = 1;

				$threads = $db->query_read ("SELECT
					mods.*,thread.*
					FROM " . TABLE_PREFIX . "modsys_settings AS mods
					LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.threadid=mods.threadid)
					WHERE thread.forumid IN (0," . $forumids . ")
					AND thread.visible=1
					ORDER BY mods.mod_installcount DESC, mods.mod_nominatecount DESC, thread.title ASC
					LIMIT " . ($limitlower - 1) . ", " . $perpage
				);
				while ($thread = $db->fetch_array ($threads))
				{
					exec_switch_bg ();
					$templater = vB_Template::create('modsystem_showgroupbit');
						$templater->register('bgclass', $bgclass);
						$templater->register('show', $show);
						$templater->register('thread', $thread);
					$usergroupbits .= $templater->render();
				}

				$pagenav = construct_page_nav ($pagenumber, $perpage, $totalthreads, 'modsystem_miscactions.php?' . $vbulletin->session->vars['sessionurl'], 'group=' . $do
					. (!empty ($vbulletin->GPC['perpage']) ? "&amp;pp=$perpage" : "")
				);

				$templater = vB_Template::create('modsystem_showgroup');
					$templater->register('modtitle', $modtitle);
					$templater->register('usergroupbits', $usergroupbits);
					$templater->register('pagenav', $pagenav);
				$usergroups = $templater->render();
			}
		}
	}

	return $usergroups;
}

function modsystem_usertitle ($title_clean, $codercount, $designercount)
{
	global $vbulletin;

	unset ($title);

	$modtitle_coder = unserialize ($vbulletin->modtitle_coder);
	$modtitle_designer = unserialize ($vbulletin->modtitle_designer);
	if ($vbulletin->options['modsettings_global_modsystem'] AND count ($modtitle_coder))
	{
		foreach ($modtitle_coder AS $coder)
		{
			if ($codercount >= $coder['mincount'])
			{
				if (!$coder['maxcount'])
				{
					$title = $coder['title'];
					$tclean = $coder['title_clean'];
				}
				else
				{
					if ($codercount <= $coder['maxcount'])
					{
						$title = $coder['title'];
						$tclean = $coder['title_clean'];
					}
				}
			}
		}
	}

	if ($vbulletin->options['modsettings_global_modsystem'] AND count ($modtitle_designer))
	{
		foreach ($modtitle_designer AS $designer)
		{
			if ($designercount >= $designer['mincount'])
			{
				if (!$designer['maxcount'])
				{
					if (!$title) $title = $designer['title'];
					else $title .= '/' . $designer['title'];
					if (!$tclean) $tclean .= $designer['title_clean'];
					else $tclean .= '/' . $designer['title_clean'];
				}
				else
				{
					if ($designercount <= $designer['maxcount'])
					{
						if (!$title) $title = $designer['title'];
						else $title .= '/' . $designer['title'];
						if (!$tclean) $tclean .= $designer['title_clean'];
						else $tclean .= '/' . $designer['title_clean'];
					}
				}
			}
		}
	}

	if ($vbulletin->options['modsettings_addtitle'])
	{
		if ($tclean) $title_clean = $tclean;
	}
	else
	{
		if ($tclean) $title_clean .= '/' . $tclean;
	}

	return array ('title_clean' => $title_clean, 'title' => $title);
}

function build_mod_statistic ()
{
	global $template_hook, $vbulletin, $stylevar, $vbphrase, $session, $show;

	$x = 0;
	$limit = 5;
	$show['modstat'] = true;
	$coders = $designers = $motms = '';
	$coderc = $designerc = $codermods = $designermods = 0;
	$modstats_coder = unserialize ($vbulletin->modstats_coder);
	$modstats_designer = unserialize ($vbulletin->modstats_designer);
	$modstats_motm = unserialize ($vbulletin->modstats_motm);
	if (count ($modstats_coder))
	{
		foreach ($modstats_coder AS $coder)
		{
			$codermods = $codermods + $coder['code_mods'];
			if ($coder['released_mods'])
			{
				$coderc++;
				if ($x < $limit)
				{
					$user['musername'] = 'test';
					$coders .= '<a href="' . fetch_seo_url ('member', $coder) . '">' . fetch_musername ($coder) . '</a> (' . $coder['released_mods'] . '), ';
					$x++;
				}
			}
		}
	}
	$x = 0;
	if (count ($modstats_designer))
	{
		foreach ($modstats_designer AS $designer)
		{
			$designermods = $designermods + $designer['design_mods'];
			if ($designer['released_mods'])
			{
				$designerc++;
				if ($x < $limit)
				{
					$user['musername'] = 'test';
					$designers .= '<a href="' . fetch_seo_url ('member', $designer) . '">' . fetch_musername ($designer) . '</a> (' . $designer['released_mods'] . '), ';
					$x++;
				}
			}
		}
	}
	$x = 0;
	if (count ($modstats_motm))
	{
		foreach ($modstats_motm AS $motm)
		{
			if ($motm['motm_count'] AND $x < $limit)
			{
				$motmmods++;
				$motms .= '<a href="' . fetch_seo_url ('member', $motm) . '">' . fetch_musername ($motm) . '</a> (' . $motm['motm_count'] . '), ';
				$x++;
			}
		}
	}
	$motms = substr ($motms, 0, strlen ($motms) - 2);
	$coders = substr ($coders, 0, strlen ($coders) - 2);
	$designers = substr ($designers, 0, strlen ($designers) - 2);

	$show['topsta'] = false;
	if ($codermods OR $designermods OR $motmmods) $show['topsta'] = true;
	if ($coders != '' OR $designers != '' OR $motms != '')
	{
		$templater = vB_Template::create('modsystem_stats');
			$templater->register('motms', $motms);
			$templater->register('coders', $coders);
			$templater->register('designers', $designers);
			$templater->register('coderc', $coderc);
			$templater->register('designerc', $designerc);
			$templater->register('codermods', $codermods);
			$templater->register('designermods', $designermods);
		$template_hook['forumhome_wgo_pos5'] .= $templater->render();
	}
}

function datastore_cd_titles ($do = '')
{
	global $db, $vbulletin;

	$variable_array = array ();
	if ($do == 'coder') $tables = $db->query_read ("SELECT * FROM `" . TABLE_PREFIX . "modsys_coder` ORDER BY `mincount` ASC");
	if ($do == 'style') $tables = $db->query_read ("SELECT * FROM `" . TABLE_PREFIX . "modsys_designer` ORDER BY `mincount` ASC");

	while ($table = $db->fetch_array ($tables))
	{
		$variable_array[] = $table;
	}

	if ($do == 'coder') build_datastore ('modtitle_coder', serialize ($variable_array));
	if ($do == 'style') build_datastore ('modtitle_designer', serialize ($variable_array));
}

function update_coder_or_designer ($threadid, $addsub)
{
	global $db, $vbulletin;

	if ($vbulletin->options['modsettings_coder'] != '' OR $vbulletin->options['modsettings_designer'] != '' AND $vbulletin->options['modsettings_forumids'] != '')
	{
		$mod = $db->query_first ("SELECT
			modification.author,modification.threadid,thread.forumid
			FROM " . TABLE_PREFIX . "modsys_settings AS modification
			LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON(thread.threadid=modification.threadid)
			WHERE modification.threadid=" . intval ($threadid)
		);

		if ($vbulletin->options['modsettings_coder'])
		{
			$coder_forumids = explode (',', $vbulletin->options['modsettings_coder']);
			if (in_array ($mod['forumid'], $coder_forumids))
			{
				$update_set = ($addsub ? "codercount=codercount+'1'" : "codercount=codercount-'1'");
				$db->query ("UPDATE " . TABLE_PREFIX . "user SET " . $update_set . " WHERE userid=" . intval ($mod['author']));
				mode_create_datastore ('coder', 1);
			}
		}

		if ($vbulletin->options['modsettings_designer'])
		{
			$designer_forumids = explode (',', $vbulletin->options['modsettings_designer']);
			if (in_array ($mod['forumid'], $designer_forumids))
			{
				$update_set = ($addsub ? "designercount=designercount+'1'" : "designercount=designercount-'1'");
				$db->query ("UPDATE " . TABLE_PREFIX . "user SET " . $update_set . " WHERE userid=" . intval ($mod['author']));
				mode_create_datastore ('style', 1);
			}
		}
	}
}

function mode_create_datastore ($database = '', $sort = 1)
{
	global $db, $vbulletin;

	$doit = 0;
	if ($database != '')
	{
		switch ($database)
		{
			case 'coder':
				$datastore = 'modstats_coder';
				$sort_by = "code_mods " . ($sort ? "DESC" : "ASC") . ",user.codercount " . ($sort ? "DESC" : "ASC") . ",user.username ASC";
				$query = "SUM(IF(thread.forumid IN (0," . $vbulletin->options['modsettings_coder'] . "), 1, 0)) AS code_mods, ";
				$ids = $vbulletin->options['modsettings_coder'];
				if ($vbulletin->options['modsettings_coder']) $doit = 1;
				break;
			case 'style':
				$datastore = 'modstats_designer';
				$sort_by = "design_mods " . ($sort ? "DESC" : "ASC") . ",user.designercount " . ($sort ? "DESC" : "ASC") . ",user.username ASC";
				$query = "SUM(IF(thread.forumid IN (0," . $vbulletin->options['modsettings_designer'] . "), 1, 0)) AS design_mods, ";
				$ids = $vbulletin->options['modsettings_designer'];
				if ($vbulletin->options['modsettings_coder']) $doit = 1;
				break;
			default:
				$doit = 1;
				$datastore = 'modstats_motm';
				$sort_by = "motm_count " . ($sort ? "DESC" : "ASC") . ", user.username ASC";
				$query = "SUM(modification.motm) AS motm_count, ";
				$ids = $vbulletin->options['modsettings_forumids'];
				break;
		}

		if ($doit)
		{
			$variable_array = array ();
			$stats_code = $db->query_read ("SELECT
				thread.forumid,
				COUNT(id) AS released_mods,
				" . $query . "
				modification.author,modification.threadid,
				user.userid,user.username,user.codercount,user.designercount,user.displaygroupid,user.usergroupid
				FROM " . TABLE_PREFIX . "modsys_settings AS modification
				LEFT JOIN " . TABLE_PREFIX . "user AS user ON (user.userid=modification.author)
				LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.threadid=modification.threadid)
				WHERE thread.forumid IN (0," . $ids . ")
				GROUP BY user.userid
				ORDER BY " . $sort_by . "
			");
			while ($stat = $db->fetch_array ($stats_code))
			{
				$variable_array[] = $stat;
			}
			build_datastore ($datastore, serialize ($variable_array));
		}
	}
}

function send_mod_updates ($threadid, $info, $manual = 0)
{
	global $vbulletin, $vbphrase, $db, $old_version, $new_version;

	$manual_query = (!$manual ? "AND mun.auto_notify='1' " : "AND (mun.auto_notify='1' OR mun.manual_notify='1') ");

	// include useful functions
	require_once (DIR . '/includes/functions_newpost.php');

	$botusername = $vbulletin->userinfo['username'];
	if ($vbulletin->options['modsettings_bot_username'] AND $vbulletin->options['modsettings_bot_poster'])
	{
		$bot = $db->query_first ("SELECT userid,username FROM " . TABLE_PREFIX . "user WHERE userid=" . intval ($vbulletin->options['modsettings_bot_username']));
		if ($bot['userid'])
		{
			$botuserid   = $bot['userid'];
			$botusername = $bot['username'];
		}
	}

	$replace_six = '';
	if (!$manual) $replace_six = construct_phrase ($vbphrase['modsystem_replace_six'], $old_version, $new_version);

	$users = $db->query_read ("SELECT
		u.username,u.email,
		mun.userid,mun.auto_notify,mun.manual_notify,mun.mod_installed,mun.pm_notify
		FROM " . TABLE_PREFIX . "modsys_user_notification mun
		LEFT JOIN " . TABLE_PREFIX . "user u ON (u.userid = mun.userid)
		WHERE mun.threadid=" . intval ($threadid) . "
		" . $manual_query . "
		AND mun.mod_installed='1'
		AND mun.userid!=" . intval ($vbulletin->userinfo['userid']) . "
	");
	while ($user = $db->fetch_array ($users))
	{
		if ($user['pm_notify'])
		{
			// notify User via PM
			$pm_title   = construct_phrase ($vbphrase['modsystem_pm_title'], $info['title']);
			$pm_message = construct_phrase ($vbphrase['modsystem_pm_message'], $user['username'], $info['title'], $vbulletin->options['bburl'], $info['threadid'], $botusername, $replace_six);
			send_mod_update_pm ($user['username'], $pm_title, $pm_message, $botuserid, $botusername);
		}
		else
		{
			// notify User via Email
			$email_title   = construct_phrase ($vbphrase['modsystem_pm_title'], $info['title']);
			$email_message = construct_phrase ($vbphrase['modsystem_email_message'], $user['username'], $info['title'], $vbulletin->options['bburl'], $info['threadid'], '', $replace_six);
			vbmail ($user['email'], $email_title, $email_message);
		}
	}
}

function send_mod_update_pm ($to_username, $pm_title, $pm_message, $botuserid, $botusername)
{
	global $vbulletin, $permissions, $db;

	$errors = array(); // catches errors

	$botpermissions['adminpermissions'] = 2;

	// create the DM to do error checking and insert the new PM
	$pmdm =& datamanager_init('PM', $vbulletin, ERRTYPE_ARRAY);
	$pmdm->set('fromuserid',         $botuserid);
	$pmdm->set('fromusername',       $botusername);
	$pmdm->set('title',              $pm_title);
	$pmdm->set('message',            $pm_message);
	$pmdm->set_recipients($to_username, $botpermissions);
	$pmdm->set('dateline', TIMENOW);

	// process errors if there are any
	$errors = array_merge ($errors, $pmdm->errors);

	if (!empty ($errors))
	{
	}
	else
	{
		// everything's good!
		$pmdm->save ();
	}
}

function getVersionArray ($version)
{
	global $subVerCheck, $mainVer, $subVer, $versionBits, $i;

	if (preg_match ('/^([a-zA-Z]+ )?([0-9\.]+)\s*([a-zA-Z].*)$/', $version, $subVerCheck))
	{
		$mainVer = $subVerCheck[2];
		$subVer = strtoupper ($subVerCheck[3]);
	}
	else
	{
		$mainVer = $version;
		$subVer = "";
	}

	$versionBits = explode ('.', $mainVer);

	if (strlen ($versionBits) < 4)
	{
		for ($i = strlen ($versionBits); $i < 4; $i++)
		{
			$versionBits[$i] = 0;
		}
	}

	$versionBits[4] = 0;
	$versionBits[5] = 0;

	if ($subVer != '')
	{
		if (preg_match ('/^(A|ALPHA|B|BETA|G|GAMMA|RC|RELEASE CANDIDATE|GOLD|STABLE|FINAL|PL|PATCH LEVEL|PATCH)\s*(\d*)$/i', $subVer, $matches))
		{
			switch ($matches[1])
			{
				case "A":
				case "ALPHA":
					$versionBits[4] = -4;
					break;
				case "B":
				case "BETA":
					$versionBits[4] = -3;
					break;
				case "G":
				case "GAMMA":
					$versionBits[4] = -2;
					break;
				case "RC":
				case "RELEASE CANDIDATE":
					$versionBits[4] = -1;
					break;
				case "PL":
				case "PATCH LEVEL":
				case "PATCH":
					$versionBits[4] = 1;
					break;
				case "GOLD":
				case "STABLE":
				case "FINAL":
				default:
					$versionBits[4] = 0;
			}

			$versionBits[5] = $matches[2];
		}
	}

	for ($i = 0; $i < 6; $i++)
	{
		if (!($versionBits[$i] = intval ($versionBits[$i])))
		{
			$versionBits[$i] = 0;
		}
	}

	return $versionBits;
}

function isNewerVersion ($thisVersion, $latestVersion)
{
	global $curVersion, $newVersion, $i;

	if ($thisVersion != $latestVersion)
	{
		$curVersion = getVersionArray ($thisVersion);
		$newVersion = getVersionArray ($latestVersion);

		for ($i = 0; $i < 6; $i++)
		{
			if ($newVersion[$i] != $curVersion[$i])
			{
				return ($newVersion[$i] > $curVersion[$i]);
			}
		}
	}

	return false;
}

function prepare_motm_poll ()
{
	global $vbulletin;

	if ($vbulletin->options['modsettings_global_modsystem']
		AND $vbulletin->options['modsettings_global_motm']
		AND $vbulletin->options['modsettings_motm_forumid']
		AND $vbulletin->options['modsettings_bot_username'])
	{
		$n = date ('n', $vbulletin->options['modsettings_motm_start']);
		$y = date ('Y', $vbulletin->options['modsettings_motm_start']);

		$n++;
		if ($n > 12)
		{
			$y++;
			$n = 1;
		}

		// create the month range from where we take the nominated MODs
		$start = strtotime ('1.' . $n . '.' . $y . ' 00:00:00');
		$t = date ('t', $start);
		$end = strtotime ($t . '.' . $n . '.' . $y . ' 23:59:59');

		create_poll_thread ($vbulletin->options['modsettings_motm_forumid'], $start, $end);
	}
}

function create_poll_thread ($forumid = 0, $start, $end)
{
	global $db, $vbphrase, $vbulletin;

	$polloptions = $vbulletin->options['modsettings_max_pollmotm'];
	$error = array ();

	// compare the selected polloptions with the global forums polloptions
	if ($vbulletin->options['maxpolloptions'] > 0 AND $polloptions > $vbulletin->options['maxpolloptions']) $polloptions = $vbulletin->options['maxpolloptions'];

	// the poll normally stays open for 30 days, but we will close it now and get the MOTM winner
	$poll = $db->query_read ("SELECT * FROM " . TABLE_PREFIX . "poll WHERE motm='1'");
	while ($motm = $db->fetch_array ($poll))
	{
		$winner_threadid = $min_vote = 0;
		$votes     = explode ('|||', $motm['votes']);
		$threadids = explode ('|||', $motm['threadids']);
		foreach ($votes AS $key => $val)
		{
			if ($val AND $val > $min_vote)
			{
				$min_vote = $val;
				$nomcount = $votes["$key"];
				$winner_threadid = $threadids["$key"];
			}
		}

		if ($winner_threadid)
		{
			// close poll and set the motm-flasg to zero
			$db->query_read ("UPDATE " . TABLE_PREFIX . "poll SET motm='0',active='0' WHERE pollid=" . intval ($motm['pollid']));

			// set the MOD winner flag
			$db->query_read ("UPDATE " . TABLE_PREFIX . "modsys_settings SET motm='1' WHERE threadid=" . intval ($winner_threadid));
			$db->query_read ("INSERT INTO " . TABLE_PREFIX . "modsys_motm
				(threadid,dateline,nominatecount)
				VALUES
				(" . intval ($winner_threadid) . "," . TIMENOW . "," . intval ($nomcount) . ")
			");

			// create datastore
			if ($vbulletin->options['modsettings_use_datastore']) mode_create_datastore ('motm', 1);
		}
	}

	$counter = 1;
	$thread_polloptions = array ();

	// creating poll-options ordered by the SUM(nominated) and title
	$poll_threadids = $nom_count = '';
	$modifications = $db->query_read ("SELECT
		SUM(un.mod_nominated) AS ncount,un.threadid,ms.author,t.title
		FROM " . TABLE_PREFIX . "modsys_user_notification AS un
		LEFT JOIN " . TABLE_PREFIX . "modsys_settings as ms ON(ms.threadid=un.threadid)
		LEFT JOIN " . TABLE_PREFIX . "thread AS t ON(t.threadid=un.threadid)
		WHERE un.nominate_date BETWEEN " . intval ($start) . " AND " . intval ($end) . "
		AND ms.motm=0
		GROUP BY un.threadid
		ORDER BY ncount DESC
		LIMIT " . $polloptions
	);
	while ($mod = $db->fetch_array ($modifications))
	{
		$nomcount .= $mod['ncount'] . "|||";
		$poll_threadids .= $mod['threadid'] . "|||";
		$thread_polloptions["$counter"] = $mod['title'];
		$counter++;
	}
	$poll_threadids = substr ($poll_threadids, 0, -3);

	// get our BOT poster
	$bot = $db->query_first ("SELECT userid,username FROM " . TABLE_PREFIX . "user WHERE userid=" . intval ($vbulletin->options['modsettings_bot_username']));
	if ($bot['userid']) $botusername = $bot['username'];

	// we've got all we need, so let's reset all nominations and set the FLAG back
	if (count ($thread_polloptions) >= 2 AND $botusername != '')
	{
		// reset all User Nominations
		$db->query ("UPDATE " . TABLE_PREFIX . "modsys_settings SET mod_nominatecount='0'");
		$db->query ("UPDATE " . TABLE_PREFIX . "modsys_user_notification SET mod_nominated='0',nominate_date='0'");
	}

	// rest the FLAG
	require_once (DIR . '/includes/adminfunctions.php');
	$db->query("UPDATE " . TABLE_PREFIX . "setting SET value='0' WHERE varname='modsettings_do_motm'");
	build_options ();

	// we need at least 2 options for the poll
	if (count ($thread_polloptions) >= 2 AND $botusername != '')
	{
		$month = date ('F Y', $start);
		$foruminfo = fetch_foruminfo ($forumid);
		require_once (DIR . '/includes/functions_newpost.php');

		$rescue = $vbulletin->userinfo;
		$vbulletin->userinfo['userid'] = $bot['userid'];
		$vbulletin->userinfo['username'] = $bot['username'];
		$newpost = array (
			'title'          => construct_phrase ($vbphrase['modsystem_poll_title'], $month),
			'iconid'         => 0,
			'prefixid'       => 0,
			'signature'      => '',
			'preview'        => 0,
			'disablesmilies' => 0,
			'username'       => $botusername,
			'postpoll'       => true,
			'polloptions'    => $polloptions,
			'poststarttime'  => TIMENOW,
			'stickunstick'   => 0,
			'openclose'      => 1,
			'message'        => construct_phrase ($vbphrase['modsystem_poll_posting'], $vbulletin->options['bbtitle'])
		);

		build_new_post ('thread', $foruminfo, array (), array (), $newpost, $errors);

		$vbulletin->userinfo = $rescue;
		unset ($rescue);

		if (sizeof ($errors) > 0)
		{
			// errors
		}
		else
		{
			$threadinfo = fetch_threadinfo ($newpost['threadid']);

			// Add the poll
			$counter = 0;
			$poll =& datamanager_init('Poll', $vbulletin, ERRTYPE_STANDARD);
			while ($counter++ < $polloptions)
			{
				if ($thread_polloptions["$counter"] != '')
				{
					$poll->set_option($thread_polloptions["$counter"]);
				}
			}
			$poll->set('question',	construct_phrase ($vbphrase['modsystem_poll_question'], $month));
			$poll->set('dateline',	TIMENOW);
			$poll->set('active',	  '1');
			$poll->set('timeout',   30);
			$poll->set('multiple',  0);
			$poll->set('public',    0);

			$pollid = $poll->save();
			//end create new poll

			if ($pollid)
			{
				$db->query("UPDATE " . TABLE_PREFIX . "poll SET motm='1' WHERE pollid=" . intval ($pollid));
				$db->query("UPDATE " . TABLE_PREFIX . "poll SET threadids='" . $db->escape_string ($poll_threadids) . "' WHERE pollid=" . intval ($pollid));

				// update thread
				$threadman =& datamanager_init('Thread', $vbulletin, ERRTYPE_STANDARD, 'threadpost');
				$threadman->set_existing ($threadinfo);
				$threadman->set('pollid', $pollid);
				$threadman->save();
			}
		}
	}
	else
	{
		// not enough MODs this month
		$month = date ('F Y', $start);
		$foruminfo = fetch_foruminfo ($forumid);
		require_once (DIR . '/includes/functions_newpost.php');

		$rescue = $vbulletin->userinfo;
		$vbulletin->userinfo['userid'] = $bot['userid'];
		$vbulletin->userinfo['username'] = $bot['username'];
		$newpost = array (
			'title'          => construct_phrase ($vbphrase['modsystem_poll_title'], $month),
			'iconid'         => 0,
			'prefixid'       => 0,
			'signature'      => '',
			'preview'        => 0,
			'disablesmilies' => 0,
			'username'       => $botusername,
			'postpoll'       => true,
			'polloptions'    => $polloptions,
			'poststarttime'  => TIMENOW,
			'stickunstick'   => 0,
			'openclose'      => 1,
			'message'        => construct_phrase ($vbphrase['modsystem_poll_no_posting'], $vbulletin->options['bbtitle'])
		);

		build_new_post ('thread', $foruminfo, array (), array (), $newpost, $errors);

		$vbulletin->userinfo = $rescue;
		unset ($rescue);
	}
}
?>