<?php




class amefy
{
	
	public $hooks = array(
		1 	=> array('hook' => 'profile_sidebar_first', 'create' => 'block'),
		2 	=> array('hook' => 'profile_sidebar_stats', 'create' => 'block'),
		3 	=> array('hook' => 'profile_sidebar_friends', 'create' => 'block'),
		4 	=> array('hook' => 'profile_sidebar_albums', 'create' => 'block'),
		5 	=> array('hook' => 'profile_sidebar_groups', 'create' => 'block'),
		6 	=> array('hook' => 'profile_sidebar_last', 'create' => 'block'),
		10 	=> array('hook' => 'profile_left_first', 'create' => 'tab'),
		11 	=> array('hook' => 'profile_left_last', 'create' => 'tab'),
	);
	
	protected $_blocks = array();
	protected $_registry;
	protected $_info = -1;
	protected $_parser;
	protected $_userfields;
	protected $_tabs = array();
	
	public $template_hook;
	public $blocklist;
	public $data = array();
	
	function amefy(&$registry)
	{
		
		$this->_registry = $registry;
		
	}
	
	function set_userfields(&$userfields)
	{
		
		$this->_userfields = $userfields;
		
	}
	
	protected function &fetch_info($refresh = false)
	{
		
		$refresh == true ? $this->_info = -1 : false;
		
		if ($this->_info == -1)
		{
			
			$info = array();
			
			$results = $this->_registry->db->query_read_slave("SELECT * FROM " . TABLE_PREFIX . "amefy ORDER BY position, ordinal, title");
			
			while ($result = $this->_registry->db->fetch_array($results))
			{
				
				$info["$result[position]"]["$result[id]"] = array(
																		'typeid' 	=> $result['typeid'],
																		'fields' 	=> explode(",", $result['fieldids']),
																		'title'		=> $result['title'],
																		'width'		=> $result['width'],
																		'height'	=> $result['height']
																);
				
			}
			
			if (count($info))
			{
				
				$this->_info = $info;
				
			}
			
		}
		
		return $this->_info;
		
	}
	
	protected function parse($text)
	{
		
		if (!isset($this->_parser))
		{
			
			require_once(DIR . "/includes/class_bbcode.php");
			$this->_parser = new vB_BbCodeParser($this->_registry, fetch_tag_list(), false);			
			
		}
		
		return $this->_parser->parse_bbcode($text, false, true, false);
		
	}
	
	public function create_block($data)
	{
	
	    $template = vB_Template::create('ame_member_block');
	    $template->register('block_data', $data);				
		$this->template_hook[$this->hooks[$data['position']]['hook']] .= $template->render();
		
	}
	
	public function create_tab($data)
	{
		
		$this->_tabs["$data[tag]"] = $data['position'];
		$this->template_hook[$this->hooks[$data['position']]['hook']] .= "<dd><a id=\"{$data[tag]}-tab\" class=\"wider\" href=\"#{$data[tag]}\" onclick=\"return tabViewPicker(this);\">{$data[title]}</a></dd>";

		$this->blocklist[$data['tag']] = array(
			'class'		=> 'AME_ProfileBlock',
			'title'		=> $data['title'],
			'options'	=> $data,
		);		
		
	}
	
	function append_tabs(&$blocks)
	{
		
		if (count($this->_tabs))
		{
			
			foreach($this->_tabs as $tag => $position)
			{
				
				$this->template_hook["profile_left"] .= $blocks["$tag"];
				
			}
			
		}
		
	}	
	
	public function parse_data()
	{
		
		if (count($this->data))
		{
			
			foreach($this->data as $data)
			{
				
				$call = "create_" . $this->hooks["$data[position]"]['create'];
				$this->$call($data);
				
			}
			
		}
		
	}
	
	public function domember()
	{
		
		if ($this->build_data())
		{
			
			$this->parse_data();
			
		}
		
	}
	
	public function build_data()
	{

		$items = $this->fetch_info();
		
		if ($items == -1)
		{
			
			return false;
			
		}
		
		if (count($items))
		{
			
			foreach($items as $position => $item)
			{

				foreach($item as $id => $info)
				{
					
					$toparse = "";
					
					if (count($info['fields']))
					{
						
						if (count($info['fields'] > 1))
						{
							
							if ($info['typeid'] == 1)
							{
								//randomly select afield to parse
								$rnd 		= rand(1, count($info['fields'])) - 1;
								$toparse 	= $this->_userfields["field{$info[fields][$rnd]}"];
															
							}
							else 
							{
								
								foreach($info['fields'] as $value)
								{
									
									$toparse .= ($toparse ? "\n" : "") . $this->_userfields["field$value"];
									
								}
								
							}
							
						}
						else 
						{
							
							$toparse 	= $this->_userfields["field{$info[fields][0]}"];
							
						}

						$this->data[] = array(
							
							'tag'		=> "ame_{$position}_{$id}",
							'title'		=> $info['title'],
							'width'		=> $info['width'],
							'height'	=> $info['height'],
							'position'	=> $position,
							'parsed'	=> $this->parse($toparse)
						
						);
											
					}
						
				}
				
			}
			
		}
		
		return (count($this->data) > 0);
		
	}

	public function verify(&$dm)
	{
		
		$items = $this->fetch_info();
		
		if (count($items))
		{
			
			require_once(DIR . "/includes/functions_video.php");
			
			foreach($items as $position => $item)
			{

				foreach ($item as $key => $info)
				{
					
					foreach ($info['fields'] as $fieldid)
					{
							
						if ($dm->setfields["field$fieldid"])
						{
						
							$value = strip_bbcode($dm->existing["field$fieldid"]);
							
							if (trim($value))
							{
								
								$value = "[url]" . $value . "[/url]";
								$value = parse_video_bbcode($value);
								$dm->userfield["field$fieldid"] = htmlspecialchars_uni($value);					
								
							}		
							
							
						}
						
					}
					
				}
				
			}			
			
		}
		
	}	
	
}


if (class_exists("vB_ProfileBlock"))
{
	
	class vB_ProfileBlock_AME_ProfileBlock extends vB_ProfileBlock
	{
	
		var $template_name = 'ame_member_block';
		var $nowrap = true;
		
		function block_is_enabled()
		{
			
			return true;
			
		}
	
		function confirm_empty_wrap()
		{
			
			return false;
			
		}
	
		function confirm_display()
		{
	
			return true;
	
		}
	
		function prepare_output($id = '', $options = array())
		{
		
			$this->block_data = $options;

		}
		
	}
	
}

?>