<?php
// ####################### SET PHP ENVIRONMENT ###########################

error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################

define('NO_REGISTER_GLOBALS', 1);
define('THIS_SCRIPT', 'tab_blog'); // change this depending on your filename

// ################### PRE-CACHE TEMPLATES AND DATA ######################

// get special phrase groups
$phrasegroups = array();

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array();

// pre-cache templates used by specific actions
$actiontemplates = array();

// ######################### REQUIRE BACK-END ############################

require_once('./global.php');
require_once('./includes/functions_forumdisplay.php');

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################


$tab_options['title_maxchars'] = '50';

echo '<table border="0" cellpadding="6" cellspacing="1" class="tborder" width=100%>
		<tr> 
			<td class="thead" width="50%">Blog Title</td>
			<td class="thead" width="10%" align="center" style="white-space: nowrap">Date</td>
			<td class="thead" width="20%" align="center" style="white-space: nowrap">Blogger</td>
			<td class="thead" width="2%">Views</td>
		</tr>';

$latestblogs = $db->query(" 
    SELECT blog.blogid, blog.firstblogtextid, blog.title, blog.username, blog.dateline, blog.userid, blog.views, blog_text.pagetext as preview
    FROM " . TABLE_PREFIX . "blog AS blog
    LEFT JOIN " . TABLE_PREFIX . "blog_text AS blog_text ON (blog_text.blogid = blog.blogid)
    WHERE blog.state='visible' and blog.pending=0
    GROUP BY blog.blogid 
    ORDER BY blog.dateline DESC 
    LIMIT 10 
"); 

while ($showblogs=$db->fetch_array($latestblogs)) 
{ 
		
	// Trim title
   		if (strlen($showblogs['title']) > $tab_options['title_maxchars'] AND $tab_options['title_maxchars'])
   		{
	   		$showblogs['title'] = fetch_trimmed_title($showblogs['title'], $tab_options['title_maxchars']);
   		}

	// Process array
		$showblogs = process_thread_array(
				$showblogs,
				$mod_options['portal_threads_showicon']
			);

	$blog_userid = $showblogs['userid'];
    $blogid = $showblogs['blogid'];
    $blog_title = $showblogs['title'];
    $blog_views = $showblogs['views'];
    $blog_username = $showblogs['username'];
    $blog_dateline = vbdate($vbulletin->options['dateformat'], $showblogs['dateline']);
    $blog_preview = $showblogs['preview'];

	echo '<tr>
			<td class="alt1 smallfont"><a href="blog.php?b=' . $blogid . '"><b>' . $blog_title . '</b></a><br />' . $blog_preview . '<span class=smallfont>&nbsp;<a href="blog.php?b=' . $blogid . '"><b>more</b></a></span></td>
			<td align="center" class="alt2"><span class=smallfont>' . $blog_dateline . '</span></td>
			<td align="center" class="alt1"><span class=smallfont><a href="blog.php?u=' . $blog_userid . '">' . $blog_username . '</span></a></td>
			<td align="center" class="alt2"><span class=smallfont>' . $blog_views . '</span></td>
		  </tr>';

}

echo '</table>';

$db->free_result($latestblogs);
unset($showblogs);

?>